2014-03-03  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 12.1.0 Released.

2014-03-01  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 12.1.0-rc3 Released.

	* chan_sip: Fix crash in ast_channel_hangupcause_set().

	  Fix crash in ast_channel_hangupcause_set() because p->owner not
	  checked before calling.  Regression introduced by the fix for
	  ASTERISK-22621.

	  (closes issue ASTERISK-23135)
	  Reported by: OK

	  (issue ASTERISK-23323)
	  Reported by: Walter Doekes

2013-02-27  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 12.1.0-rc2 Released.

	* res_rtp_asterisk: Fix checklist creating problems in ICE sessions
	  
	  Prior to this patch, local candidate lists including SRFLX would
	  fail to start properly when building ICE candidate check lists. This
	  patch fixes that problem by making sure that each SRFLX candidate is
	  associated with the proper base address so that the check list can
	  create matches properly.

	  This patch was written by jcolp. The issue will be left open to await
	  testing by the issue participants.       

	  (issue ASTERISK-23213)
	  Reported by: Andrea Suisani
	  Review: https://reviewboard.asterisk.org/r/3256/

	* res_fax: Warn that minrate=2400 is not valid for V.27 instead of
	  failing load.

	  Change minrate from 2400 to 4800 on config reload in response to
	  changes from ASTERISK-22790 only.  Any config with minrate of
	  2400 that would fail before r405693 will still fail.

	  Comment out many settings in res_fax.conf.sample. The defaults are
	  set in res_fax.c, so setting the same value in sample config does
	  nothing but make the sample config more fragile.

	  (closes issue ASTERISK-23231)
	  Reported by: David Brillert
	  Review: https://reviewboard.asterisk.org/r/3261/

	* main: Initialize dialplan providing core components prior to module
	  pre-load

	  It is possible to pre-load pbx_config. As a result, pbx_config -
	  which will load and parse the dialplan - will attempt to use various
	  dialplan components, such as device state providers and presence
	  state providers, prior to them being initialized by the core. This
	  would lead to a crash, as the components had not created their Stasis
	  cache entries.

	  This patch moves a number of core component initializations before
	  the module pre-load. This guarantees that if someone does pre-load
	  pbx_config - or other pbx modules - that the Stasis caches for the
	  various core components are created.

	  (closes issue ASTERISK-23320)
	  Reported by: xrobau

	  (closes issue ASTERISK-23265)
	  Reported by: Andrew Nagy
	  Tested by: Andrew Nagy, Rusty Newton

	* ari/resource_channels: Add channel variables earlier in the creation
	  process

	  This patch tweaks the behaviour of POST /channels with channel
	  variables such that the variables are passed into the pbx.c routines
	  that perform the origination. This allows the variables to be
	  assigned to the newly	created	channels immediately upon their
	  construction, as opposed to be assigned after the originate has
	  completed.

	  The upshot of this is that the variables are available on the
	  channels if they execute in the dialplan, as opposed to only being
	  available once the channels are answered.

	* security_events: Fix assertion failure in dev-mode on optional IE
	  parsing

	  When formatting an optional IE, the value is, of course, optional. As
	  such, it is entirely appropriate for ast_json_object_get to return
	  NULL. If that occurs, we now simply skip the IE that was requested,
	  as it was not provided by the entity that raised the event.

	  Thanks to George Joseph (gtjoseph) for catching this and reporting it
	  in #asterisk-dev

	* funcs/func_cdr: Handle empty time values when extracting parsed
	  values

	  When extracting timestamps that are parsed, time stamp values that
	  are not set (time values of 0.000000) should not actually result in
	  a parsed string. The value should be skipped, and the result of the
	  CDR function should be an empty string.

	  Prior to this patch, the result was fed to the time formatting, which
	  would result in an output of a date/time in 1969.

	* security_events: Fix error caused by DTD validation error

	  The appdocsxml.dtd specifies that a "required" attribute in a
	  parameter may have a value of yes, no, true, or false. On some
	  systems, specifying "False" instead of "false" would cause a
	  validation error. This patch fixes the casing to explicitly match
	  the DTD.

2013-02-06  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 12.1.0-rc1 Released.

2014-02-06 20:06 +0000 [r407589]  Matthew Jordan <mjordan@digium.com>

	* main/security_events.c, UPGRADE.txt, CHANGES: security_events:
	  Add AMI documentation; output optional fields This patch adds
	  documentation for the Security Events that are emited over AMI.
	  It also notes these events in the UPGRADE/CHANGES file.

2014-02-06 19:57 +0000 [r407587]  Rusty Newton <rnewton@digium.com>

	* configs/pjsip.conf.sample: configs/pjsip.conf.sample:
	  Configuration section naming in pjsip.conf.sample needs a little
	  clarification There is a bit of nuance to how you name things in
	  pjsip.conf. This is a documentation patch to at least clear it up
	  a little for users. Review:
	  https://reviewboard.asterisk.org/r/3180/

2014-02-06 17:54 +0000 [r407572]  Kevin Harwell <kharwell@digium.com>

	* contrib/ast-db-manage/config/versions/2fc7930b41b3_add_pjsip_endpoint_options_for_12_1.py:
	  pjsip realtime: already created enum failure for postgresql If an
	  enum had been previously created the alembic script would attempt
	  to re-create it and an error would be generated while running
	  migrations for a postgresql server. The work around for this is
	  to use the ENUM object type for postgres as opposed to the
	  generic enum type used by sqlalchemy. Using this type in the
	  script seems to work properly for both postgres and mysql.

2014-02-06 17:06 +0000 [r407568]  Richard Mudgett <rmudgett@digium.com>

	* res/res_pjsip_logger.c,
	  res/res_pjsip/include/res_pjsip_private.h,
	  res/res_pjsip/pjsip_options.c, res/res_pjsip/config_transport.c,
	  include/asterisk/res_pjsip.h, res/res_pjsip/config_global.c,
	  res/res_pjsip/config_auth.c, res/res_pjsip/location.c,
	  res/res_pjsip_outbound_registration.c,
	  res/res_pjsip_endpoint_identifier_ip.c,
	  include/asterisk/res_pjsip_cli.h, res/res_pjsip/pjsip_cli.c,
	  res/res_pjsip/pjsip_configuration.c,
	  res/res_pjsip/config_domain_aliases.c: res_pjsip: Updates and
	  adds more PJSIP CLI commands. * Adds identify, transport, and
	  registration support to the PJSIP CLI. * Creates three additional
	  callbacks, one for an iterator, one for a comparator, and one for
	  a container. This eliminates the link dependency from higher
	  level modules to lower level ones. * Eliminates duplicate sorting
	  in PJSIP CLI commands. * Cleans up PJSIP CLI output formatting. *
	  Pushes CLI command registration down to the implementing source
	  file. * Adds several ast_sip_destroy_sorcery functions to
	  complement existing ast_sip_sorcery_initialize functions. The
	  destroy functions unregister PJSIP CLI commands and PJSIP CLI
	  formatters. Reported by: George Joseph Review:
	  https://reviewboard.asterisk.org/r/3104/

2014-02-06 16:53 +0000 [r407567]  Mark Michelson <mmichelson@digium.com>

	* contrib/ast-db-manage/config/versions/2fc7930b41b3_add_pjsip_endpoint_options_for_12_1.py:
	  Fix alembic script to work properly in offline mode. When run in
	  offline mode, this would attempt to check the database for the
	  presence of a type it was going to try to create. I now check the
	  context to see if we're running in offline mode and change a
	  parameter accordingly.

2014-02-05 23:03 +0000 [r407513]  Rusty Newton <rnewton@digium.com>

	* /, formats/format_wav.c: formats/format_wav: enhancing log
	  message "Not a wav file" to be clear on what is supported
	  Modifying the log message to be more specific as to what is
	  supported. Specifically it seems format_wav supports only PCM
	  encoded versions with a lower-case '.wav' extension. (closes
	  issues ASTERISK-22310) Reported by: Jim Credland Review:
	  https://reviewboard.asterisk.org/r/3188/ ........ Merged
	  revisions 407511 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 407512 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-02-05 20:55 +0000 [r407461]  Jonathan Rose <jrose@digium.com>

	* CHANGES: CHANGES: Improved description of Name/Creator changes to
	  bridge ARI, adds AMI The changes log was written with language
	  that was a little too internal Asterisk specific, so it's been
	  changed to be more in the frame of reference of an ARI user.
	  Also, previously the AMI event changes were omitted from the
	  change log as well as the ability to include a bridge name in the
	  ARI post bridges command.

2014-02-05 20:43 +0000 [r407458]  Kinsey Moore <kmoore@digium.com>

	* main/logger.c, /: Logger: Fix handling of absolute paths This
	  fixes path handling for log files so that an extra / is not
	  appended to the file path when the path is absolute (begins with
	  /). This would previously result in different but functionally
	  equivalent paths in the output of 'logger show channels'.
	  ........ Merged revisions 407455 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 407456 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-02-05 19:41 +0000 [r407442]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip/config_global.c: res_pjsip: When no global type the
	  debug option defaults to "yes" If the global section was not
	  specified in pjsip.conf then the configuration object does not
	  exist in sorcery so when retrieving "debug" option it would
	  return NULL. Then the NULL result was passed to ast_false utils
	  function which would return false because it wasn't set to some
	  representation of false, thus enabling sip debug logging. Made it
	  so if the global config object does not exist then it will return
	  a default of "no" for sip debugging. (issue ASTERISK-23038)
	  Reported by: Rusty Newton

2014-02-05 17:27 +0000 [r407423]  Kinsey Moore <kmoore@digium.com>

	* UPGRADE.txt: UPGRADE: Note change in behavior for device state
	  subscriptions

2014-02-05 17:12 +0000 [r407419]  Jonathan Rose <jrose@digium.com>

	* CHANGES: CHANGES: Update changes log to include new bridge fields
	  added in r404042

2014-02-05 14:22 +0000 [r407389-407402]  Matthew Jordan <mjordan@digium.com>

	* UPGRADE.txt, rest-api/api-docs/channels.json,
	  rest-api/api-docs/sounds.json, rest-api/resources.json, CHANGES,
	  include/asterisk/manager.h, rest-api/api-docs/bridges.json,
	  rest-api/api-docs/recordings.json,
	  rest-api/api-docs/deviceStates.json,
	  rest-api/api-docs/endpoints.json,
	  rest-api/api-docs/mailboxes.json, rest-api/api-docs/events.json,
	  rest-api/api-docs/asterisk.json,
	  rest-api/api-docs/applications.json,
	  rest-api/api-docs/playbacks.json: ARI/AMI: Update versions;
	  update UPGRADE/CHANGES notes for 12.1.0 changes Due to backwards
	  compatible changes made to AMI/ARI, the version needs to be
	  bumped to 1.1.0/2.1.0, respectively.

	* rest-api-templates/api.wiki.mustache,
	  rest-api-templates/swagger_model.py: api.wiki.mustache: Update
	  wiki template to support body parameters This patch updates the
	  api.wiki.mustache template and the swagger_model python script to
	  understand if an operation has a body parameter. If an operation
	  does have a body parameter, it will now be displayed in the
	  corresponding wiki entry.

2014-02-04 20:08 +0000 [r407274-407339]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/devicestate.h, /, main/devicestate.c:
	  devicestate: Make ast_devstate_changed_literal() return value and
	  doxygen consistent. Nothing actually cares about the value
	  anyway. (closes issue ASTERISK-23178) Reported by: Jonathan Rose
	  ........ Merged revisions 407337 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 407338 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_pjsip/pjsip_configuration.c: res_pjsip: Fix assertion for
	  pjsip.conf authorization list options. (closes issue
	  ASTERISK-23168) Reported by: George Joseph Review:
	  https://reviewboard.asterisk.org/r/3143/

	* configs/sip.conf.sample, main/tcptls.c, /: tcptls.c: Made TLS
	  handle a certificate chain file. Thanks to Guillaume Martres for
	  doing the necessary research to validate the change. (closes
	  issue ASTERISK-17727) Reported by: LN Patches:
	  use_certificate_chain.patch (license #5864) patch uploaded by st
	  documente_certificate_chain.patch (license #6576) patch uploaded
	  by Guillaume Martres ........ Merged revisions 407272 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 407273 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-02-04 16:54 +0000 [r407259]  Matthew Jordan <mjordan@digium.com>

	* funcs/func_cdr.c: funcs/func_cdr: Fix non-epoch timestamps broken
	  by improper char array deref Thanks to snuffy for pointing this
	  issue out and fixing it. (closes issue ASTERISK-23250) Reported
	  by: snuffy patches: func_cdr-fix.diff uploaded by snuffy (License
	  5024)

2014-02-04 02:21 +0000 [r407213]  Joshua Colp <jcolp@digium.com>

	* /, res/res_clialiases.c: res_clialiases: Fix crash when reloading
	  and re-aliasing an alias that is in use. The code assumed that
	  unregistering the alias would always succeed while in practice
	  this is not actually true. A common case is the "reload" command
	  itself. If the cli_aliases.conf configuration file was changed
	  and reload executed the command would fail to unregister and
	  ultimately point to freed memory. The reload process now checks
	  whether unregistering succeeded or not and if not the old CLI
	  alias is retained. (closes issue ASTERISK-19773) Reported by:
	  Joel Vandal (closes issue ASTERISK-22757) Reported by: Gareth
	  Blades ........ Merged revisions 407205 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 407210 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-02-04 02:04 +0000 [r407197]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Skinny - Fix deadlock when pickup of no
	  call. Locking issues in skinny when picking up a call that
	  doesn't exist. Cleaned up sub locking by fully removing and using
	  the chan lock instead. Also changed ast_call_pickup to check
	  whether chan was masq'd. (closes issue ASTERISK-23249) Reported
	  by: wedhorn Tested by: snuffy, myself Patches:
	  skinny-locking01.diff uploaded by wedhorn (license 5019)

2014-02-03 01:14 +0000 [r407166]  Matthew Jordan <mjordan@digium.com>

	* main/cdr.c: cdrs: Check for applications to lock onto during dial
	  begin handling This patch brings CDR processing further in line
	  with r407085. During some dial operations, the application would
	  not be locked to the Dial application and would instead continue
	  to show the previously known application. In particular, this
	  would occur when a Parked call would time out. This was due to a
	  previous snapshot already locking the application to Park -
	  processing this in a Dial Begin allows the Dial application to
	  reassert its rightful place. (CDRs. Ugh.) But hooray for the
	  Parked Call tests for catching this in the Asterisk Test Suite.

2014-02-01 16:23 +0000 [r407153]  Joshua Colp <jcolp@digium.com>

	* res/ari/ari_model_validators.c, res/res_stasis.c,
	  main/stasis_bridges.c, res/ari/ari_model_validators.h,
	  rest-api/api-docs/events.json, res/stasis/app.c: res_stasis:
	  Enable transfers and provide events when they occur. This change
	  enables transfers within ARI created bridges and adds events for
	  when they occur. Unlike other events these will be received if
	  *any* subscribed object is involved in the transfer. (closes
	  issue ASTERISK-22984) Reported by: David M. Lee Review:
	  https://reviewboard.asterisk.org/r/3120/

2014-02-01 00:24 +0000 [r407104]  coreyfarrell <coreyfarrell@localhost>:

	* /, apps/app_stack.c: app_stack: protect against missing
	  parameters to STACK_PEEK and LOCAL_PEEK STACK_PEEK requires 2
	  parameters and LOCAL_PEEK requires 1 parameter. This protects
	  against situations where those parameters are blank or missing by
	  logging an error and returning. (closes issue ASTERISK-23220)
	  Reported by: James Sharp ........ Merged revisions 407100 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 407103 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-31 23:40 +0000 [r407082-407084]  Matthew Jordan <mjordan@digium.com>

	* main/manager_channels.c, apps/app_dial.c, main/cdr.c, main/pbx.c,
	  main/bridge_after.c, UPGRADE.txt: CDRs: fix a variety of dial
	  status problems, h/hangup handler creating CDRs This patch fixes
	  a number of small-ish problems that were noticed when witnessing
	  the records that the FreePBX dialplan produces: (1) Mid-call
	  events (as well as privacy options) have the ability to change
	  the overall state of the Dial operation after the called party
	  answers. This means that publishing the DialEnd event when the
	  called party is premature; we have to wait for the execution of
	  these subroutines to complete before we can signal the overall
	  status of the DialEnd. This patch moves that publication and adds
	  handlers for the mid-call events. (2) The AST_FLAG_OUTGOING
	  channel flag is cleared if an after bridge goto datastore is
	  detected. This flag was preventing CDRs from being recorded for
	  all outbound channels that had a 'continue' option enabled on
	  them by the Dial application. (3) The CDR engine now locks the
	  'Dial' application as being the CDR application if it detects
	  that the current CDR has entered that app. This is similar to the
	  logic that is done for Parking. In general, if we entered into
	  Dial, then we want that CDR to record the application as such -
	  this prevents pre-dial handlers, mid-call handlers, and other
	  shenaniganry from changing the application value. (4) The CDR
	  engine now checks for the AST_SOFTHANGUP_HANGUP_EXEC in more
	  places to determine if the channel is in hangup logic or dead. In
	  either case, we don't want to record changes in the channel. (5)
	  The default option for "endbeforehexten" has been changed to
	  "yes". In general, you don't want to see CDRs in the 'h' exten or
	  in hangup logic. Since the semantics of that option changed in
	  12, it made sense to update the default value as well. (6)
	  Finally, because we now have the ability to synchronize on the
	  messages published to the CDR topic, on shutdown the CDR engine
	  will now synchronize to the messages currently in flight. This
	  helps to ensure that all in-flight CDRs are written before
	  shutting down. (closes issue ASTERISK-23164) Reported by: Matt
	  Jordan Review: https://reviewboard.asterisk.org/r/3154

	* apps/app_dial.c, /: app_dial: Allow macro/gosub pre-bridge
	  execution to occur on priorities The parsing for the destination
	  of the macro/gosub uses the '^' character to separate out
	  context, extension, and priority. However, the logic for the
	  macro/gosub execution was written such that it would only do the
	  actual macro/gosub jump if a '^' character existed. This doesn't
	  apply when the macro/gosub jump occurs in a priority/priority
	  label. This patch changes the logic so that the parsing still
	  occurs, but the jump will occur even for priorities/priority
	  labels. (issue ASTERISK-23164) Review:
	  https://reviewboard.asterisk.org/r/3154 ........ Merged revisions
	  407041 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 407074 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-31 23:14 +0000 [r407034-407036]  Kevin Harwell <kharwell@digium.com>

	* contrib/ast-db-manage/config/versions/21e526ad3040_add_pjsip_debug_option.py
	  (added), configs/pjsip.conf.sample, UPGRADE.txt,
	  res/res_pjsip_logger.c, CHANGES, res/res_pjsip.c,
	  include/asterisk/res_pjsip.h, res/res_pjsip/config_global.c:
	  res_pjsip: Config option to enable PJSIP logger at load time.
	  Added a "debug" configuration option for res_pjsip that when set
	  to "yes" enables SIP messages to be logged. It is specified under
	  the "system" type. Also added an alembic script to add the option
	  to realtime. (closes issue ASTERISK-23038) Reported by: Rusty
	  Newton Review: https://reviewboard.asterisk.org/r/3148/

	* res/res_pjsip_exten_state.c: res_pjsip_exten_state: Exporting
	  global symbols caused load order issues Removed the exportation
	  of global symbols from the module as it is no longer needed and
	  it could potentially cause load problems as on some systems it
	  would try to load before res_pjsip_pubsub

2014-01-31 22:38 +0000 [r407031]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/res_pjsip_presence_xml.h (added): Add file that
	  apparently got missed in the merge.

2014-01-31 22:17 +0000 [r407019]  Kevin Harwell <kharwell@digium.com>

	* UPGRADE.txt,
	  contrib/ast-db-manage/config/versions/581a4264e537_adding_extensions.py,
	  contrib/ast-db-manage/config/versions/2fc7930b41b3_add_pjsip_endpoint_options_for_12_1.py:
	  alembic: script modifications due to errors A couple of the
	  scripts had errors that would not allow a full migration to take
	  place. The extensions table needed to make its 'id' column a
	  primary key in order to work with mysql. The other script
	  ...add_endpoints... was missing tables that it was trying to add
	  columns to. Added the primary key on id for extensions and added
	  the tables in for the missing pjsip configuration options. While
	  it is not ideal to modify already released scripts this was a
	  case where it had to be done due to errors in the script and
	  lacking a better alternative. Review:
	  https://reviewboard.asterisk.org/r/3167/

2014-01-31 22:11 +0000 [r407016]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip_xpidf_body_generator.c (added),
	  res/res_pjsip_mwi_body_generator.c (added),
	  res/res_pjsip_pubsub.c, res/res_pjsip_pidf.c (removed),
	  res/res_pjsip_pidf_eyebeam_body_supplement.c (added),
	  res/res_pjsip_exten_state.c, res/res_pjsip/presence_xml.c
	  (added), include/asterisk/res_pjsip_pubsub.h,
	  res/res_pjsip_pidf_body_generator.c (added),
	  include/asterisk/res_pjsip_exten_state.h (removed),
	  res/res_pjsip_pubsub.exports.in,
	  include/asterisk/res_pjsip_body_generator_types.h (added),
	  res/res_pjsip_mwi.c: Decouple subscription handling from
	  NOTIFY/PUBLISH body generation. When the PJSIP pubsub framework
	  was created, subscription handlers were required to state what
	  event they handled along with what body types they knew how to
	  generate. While this serves well when implementing a base RFC, it
	  has problems when trying to extend the body to support
	  non-standard or proprietary body elements. The code also was
	  NOTIFY-specific, meaning that when the time comes that we start
	  writing code to send out PUBLISH requests with MWI or presence
	  bodies, we would likely find ourselves duplicating code that had
	  previously been written. This changeset introduces the concept of
	  body generators and body supplements. A body generator is
	  responsible for allocating a native structure for a given body
	  type, providing the primary body content, converting the native
	  structure to a string, and deallocating resources. A body
	  supplement takes the primary body content (the native structure,
	  not a string) generated by the body generator and adds
	  nonstandard elements to the body. With these elements living in
	  their own module, it becomes easy to extend our support for body
	  types and to re-use resources when sending a PUBLISH request.
	  Body generators and body supplements register themselves with the
	  pubsub core, similar to how subscription and publish handlers had
	  done. Now, subscription handlers do not need to know what type of
	  body content they generate, but they still need to inform the
	  pubsub core about what the default body type for a given event
	  package is. The pubsub core keeps track of what body generators
	  and body supplements have been registered. When a SUBSCRIBE
	  arrives, the pubsub core will check that there is a subscription
	  handler for the event in the SUBSCRIBE, then it will check that
	  there is a body generator that can provide the content specified
	  in the Accept header(s). Because of the nature of body generators
	  and supplements, it means res_pjsip_exten_state and res_pjsip_mwi
	  have been completely gutted. They no longer worry about body
	  types, instead calling ast_sip_pubsub_generate_body_content()
	  when they need to generate a NOTIFY body. Review:
	  https://reviewboard.asterisk.org/r/3150

2014-01-31 22:05 +0000 [r407014]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_mwi.c: res_pjsip_mwi: Subscribe fails when missing
	  aor name When subscribing to MWI (res_pjsip_mwi) and the sip uri
	  did not contain a name (ex: sip:<ip address>) then the
	  subscription would fail since it would be unable to locate an
	  associated aor. This patch makes it so that when a subscribe
	  comes with no aor name then it will subscribe to all aors on the
	  located endpoint. (closes issue ASTERISK-23072) Reported by: Bob
	  M Review: https://reviewboard.asterisk.org/r/3164/

2014-01-31 15:01 +0000 [r407000]  Kinsey Moore <kmoore@digium.com>

	* res/res_pjsip_nat.c: PJSIP: Fix address for ACK in NAT situations
	  In NAT scenarios where a call is placed to a Grandstream phone,
	  res_pjsip will sometimes send the ACK to a 200 OK to the private
	  address of the device behind the NAT instead of the address of
	  the NAT device. This corrects that behavior by rewriting the
	  address in the Contact header in the incoming 200 OK and the
	  dialog's target address if necessary (since it has already been
	  rewritten to the incorrect private address). (closes issue
	  ASTERISK-23106) Review: https://reviewboard.asterisk.org/r/3168/
	  Reported by: Matt Jordan

2014-01-31 05:28 +0000 [r406987]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Skinny: fix up possible double unlock of
	  chan. Return before chan is possibly unlocked a second time when
	  hanging up a channel in SUBSTATE_OFFHOOK.

2014-01-30 20:34 +0000 [r406935]  coreyfarrell <coreyfarrell@localhost>:

	* main/udptl.c, res/res_rtp_asterisk.c, /: res_rtp_asterisk &
	  udptl: fix port selection to work with SELinux restrictions
	  ast_bind to a port reserved for another program by SELinux causes
	  errno == EACCES. This caused random failures when binding rtp or
	  udptl sockets. Treat EACCES as a non-fatal error, try next port.
	  (closes issue ASTERISK-23134) Reported by: Corey Farrell ........
	  Merged revisions 406933 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406934 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-30 17:33 +0000 [r406919]  Sean Bright <sean@malleable.com>

	* main/manager.c, /: Make a NOTICE about an invalid channel name
	  more useful. ........ Merged revisions 406918 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-29 00:42 +0000 [r406862]  Russell Bryant <russell@russellbryant.com>

	* /, configs/queues.conf.sample: queues.conf.sample Fix documented
	  default for persistentmembers Closes issue ASTERISK-22662
	  ........ Merged revisions 406860 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406861 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-28 23:35 +0000 [r406788-406847]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_pubsub.c: res_pjsip_pubsub: potential crash on
	  timeout What seems to be happening is if a subscription has been
	  terminated and the subscription timeout/expires is less than the
	  time it takes for all pending transactions (currently on the
	  subscription) to end then the subscription timer will not have
	  been canceled yet and sub will be null. Since the subscription
	  has already been canceled nothing needs to be done so a null
	  check in the asterisk code is sufficient in working around this
	  problem. (closes issue ASTERISK-23129) Reported by: Dan Jenkins

	* cdr/cdr_radius.c, cel/cel_radius.c, /, configure,
	  include/asterisk/autoconfig.h.in, configure.ac: cdr_radius,
	  cel_radius: build agains libfreeradius-client Asterisk's RADIUS
	  module currently build against libradiusclient-ng, but this
	  project has been superseeded by libfreeradius-client. The API is
	  99% compatible except that the header name has changed, the
	  library name has changed, and the configuration file location has
	  changed. (closes issue ASTERISK-22980) Reported by: Jeremy Lainé
	  Patches: freeradius-client.patch uploaded by sharky (license
	  6561) ........ Merged revisions 406801 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406802 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_pjsip/include/res_pjsip_private.h,
	  include/asterisk/compat.h: res_pjsip,compat: INFINITY and NAN
	  undefined On some systems the values for INFINITY and NAN are not
	  defined thus causing a build error on those systems. Added
	  definitions for those if they had not previously been defined.
	  (closes issue ASTERISK-23056) Reported by: capouch Patches:
	  inf-nan-patch.txt uploaded by capouch (license 6564)

2014-01-28 19:13 +0000 [r406775]  Kinsey Moore <kmoore@digium.com>

	* res/res_stasis_device_state.c: ARI: Make double subscribe respond
	  with success Currently, attempting to subscribe an application to
	  a device state that it has already subscribed to will generate a
	  500 error response. This will now be treated as a subscription
	  refresh even though ARI subscriptions don't currently support
	  lifetimes and will respond with the normal response for a
	  successful subscription (200 OK). (closes issue ASTERISK-23143)
	  Reported by: Matt Jordan

2014-01-28 16:41 +0000 [r406723]  Scott Griepentrog <sgriepentrog@digium.com>

	* main/rtp_engine.c, /: rtp_engine: improved handling of
	  get_rtp_info failure In ast_rtp_instance_make_compatible(), after
	  a failure of channel tech call get_rtp_info() to return
	  peer_instance, the null pointer would be passed to ao2_ref,
	  producing an error that looked like a refernce counting problem
	  but is not. This patch corrects that and adds helpful LOG_ERROR
	  messages to indicate which failure path occurred. (issue
	  AST-1276) Review: https://reviewboard.asterisk.org/r/3156/
	  ........ Merged revisions 406721 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406722 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-28 00:11 +0000 [r406707]  Richard Mudgett <rmudgett@digium.com>

	* tests/test_cel.c, tests/test_cdr.c: test_cdr.c, test_cel.c:
	  Correctly destroy created bridges. * Fixed the
	  test_cel_attended_transfer_bridges_link unit test to also account
	  for the local channel link being destroyed now that the bridges
	  are actually destroyed. * Made CDR unit test use its own version
	  of do_sleep() from the CEL unit tests.

2014-01-27 20:36 +0000 [r406574-406645]  Russell Bryant <russell@russellbryant.com>

	* /, main/config.c: Allow nested #includes in extconfig.conf
	  extconfig.conf was hard-coded to not allow nested includes for
	  some reason. The code has been this way since a patch was merged
	  for ASTERISK-3333 (revision 4889), which was a significant update
	  to this code ("Merge config updates"). I can't figure out any
	  good reason why this should be limited. This patch just removes
	  the limit and uses the default nesting depth limit. Closes issue
	  ASTERISK-17837 Review: https://reviewboard.asterisk.org/r/3159/
	  ........ Merged revisions 406643 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406644 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/channel.c, /, main/file.c, include/asterisk/channel.h:
	  Protect ast_filestream object when on a channel The
	  ast_filestream object gets tacked on to a channel via
	  chan->timingdata. It's a reference counted object, but the
	  reference count isn't used when putting it on a channel. It's
	  theoretically possible for another thread to interfere with the
	  channel while it's unlocked and cause the filestream to get
	  destroyed. Use the astobj2 reference count to make sure that as
	  long as this code path is holding on the ast_filestream and
	  passing it into the file.c playback code, that it knows it's
	  valid. Bug reported by Leif Madsen. Review:
	  https://reviewboard.asterisk.org/r/3135/ ........ Merged
	  revisions 406566 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406567 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-26 23:03 +0000 [r406516]  Richard Mudgett <rmudgett@digium.com>

	* main/tcptls.c, /: tcptls.c: Add missing cleanup on off nominal
	  path. ........ Merged revisions 406514 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406515 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-26 02:10 +0000 [r406489]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_session.c: res_pjsip_session: Be less strict with
	  core requested outgoing capabilities. The core may (depending on
	  circumstances) request a single codec on outgoing calls. Many
	  channel drivers ignore or treat this as a suggestion while still
	  including configured codecs. The res_pjsip_session logic treated
	  this as an explicit request, leaving out other configured codecs.
	  This change makes res_pjsip_session behave like other channel
	  driver and simply adds the requested codec to the list. (closes
	  issue ASTERISK-23082) Reported by: xrobau Review:
	  https://reviewboard.asterisk.org/r/3140/

2014-01-24 23:29 +0000 [r406401-406465]  Richard Mudgett <rmudgett@digium.com>

	* main/cel.c, /: CEL: Protect data structures during reload and
	  shutdown. The CEL data structures need to be protected during a
	  configuration reload and shutdown. Asterisk crashed during a
	  shutdown because CEL events were still in flight and the CEL data
	  structures were already destroyed. * Protected the cel_backends,
	  cel_dialstatus_store, and cel_linkedids ao2 containers with a
	  global ao2 object wrapper. * Added NULL checks before use of the
	  cel_backends, cel_dialstatus_store, and cel_linkedids ao2
	  containers in case the CEL module is already shutdown. * Fixed
	  overloading of the cel_linkedids held objects reference count.
	  During shutdown any held objects would be leaked. * Fixed memory
	  leak of cel_linkedids held objects if the LINKEDID_END is not
	  being tracked. The objects in the cel_linkedids container were
	  not removed if the LINKEDID_END event is not used. * Added access
	  protection to the cel_backends container during the CLI "cel show
	  status" command. * Made cel_backends, cel_dialstatus_store, and
	  cel_linkedids use the standard ao2 callback templates for the
	  hash and cmp functions. * Eliminated unnecessary uses of
	  RAII_VAR(). * Made ast_cel_engine_init() cleanup alocated
	  resources on failure. (closes issue AST-1253) Reported by:
	  Guenther Kelleter Review:
	  https://reviewboard.asterisk.org/r/3128/ ........ Merged
	  revisions 406417 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406418 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/manager.c, /: manager: Register atexit shutdown routine only
	  once. * Made register atexit shutdown routine only once in
	  __init_manager(). * Fixed some initial load failure conditions in
	  __init_manager(). * Made reset options to defaults on reload when
	  the reload will actually happen. * Removed unnecessary container
	  traversals of the white/black filters during manager_free_user().
	  * ast_free() does not need a NULL check before calling. ........
	  Merged revisions 406359 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406400 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-24 21:25 +0000 [r406389]  Jonathan Rose <jrose@digium.com>

	* res/res_config_pgsql.c, /: res_config_pgsql: Fix a memory leak
	  and use RAII_VAR for cleanup when practical Review:
	  https://reviewboard.asterisk.org/r/3141/ ........ Merged
	  revisions 406360 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406361 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-24 18:04 +0000 [r406342]  Richard Mudgett <rmudgett@digium.com>

	* main/manager.c, /: manager: Protect data structures during
	  shutdown. Occasionally, the manager module would get an
	  "INTERNAL_OBJ: bad magic number" error on a "core restart
	  gracefully" command if an AMI connection is established. * Added
	  ao2_global_obj protection to the sessions global container. *
	  Fixed the order of unreferencing a session object in
	  session_destroy(). * Removed unnecessary container traversals of
	  the white/black filters during session_destructor(). (closes
	  issue AST-1242) Reported by: Guenther Kelleter Review:
	  https://reviewboard.asterisk.org/r/3144/ ........ Merged
	  revisions 406341 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-23 23:41 +0000 [r406327]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip_pidf.c: Today is not my day for writing code that
	  compiles.

2014-01-23 22:54 +0000 [r406311]  Michael L. Young <elgueromexicano@gmail.com>

	* addons/res_config_mysql.c: res_config_mysql: Fix Setting The
	  Column Name Incorrectly When support for a realtime sorcery
	  module was added in revision 386731, the wrong property was
	  accidentally used for setting the column name to be updated in
	  the database table. This patch fixes the typo. (closes issue
	  ASTERISK-23177) Reported by: Denis Tested by: Denis Patches:
	  asterisk-23177-use-field-name.diff by Michael L. Young (license
	  5026)

2014-01-23 21:09 +0000 [r406294-406295]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip_pidf.c: Fix presence body errors found during
	  testing: * PIDF bodies were reporting an "open" state in many
	  cases where it should have been reporting "closed" * XPIDF bodies
	  had XML nodes placed incorrectly within the hierarchy. * SIP URIs
	  in XPIDF bodies did not go through XML sanitization * XML
	  sanitization had some errors: * Right angle bracket was being
	  replaced with "&rt;" instead of "&gt;" * Double quote,
	  apostrophe, and ampersand were not being escaped.

	* res/res_pjsip_pidf.c: Fix presence body errors found during
	  testing: * PIDF bodies were reporting an "open" state in many
	  cases where it should have been reporting "closed" * XPIDF bodies
	  had XML nodes placed incorrectly within the hierarchy. * SIP URIs
	  in XPIDF bodies did not go through XML sanitization * XML
	  sanitization had some errors: * Right angle bracket was being
	  replaced with "&rt;" instead of "&gt;" * Double quote,
	  apostrophe, and ampersand were not being escaped.

2014-01-22 22:23 +0000 [r406264]  Scott Griepentrog <sgriepentrog@digium.com>

	* utils/extconf.c, main/pbx.c, /: pbx.c: Pre-initialize timezone to
	  avoid crash on destroy In ast_build_timing, initialize the
	  timezone value to NULL in order to avoid deferencing an
	  uninitialized value later when calling ast_destroy_timing. The
	  timezone value could be uninitialized if ast_build_timing were to
	  fail due to a zero length time string. (closes issue
	  ASTERISK-22861) Reported by: Sebastian Murray-Roberts Review:
	  https://reviewboard.asterisk.org/r/3134/ Patches:
	  ast_build_timing-initialize-timezone.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 406241 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406245 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-22 19:34 +0000 [r406152-406223]  Kinsey Moore <kmoore@digium.com>

	* apps/app_confbridge.c, /: ConfBridge: Fix channel parameter
	  documentation Confbridge AMI and CLI commands for mute, unmute,
	  and setting the single video source can accept channel prefixes
	  in lieu of a full channel name, but documentation states only
	  that it is required and is a channel name. This corrects the
	  documentation. (closes issue PQ-1397) Reported by: Steve Pitts
	  ........ Merged revisions 406217 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, channels/chan_sip.c: chan_sip: Decline image streams on
	  unsupported transports This change allows chan_sip to decline
	  individual image streams over unsupported transports in the SDP
	  of the 200 response. Previously, an image stream offer with
	  RTP/AVP as the transport would cause chan_sip to respond with a
	  488. (closes issue ASTERISK-22988) Reported by: adomjan Original
	  patch by: adomjan ........ Merged revisions 406170 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406171 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_stasis_playback.c: res_stasis_playback: Correct error
	  argument order Several of the playback error messages for invalid
	  media input in res_stasis_playback.c had the media name and
	  channel name reversed. They now correctly identify the channel
	  name and media name. Reported by: skrusty

2014-01-21 21:47 +0000 [r406133]  Rusty Newton <rnewton@digium.com>

	* res/res_pjsip.c: res_pjsip: Documentation improvement for
	  Endpoint and AOR mailbox options. Making the help text for both
	  more explicit regarding the format of mailbox identifiers. i.e.
	  clarifying the format for app_voicemail mailboxes vs mailboxes
	  from external MWI sources through modules such as
	  res_external_mwi.

2014-01-21 21:06 +0000 [r406081]  Walter Doekes <walter+asterisk@wjd.nu>

	* configs/manager.conf.sample, main/manager.c, /: manager: Clarify
	  eventfilter documentation. Textual changes only. Review:
	  https://reviewboard.asterisk.org/r/3133/ ........ Merged
	  revisions 406079 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406080 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-21 20:20 +0000 [r406003-406049]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_mgcp.c: chan_mgcp: Enforce locking for oseq This
	  restricts direct usage of global oseq so that all accesses are
	  locked and threads are not racing to get oseq values that they
	  did not claim. This also fixes a build error in res_pktccops
	  under dev mode. (closes issue ASTERISK-23100) Reported by:
	  adomjan Patch by: adomjan ........ Merged revisions 406037 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 406038 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_pjsip_outbound_registration.c, res/res_pjsip.c: PJSIP:
	  Handle headers in a list appropriately The PJSIP header parsing
	  function (pjsip_parse_hdr) can generate more than one header
	  instance from a single header field. These header instances exist
	  as a list attached to the returned header and must be handled
	  appropriately when they are added to a message or else only the
	  first header instance will be used. This changes the linked list
	  functions used in outbound proxy code to merge the lists
	  properly.

	* rest-api-templates/ari_resource.h.mustache,
	  res/res_ari_device_states.c, res/res_ari_mailboxes.c,
	  res/res_ari_asterisk.c,
	  rest-api-templates/res_ari_resource.c.mustache,
	  res/res_ari_applications.c,
	  rest-api-templates/body_parsing.mustache (added),
	  res/res_ari_channels.c, res/ari/resource_playbacks.h,
	  rest-api-templates/param_parsing.mustache,
	  res/ari/resource_sounds.h, res/ari/resource_bridges.h,
	  res/ari/resource_device_states.h, res/ari/resource_mailboxes.h,
	  rest-api/api-docs/channels.json, res/ari/resource_asterisk.h,
	  res/ari/resource_applications.h, res/ari/resource_channels.c,
	  res/res_ari_playbacks.c, res/res_ari_sounds.c,
	  rest-api-templates/asterisk_processor.py,
	  res/ari/resource_channels.h, res/res_ari_bridges.c: ARI: Support
	  channel variables in originate This adds back in support for
	  specifying channel variables during an originate without
	  compromising the ability to specify query parameters in the JSON
	  body. This was accomplished by generating the body-parsing code
	  in a separate function instead of being integrated with the URI
	  query parameter parsing code such that it could be called by
	  paths with body parameters. This is transparent to the user of
	  the API and prevents manual duplication of code or data
	  structures. (closes issue ASTERISK-23051) Review:
	  https://reviewboard.asterisk.org/r/3122/ Reported by: Matt Jordan

2014-01-20 23:18 +0000 [r405982]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Skinny: fix up handling of fragmented
	  packets. Bad offset in reading second or more fragment of skinny
	  packets. Fixed to offset by char (single byte) rather than size
	  of req.

2014-01-20 22:15 +0000 [r405928]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/sig_pri.c: chan_dahdi/PRI: Suppress CONNECTED_LINE
	  updates when nothing in the udpate is valid. * Also simplified
	  some subddress handling code. (closes issue ASTERISK-23008)
	  Reported by: Michael Cargile ........ Merged revisions 405926
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8 ........
	  Merged revisions 405927 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-20 21:53 +0000 [r405924]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Skinny: fix up session logging. Logging
	  from the skinny session loop was providing some incorrect reasons
	  for exiting the loop. Cleaned up messages and handling so correct
	  reason displayed.

2014-01-20 18:07 +0000 [r405908]  Jonathan Rose <jrose@digium.com>

	* channels/chan_pjsip.c: chan_pjsip: Provide a means for tracking
	  device state when holding/unholding Previously PJSIP did not
	  track hold/unhold and it would always simply be 'inuse'. This
	  patch fixes that. review:
	  https://reviewboard.asterisk.org/r/3129/

2014-01-18 23:57 +0000 [r405893]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Skinny: fix reversed device reset from
	  CLI. Existing code would do a full device restart when "skinny
	  reset device" was entered at the CLI and do a reset when "skinny
	  reset device restart" entered.

2014-01-17 22:05 +0000 [r405877]  Sean Bright <sean@malleable.com>

	* channels/chan_sip.c: Make sure the maxptime attribute is added to
	  the correct offers.

2014-01-17 21:32 +0000 [r405861-405875]  Scott Griepentrog <sgriepentrog@digium.com>

	* main/frame.c, include/asterisk/format_pref.h,
	  res/res_pjsip_sdp_rtp.c, main/format_pref.c, main/sorcery.c:
	  pjsip: fix support for allow=all This change adds improvements to
	  support for allow=all in pjsip.conf so that it functions as
	  intended. Previously, the allow/disallow socery configuration
	  would set & clear codecs from the media.codecs and media.prefs
	  list, but if all was specified the prefs list was not updated.
	  Then a call would fail when create_outgoing_sdp_stream() created
	  an SDP with no audio codecs. A new function
	  ast_codec_pref_append_all() is provided to add all codecs to the
	  prefs list - only those not already on the list. This enables the
	  configuration to specify a codec preference, but still add all
	  codecs, and even then remove some codecs, as shown in this
	  example: allow = ulaw, alaw, all, !g729, !g723 Also, the display
	  order of allow in cli output is updated to match the
	  configuration by using prefs instead of caps when generating a
	  human readable string. Finally, a change to
	  create_outgoing_sdp_stream() skips a codec when it does not have
	  a payload code instead of the call failing. (closes issue
	  ASTERISK-23018) Reported by: xrobau Review:
	  https://reviewboard.asterisk.org/r/3131/

	* main/http.c: http: supported chunked Transfer-Encoding This
	  change implements support for HTTP Transfer-Encoding chunked in
	  both JSON and Form (post vars) body content. A new function
	  ast_http_get_contents() handles both regular and chunked mode
	  body, returning after the entire body is received. (closes issue
	  ASTERISK-23068) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/3125/

2014-01-17 18:54 +0000 [r405777-405843]  Rusty Newton <rnewton@digium.com>

	* res/res_pjsip.c: Fixing some XML syntax issues with my previous
	  commit at r405777 for ASTERISK-23071

	* /, channels/chan_sip.c, doc/asterisk.8, main/features.c,
	  configs/sip.conf.sample, apps/app_queue.c, apps/app_transfer.c,
	  channels/chan_iax2.c: Documentation: doc fixes across various
	  parts of the code for ASTERISK issues 23061,23028,23046,23027
	  Fixes typos of "transfered" instead of "transferred" in various
	  code. Fixes incorrect gosub param help text for app_queue. Fixes
	  Asterisk man pages containing unquoted minus signs. Adds note
	  about the "textsupport" option in sip.conf.sample. (issue
	  ASTERISK-23061) (issue ASTERISK-23028) (issue ASTERISK-23046)
	  (issue ASTERISK-23027) (closes issue ASTERISK-23061) (closes
	  issue ASTERISK-23028) (closes issue ASTERISK-23046) (closes issue
	  ASTERISK-23027) Reported by: Eugene, Jeremy Laine, Denis
	  Pantsyrev Patches: transferred.patch uploaded by Jeremy Laine
	  (license 6561) hyphen.patch uploaded by Jeremy Laine (license
	  6561) sip.conf.sample.patch uploaded by Eugene (license 6360)
	  ........ Merged revisions 405791 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 405792 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_pjsip.c: res_pjsip: enhance documentation for mailboxes
	  options, for both endpoints and aors Made documentation more
	  explicit as to the use of the both options. (issue
	  ASTERISK-23071) (closes issue ASTERISK-23071) Reported by: Matt
	  Jordan

2014-01-16 20:05 +0000 [r405746-405748]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip/pjsip_options.c: res_pjsip: AOR option
	  qualify_frequency not respected on startup If an endpoint had
	  previously dynamically registered a contact and the contact
	  information was successfully stored in astdb then upon restart
	  the qualify notifications would not be sent out if the
	  qualify_frequency was set. This was due to the fact that only
	  permanent contacts were being checked and scheduled for qualifies
	  on startup. Modified the code to check and schedule all
	  registered contacts at startup. (closes issue ASTERISK-23062)
	  Reported by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/3124/

	* main/manager.c, /: manager: Originate doesn't abort on failed
	  format_cap allocation action_originate responds to the remote
	  system with an error when cap==NULL, but doesn't return (abort
	  the originate). Patched to return. (closes issue ASTERISK-23034)
	  Reported by: Corey Farrell Patches: ASTERISK-23034.patch uploaded
	  by coreyfarrell (license 5909) ........ Merged revisions 405745
	  from http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-16 19:32 +0000 [r405743]  Kinsey Moore <kmoore@digium.com>

	* res/res_pjsip.c: PJSIP: Fix outbound OPTIONS support When path
	  support was added and contacts were made available during request
	  creation and transmission, the code path used by outbound qualify
	  support was not modified correctly and was causing request
	  creation to fail. This ensures that outbound request creation
	  with only a contact and no dialog, endpoint, or uri can succeed
	  which restores qualify support. Reported by: gtjoseph Reported
	  by: kharwell

2014-01-16 19:06 +0000 [r405643-405694]  Kevin Harwell <kharwell@digium.com>

	* /, res/res_fax.c, configs/res_fax.conf.sample, UPGRADE.txt:
	  res_fax: check_modem_rate() returned incorrect rate for V.27
	  According to the new standard for V.27 and V.32 they are able to
	  transmit at a bit rate of 4,800 or 9,600. The check_mode_rate
	  function needed to be updated to reflect this. Also, because of
	  this change the default 'minrate' value was updated to be 4800.
	  (closes issue ASTERISK-22790) Reported by: Paolo Compagnini
	  Patches: res_fax.txt uploaded by looserouting (license 6548)
	  ........ Merged revisions 405656 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 405693 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* channels/chan_pjsip.c: chan_pjsip: initial device state on
	  endpoints is INVALID When endpoints get loaded their device state
	  gets set to 'INVALID' because the channel driver has not been
	  loaded yet. Fixed by updating the device state for every endpoint
	  upon load of the channel driver. (closes issue ASTERISK-23065)
	  Reported by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/3123/

2014-01-15 16:48 +0000 [r405585-405587]  Jonathan Rose <jrose@digium.com>

	* CHANGES: Remove subversion conflict tag accidentally left in
	  CHANGES

	* CHANGES: Include CHANGES info for r405553

2014-01-15 16:36 +0000 [r405583]  Joshua Colp <jcolp@digium.com>

	* /, cel/cel_manager.c: cel_manager: Don't crash if configuration
	  file is invalid. The cel_manager module did not properly handle
	  the case where the configuration file was invalid. The module
	  will now output a warning message and disable itself if this
	  occurs. Reported by: Bryan Walters ........ Merged revisions
	  405581 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 405582 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-15 13:14 +0000 [r405565]  Kinsey Moore <kmoore@digium.com>

	* res/res_pjsip_messaging.c, UPGRADE.txt, res/res_pjsip_t38.c,
	  res/res_pjsip_caller_id.c, CHANGES,
	  res/res_pjsip/pjsip_options.c, res/res_pjsip.c,
	  res/res_pjsip_nat.c, res/res_pjsip_session.c,
	  contrib/ast-db-manage/config/versions/2fc7930b41b3_add_pjsip_endpoint_options_for_12_1.py
	  (added), res/res_pjsip_header_funcs.c, res/res_pjsip/location.c,
	  res/res_pjsip_outbound_registration.c, res/res_pjsip_path.c
	  (added), res/res_pjsip_mwi.c, res/res_pjsip/pjsip_distributor.c,
	  res/res_pjsip_diversion.c, channels/chan_pjsip.c,
	  res/res_pjsip_registrar.c, res/res_pjsip_refer.c,
	  include/asterisk/res_pjsip.h,
	  include/asterisk/res_pjsip_session.h, res/res_pjsip_notify.c:
	  PJSIP: Add Path header support This adds Path support to
	  chan_pjsip in res_pjsip_path.c with minimal additions in
	  res_pjsip_registrar.c to store the path and additions in
	  res_pjsip_outbound_registration.c to enable advertisement of path
	  support to registrars and intervening proxies. Path information
	  is stored on contacts and is enabled via Address of Record (AoRs)
	  and Registration configuration sections. While adding path
	  support, it became necessary to be able to add SIP supplements
	  that handled messages outside of sessions, so a framework for
	  handling these types of hooks was added in parallel to the
	  already-existing session supplements and several senders of
	  out-of-dialog requests were refactored as a result. (closes issue
	  ASTERISK-21084) Review: https://reviewboard.asterisk.org/r/3050/

2014-01-14 23:26 +0000 [r405553]  Jonathan Rose <jrose@digium.com>

	* rest-api/resources.json, res/ari/ari_model_validators.c,
	  res/res_stasis_mailbox.exports.in (added),
	  res/ari/ari_model_validators.h, rest-api/api-docs/mailboxes.json
	  (added), include/asterisk/stasis_app_mailbox.h (added),
	  res/ari/resource_mailboxes.c (added), res/ari.make,
	  res/res_ari_mailboxes.c (added), res/ari/resource_mailboxes.h
	  (added), res/res_stasis_mailbox.c (added): ARI: Add mailboxes
	  resource for controlling and polling external MWI Adds the
	  following AMI commands: PUT mailboxes/mailboxName modifies
	  mailbox state and implicitly creates new mailboxes GET
	  mailboxes/mailboxName retrieves a JSON representation of a single
	  mailbox if it exists GET mailboxes retrieves a JSON array of all
	  mailboxes DELETE mailbox/mailboxName deletes a mailbox Note that
	  res_mwi_external must be loaded for these functions to actually
	  do anything. Review: https://reviewboard.asterisk.org/r/3117/

2014-01-14 21:44 +0000 [r405541]  Richard Mudgett <rmudgett@digium.com>

	* main/strings.c: string container: Remove unnecessary RAII_VAR
	  usage and string object lock.

2014-01-14 18:13 +0000 [r405435]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, channels/chan_sip.c: chan_sip: fix Local From tag on outbound
	  register regression In ASTERISK-12117, an improvement to insure
	  consistant local from tags on outbound registrations resulted in
	  an undesirable behavior - caused by leftover unexpired sip_pvt
	  dialogs (with the previous cseq number), resulting in many
	  uncessary REGISTER requests. Instead of significant rework of
	  transmit_register(), this change deletes the dialogs after a 200
	  OK response indiciating a successful registration, keeping the
	  old dialogs from interfering with normal operation. (closes issue
	  ASTERISK-22946) Reported by: Stephan Eisvogel Review:
	  https://reviewboard.asterisk.org/r/3109/ ........ Merged
	  revisions 405433 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 405434 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-14 18:03 +0000 [r405432]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/logger.h, main/pbx.c, main/manager.c, /,
	  funcs/func_timeout.c, apps/app_dumpchan.c, main/logger.c,
	  UPGRADE.txt, apps/app_verbose.c, main/asterisk.c,
	  configs/logger.conf.sample, main/cli.c: verbosity: Fix
	  performance of console verbose messages. The per console verbose
	  level feature as previously implemented caused a large
	  performance penalty. The fix required some minor
	  incompatibilities if the new rasterisk is used to connect to an
	  earlier version. If the new rasterisk connects to an older
	  Asterisk version then the root console verbose level is always
	  affected by the "core set verbose" command of the remote console
	  even though it may appear to only affect the current console. If
	  an older version of rasterisk connects to the new version then
	  the "core set verbose" command will have no effect. * Fixed the
	  verbose performance by not generating a verbose message if
	  nothing is going to use it and then filtered any generated
	  verbose messages before actually sending them to the remote
	  consoles. * Split the "core set debug" and "core set verbose" CLI
	  commands to remove the per module verbose support that cannot
	  work with the per console verbose level. * Added a silent option
	  to the "core set verbose" command. * Fixed "core set debug off"
	  tab completion. * Made "core show settings" list the current
	  console verbosity in addition to the root console verbosity. *
	  Changed the default verbose level of the 'verbose' setting in the
	  logger.conf [logfiles] section. The default is now to once again
	  follow the current root console level. As a result, using the AMI
	  Command action with "core set verbose" could again set the root
	  console verbose level and affect the verbose level logged.
	  (closes issue AST-1252) Reported by: Guenther Kelleter Review:
	  https://reviewboard.asterisk.org/r/3114/ ........ Merged
	  revisions 405431 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-14 03:12 +0000 [r405367]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Skinny: do not add call to missed calls
	  list if answered elsewhere. Patch updates skinny devices with a
	  SKINNY_CONNECTED callstate if an inbound ringing or callwaiting
	  call is answered elsewhere.

2014-01-13 17:09 +0000 [r405350]  Jonathan Rose <jrose@digium.com>

	* res/res_pjsip_session.c: PJSIP: Backport r405270 - Unhold on
	  reinvite without SDP Adds behavior to unhold on a reinvite
	  without an SDP section Review:
	  https://reviewboard.asterisk.org/r/3106/

2014-01-13 13:28 +0000 [r405338]  Kinsey Moore <kmoore@digium.com>

	* res/res_pjsip/pjsip_cli.c: res_pjsip: Fix CLI tab completion
	  issues This fixes several issues with the new res_pjsip CLI tab
	  completion such as output of headers during tab completion and
	  being able to tab-complete more items than the code actually
	  handled (further items would simply be ignored). (closes issue
	  ASTERISK-23081) Review: https://reviewboard.asterisk.org/r/3115/
	  Reported by: xrobau

2014-01-12 22:23 +0000 [r405325]  Joshua Colp <jcolp@digium.com>

	* res/ari/resource_playbacks.c, res/ari/resource_channels.c,
	  include/asterisk/ari.h, res/ari/resource_bridges.c,
	  res/ari/resource_recordings.c, res/ari/resource_device_states.c,
	  res/res_ari.c, res/ari/resource_endpoints.c,
	  res/ari/resource_applications.c: res_ari: Fix various memory
	  leaks. This change fixes a few memory leaks that were found based
	  on a mailing list post. 1. Some JSON response messages were never
	  freed. This was caused by the documentation stating that message
	  references were stolen when in reality they were not. The code
	  now follows the documentation and usage has been updated. 2. HTTP
	  response headers were never freed. 3. The variable list for
	  wildcards paths was never freed. (closes issue ASTERISK-23128)
	  Reported by: Kenneth Watson (on list) Review:
	  https://reviewboard.asterisk.org/r/3119/

2014-01-12 21:58 +0000 [r405311-405312]  Matthew Jordan <mjordan@digium.com>

	* funcs/func_cdr.c, include/asterisk/cdr.h, apps/app_cdr.c,
	  main/cdr.c, apps/app_forkcdr.c: CDRs: Synchronize dialplan
	  applications that manipulate CDRs with the engine In
	  https://reviewboard.asterisk.org/r/3057/, applications and
	  functions that manipulate CDRs were made to interact over Stasis.
	  This was done to synchronize manipulations of CDRs from the
	  dialplan with the updates the engine itself receives over the
	  message bus. This change rested on a faulty premise: that
	  messages published to the CDR topic or to a topic that forwards
	  to the CDR topic are synchronized with the messages handled by
	  the CDR topic subscription in the CDR engine. This is not the
	  case. There is no ordering guaranteed for two messages published
	  to the same topic; ordering is only guaranteed if a message is
	  published to the same subscriber. Stasis was modified in r405311
	  to allow a publisher to synchronize on the subscriber. This patch
	  uses that API to synchronize the CDR publishers with the CDR
	  engine message router, which maintains the overall topic
	  subscription. (closes issue ASTERISK-22884) Reported by: Matt
	  Jordan Review: https://reviewboard.asterisk.org/r/3099/

	* main/stasis.c, main/stasis_message_router.c,
	  include/asterisk/stasis.h,
	  include/asterisk/stasis_message_router.h, tests/test_stasis.c:
	  stasis: Add methods to allow for synchronous publishing to
	  subscriber This patch adds an API call to Stasis that allows a
	  publisher to publish a stasis message that will not return until
	  a specific subscriber handles the message. Since a subscriber can
	  have their own forwarding topic which orders messages from many
	  topics, this allows a publisher who knows of that subscriber to
	  synchronize to that subscriber regardless of the forwarding
	  relationships between topics. This is of particular use for
	  dialplan applications that need to synchronize on a particular
	  subscriber's handling of a message. (issue ASTERISK-22884)
	  Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/3099/

2014-01-10 19:39 +0000 [r405298]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip/security_events.c: Print "<unknown>" for artificial
	  endpoint in PJSIP security events. Previously, this printed a
	  UUID, which was not very clear when dealing with an artificial
	  endpoint. Review: https://reviewboard.asterisk.org/r/3113

2014-01-10 18:00 +0000 [r405282]  Richard Mudgett <rmudgett@digium.com>

	* main/logger.c, /: Logging callid: Fix some sizeof() references
	  per coding guidelines. ........ Merged revisions 405281 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-09 23:45 +0000 [r405268]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_dahdi.c: Fix chan_dahdi copile issue in dev-mode.
	  Error "unused variable i in dahdi_create_channel_range" when
	  compiling in dev-mode. Small restructure to
	  dahdi_create_channel_range to move the for(x) loop and int i,x to
	  a block within the IFDEF.

2014-01-09 23:36 +0000 [r405266]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_messaging.c, res/res_pjsip.c: res_pjsip_messaging:
	  potential for field values in from/to headers to be missing Added
	  in ability to specify display name format ("name"
	  <sip:name@ipaddr:port>) for a given URI and made sure it was
	  fully propagated to the outgoing message. Also made it so outoing
	  messages in res_pjsip always send as "sip:". (closes issue
	  ASTERISK-22924) Reported by: Anthony Messina Review:
	  https://reviewboard.asterisk.org/r/3094/

2014-01-09 20:25 +0000 [r405253]  Kinsey Moore <kmoore@digium.com>

	* main/astobj2.c, res/res_pjsip_session.c,
	  include/asterisk/astobj2.h: astobj2: Correct ao2_iterator opacity
	  violations This corrects the ao2_iterator opacity violations in
	  res_pjsip_session.c by adding a global function to get the number
	  of elements inside the container hidden behind the iterator.
	  (closes issue ASTERISK-23053) Review:
	  https://reviewboard.asterisk.org/r/3111/ Reported by: Richard
	  Mudgett

2014-01-09 16:51 +0000 [r405235]  Kevin Harwell <kharwell@digium.com>

	* res/res_rtp_asterisk.c, /: res_rtp_asterisk: Fails to resume
	  WebRTC call from hold In ast_rtp_ice_start if the ice session
	  create check list failed, start check was never initiated and
	  ice_started was never set to true. Upon re-entering the function
	  (for instance, [un]hold) it would try to create the check list
	  again with duplicate remote candidates. Fixed so that if the
	  create check list fails the necessary data structures are
	  properly re-initialized for any subsequent retries. Note, it was
	  decided to not stop ice support (by calling ast_rtp_ice_stop) on
	  a check list failure because it possible things might still work.
	  However, a debug message was added to help with any future
	  troubleshooting. (closes issue ASTERISK-22911) Reported by: Vytis
	  Valentinavičius Patches: works_on_my_machine.patch uploaded by
	  xytis (license 6558) ........ Merged revisions 405234 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-09 15:49 +0000 [r405216]  Matthew Jordan <mjordan@digium.com>

	* apps/app_confbridge.c, apps/confbridge/conf_state_multi_marked.c,
	  /: app_confbridge: Fix crash caused when waitmarked/marked users
	  leave together When waitmarked users join a ConfBridge, the
	  conference state is transitioned from EMPTY -> INACTIVE. In this
	  state, the users are maintined in a waiting users list. When a
	  marked user joins, the ConfBridge conference transitions from
	  INACTIVE -> MULTI_MARKED, and all users are put onto the active
	  list of users. This process works correctly. When the marked user
	  leaves, if they are the last marked user, the MULTI_MARKED state
	  does the following: (1) It plays back a message to the bridge
	  stating that the leader has left the conference. This requires an
	  unlocking of the bridge. (2) It moves waitmarked users back to
	  the waiting list (3) It transitions to the appropriate state: in
	  this case, INACTIVE However, because it plays the prompt back to
	  the bridge before moving the users and before finishing the state
	  transition, this creates a race condition: with the bridge
	  unlocked, waitmarked users who leave the conference (or are
	  kicked from it) can cause a state transition of the bridge to
	  another state before the conference is transitioned to the
	  INACTIVE state. This causes the state machine to get a bit wonky,
	  often leading to a crash when the MULTI_MARKED state attempts to
	  conclude its processing. This patch fixes this problem: (1) It
	  prevents kicked users from being kicked again. That's just a
	  nicety. (2) More importantly, it fixes the race condition by only
	  playing the prompt once the state has transitioned correctly to
	  INACTIVE. If waitmarked users sneak out during the prompt being
	  played, no harm no foul. Review:
	  https://reviewboard.asterisk.org/r/3108/ (closes issue AST-1258)
	  Reported by: Steve Pitts ........ Merged revisions 405215 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-09 14:14 +0000 [r405162]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, apps/app_dumpchan.c: "Minimun" typo. ........ Merged revisions
	  405160 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 405161 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-08 16:48 +0000 [r405131]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip/security_events.c: Use proper case for checking if
	  digest authentication is used.

2014-01-08 16:28 +0000 [r405083-405124]  Kinsey Moore <kmoore@digium.com>

	* /, configure, configure.ac, pbx/pbx_lua.c: pbx_lua: Add support
	  for Lua 5.2 This adds support for Lua 5.2 in pbx_lua which is
	  available on newer operating systems. (closes issue
	  ASTERISK-23011) Review: https://reviewboard.asterisk.org/r/3075/
	  Reported by: George Joseph Patch by: George Joseph ........
	  Merged revisions 405090 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 405091 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, channels/chan_sip.c: Add the missing part of r400140 When the
	  patch to add retry-on-forbidden-response was committed, part of
	  the patch for chan_sip was not committed which caused the feature
	  to be entirely nonfunctional. This corrects the code in question.
	  (closes issue ASTERISK-17138) Review:
	  https://reviewboard.asterisk.org/r/2874 ........ Merged revisions
	  405033 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 405081 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-07 19:55 +0000 [r405019-405034]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_acl.c: res_pjsip_acl: Fix another case of assuming
	  a contact will always contain a URI.

	* res/res_pjsip_nat.c: res_pjsip_nat: Don't assume a Contact header
	  will always contain a URI. If the 'rewrite_contact' option was
	  enabled and a Contact header was received which contained a '*' a
	  crash would occur. This change makes the res_pjsip_nat module
	  ignore the Contact header if it contains only a '*'. (closes
	  issue ASTERISK-23101) Reported by: Matt Jordan

2014-01-06 21:54 +0000 [r404952-405006]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_voicemail.c: app_voicemail: Explicitly set
	  defaultenabled=yes

	* res/res_mwi_external_ami.c (added): External MWI AMI support. The
	  external MWI AMI interface provides a thin wrapper around the
	  core external MWI resource. The resource adds the following AMI
	  actions: MWIGet, MWIDelete, and MWIUpdate. (closes issue AFS-46)
	  Review: https://reviewboard.asterisk.org/r/3061/

	* apps/app_voicemail.c, res/res_mwi_external.c (added),
	  configs/sorcery.conf.sample, include/asterisk/res_mwi_external.h
	  (added), res/res_mwi_external.exports.in (added): External MWI
	  core support. * The core external MWI resource provides for MWI
	  message counts persistence using sorcery. With sorcery, the user
	  is able to configure which sorcery wizzard backend to use if the
	  default astdb is not desired. * The core external MWI resoruce
	  provides some debugging CLI commands enabled by defining
	  MWI_DEBUG_CLI. The debugging CLI commands are: "mwi delete all",
	  "mwi delete like <regex>", "mwi delete mailbox <mailbox>", "mwi
	  list all", "mwi list like <regex>", "mwi show mailbox <mailbox>",
	  and "mwi update mailbox <mailbox> [<new> [<old>]]". (closes issue
	  AFS-43) Review: https://reviewboard.asterisk.org/r/3061/

2014-01-05 16:00 +0000 [r404923-404935]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_outbound_registration.c:
	  res_pjsip_outbound_registration: Don't assume that a registration
	  client will always exist.

	* res/res_pjsip_outbound_registration.c:
	  res_pjsip_outbound_registration: Create registration client in pj
	  thread. Depending on which threading was loading the outbound
	  registration it was possible for the registration client to be
	  allocated outside of a pj thread. This change moves the creation
	  inside the synchronous task where it is guaranteed it will occur
	  in a pj thread. Reported by: Rob Thomas

2014-01-04 10:42 +0000 [r404911]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* main/asterisk.c, /: asterisk.c: suppress live_dangerously warning
	  on rasterisk Even since the fixes of AST-2013-007, Asterisk
	  prints the following warning on startup if the user decided to
	  live dangerously: Privilege escalation protection disabled! See
	  https://wiki.asterisk.org/wiki/x/1gKfAQ for more details. This
	  message is intended for the logs and interactive startup. No need
	  for it to appear on a remote console. This commit removes it from
	  there. (closes issue ASTERISK-23084) Review:
	  https://reviewboard.asterisk.org/r/3101/ ........ Merged
	  revisions 404861 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404888 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-03 21:59 +0000 [r404859]  Kevin Harwell <kharwell@digium.com>

	* /, cel/cel_pgsql.c: cel_pgsql: module not correctly reloading
	  Upon reload the module unconditionally "unloaded" the module
	  (freeing memory and setting pointers to NULL) and then when
	  attempting a "load" if the config file had not changed then
	  nothing would be reinitialized. By moving the "unload" to occur
	  conditionally (reload only) after an attempted configuration
	  load, but before module "loading" alleviates the issue. The
	  module now loads/unloads/reloads correctly. (closes issue
	  ASTERISK-22871) Reported by: Matteo ........ Merged revisions
	  404857 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 404858 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-03 21:45 +0000 [r404843-404855]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip_logger.c: res_pjsip_logger: Add the
	  ASTERISK_FILE_VERSION macro Registering yourself with the
	  Asterisk core is the nice thing to do, even when you're a logging
	  module.

	* res/res_pjsip_authenticator_digest.c, tests/test_utils.c:
	  res_pjsip_authenticator_digest: Fix md5 hash buffer An md5 hash
	  is 32 bytes long. The char buffer must be at least 33 bytes to
	  avoid clobbering of the stack. This patch also fixes a potential
	  clobbering in test_utils.c. Thanks to Andrew Nagy for reporting
	  and testing this out in #asterisk-dev Reported by: Andrew Nagy
	  Tested by: Andrew Nagy

2014-01-03 19:00 +0000 [r404781-404786]  Kevin Harwell <kharwell@digium.com>

	* channels/chan_dahdi.c, /: chan_dahdi: dahdi show channels slices
	  PRI channel dnid on output dahdi show channels output slices the
	  callerid (which is dnid copied over on PRI channels). If the
	  channel naming structures look like: 'DAHDI/i1/1408409XXXX-6'
	  then the output slices 1408409XXXX down to 1408409XXX. This patch
	  just opens it up to 15 chars so you can see the whole thing.
	  (closes issue ASTERISK-22918) Reported by: outtolunc Patches:
	  svn_chan_dahdi.c.format12_15.diff.txt uploaded by outtolunc
	  (license 5198) ........ Merged revisions 404784 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404785 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, apps/app_meetme.c: app_meetme: compiler warning Fixed a
	  compiler warning (errors in 'dev-mode') given by gcc version
	  4.8.1. The one in app_meetme involved the
	  'sizeof-pointer-memaccess' (see:
	  http://gcc.gnu.org/gcc-4.8/porting_to.html) warning. Fixed so it
	  would no longer issue a warning and can compile again in
	  'dev-mode'. Review: https://reviewboard.asterisk.org/r/3098/
	  ........ Merged revisions 404742 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404773 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-03 18:24 +0000 [r404764]  Richard Mudgett <rmudgett@digium.com>

	* tests/test_stasis.c: test_stasis.c: Fix ref leak in normal
	  execution path.

2014-01-03 17:25 +0000 [r404725-404737]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip/pjsip_configuration.c, res/res_pjsip/location.c:
	  res_pjsip: Ensure more URI validation happens in pj threads.

	* res/res_pjsip_outbound_registration.c:
	  res_pjsip_outbound_registration: Ensure URI validation happens in
	  a pjlib thread. This change moves outbound registration URI
	  validation into the task executed within a pjlib thread. Reported
	  by: Andrew Nagy

2014-01-02 19:37 +0000 [r404676]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, funcs/func_strings.c: func_strings: use memmove to prevent
	  overlapping memory on strcpy When calling REPLACE() with an empty
	  replace-char argument, strcpy is used to overwrite the the
	  matching <find-char>. However as the src and dest arguments to
	  strcpy must not overlap, it causes other parts of the string to
	  be overwritten with adjacent characters and the result is
	  mangled. Patch replaces call to strcpy with memmove and adds a
	  test suite case for REPLACE. (closes issue ASTERISK-22910)
	  Reported by: Gareth Palmer Review:
	  https://reviewboard.asterisk.org/r/3083/ Patches:
	  func_strings.patch uploaded by Gareth Palmer (license 5169)
	  ........ Merged revisions 404674 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404675 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2014-01-02 19:06 +0000 [r404663]  Kevin Harwell <kharwell@digium.com>

	* channels/chan_pjsip.c, include/asterisk/res_pjsip.h,
	  configs/pjsip.conf.sample, res/res_pjsip/pjsip_configuration.c,
	  CHANGES, res/res_pjsip.c: res_pjsip: add 'set_var' support on
	  endpoints Added a new 'set_var' option for ast_sip_endpoint(s).
	  For each variable specified that variable gets set upon creation
	  of a pjsip channel involving the endpoint. (closes issue
	  ASTERISK-22868) Reported by: Joshua Colp Review:
	  https://reviewboard.asterisk.org/r/3095/

2013-12-31 22:49 +0000 [r404613-404652]  Joshua Colp <jcolp@digium.com>

	* channels/chan_pjsip.c, res/res_pjsip_session.c: chan_pjsip:
	  Handle hanging up before calling. Channel creation in Asterisk is
	  broken up into two steps: requesting and calling. In some cases a
	  channel may be requested but never called. This happens in the
	  ChanIsAvail dialplan application for determining if something is
	  reachable or not. The PJSIP channel driver did not take this
	  situation into account and attempted to end a session that was
	  never called out on. The code now checks the session state to
	  determine if the session has been called out on and if not
	  terminates it instead of ending it. (closes issue ASTERISK-23074)
	  Reported by: Kilburn

	* res/res_pjsip_endpoint_identifier_ip.c:
	  res_pjsip_endpoint_identifier_ip: Accept hostnames in the 'match'
	  field. Hostnames specified in the 'match' field will be resolved
	  and all addresses returned. Each address will be added to the
	  endpoint identifier for the matching process. Reported by: Rob
	  Thomas

2013-12-31 21:38 +0000 [r404605]  Kevin Harwell <kharwell@digium.com>

	* /, cel/cel_pgsql.c: cel_pgsql: deadlock on unload and
	  core_event_dispatcher A deadlock can happen between a thread
	  unloading or reloading the cel_pgsql module and the
	  core_event_dispatcher taskprocessor thread. Description of what
	  is happening: Thread 1 (for example, a netconsole thread): a
	  "module reload cel_pgsql" is launched the thread enter the
	  "my_unload_module" function (cel_pgsql.c) the thread acquire the
	  write lock on psql_columns the thread enter the
	  "ast_event_unsubscribe" function (event.c) the thread try to
	  acquire the write lock on ast_event_subs[sub->type] Thread 2
	  (core_event_dispatcher taskprocessor thread): the taskprocessor
	  pop a CEL event the thread enter the "handle_event" function
	  (event.c) the thread acquire the read lock on
	  ast_event_subs[sub->type] the thread callback the "pgsql_log"
	  function (cel_pgsql.c), since it's a subscriber of CEL events the
	  thread try to acquire a read lock on psql_columns (closes issue
	  ASTERISK-22854) Reported by: Etienne Lessard Patches:
	  cel_pgsql_fix_deadlock_event.patch uploaded by hexanol (license
	  6394) ........ Merged revisions 404603 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404604 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-31 20:26 +0000 [r404592]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_outbound_registration.c:
	  res_pjsip_outbound_registration: Add validation for 'server_uri'
	  and 'client_uri'. When applying configuration for outbound
	  registrations the 'server_uri' and 'client_uri' fields were not
	  validated. The code will now confirm that they exist and that
	  they contain parseable SIP URIs. Reported by: Andrew Nagy

2013-12-30 23:21 +0000 [r404581]  Kevin Harwell <kharwell@digium.com>

	* main/channel.c, /: channels.c: core show channeltypes slicing
	  'core show channeltypes' type column is being sliced, resulting
	  in incomplete type names. (closes issue ASTERISK-22919) Reported
	  by: outtolunc Patches: svn_channel.c.format_15.diff.txt uploaded
	  by outtolunc (license 5198) ........ Merged revisions 404579 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-24 17:10 +0000 [r404565-404568]  David M. Lee <dlee@digium.com>

	* UPGRADE.txt: Added note to UPGRADE.txt about the default value of
	  live_dangerously changing

	* main/http.c: http: Properly reject requests with
	  Transfer-Encoding set Asterisk does not support any of the
	  transfer encodings specified in HTTP/1.1, other than the default
	  "identity" encoding. According to RFC 2616: A server which
	  receives an entity-body with a transfer-coding it does not
	  understand SHOULD return 501 (Unimplemented), and close the
	  connection. A server MUST NOT send transfer-codings to an
	  HTTP/1.0 client. This patch adds the 501 Unimplemented response,
	  instead of the hard work of actually implementing other
	  recordings. This behavior is especially problematic for Node.js
	  clients, which use chunked encoding by default. (closes issue
	  ASTERISK-22486) Review: https://reviewboard.asterisk.org/r/3092/

2013-12-24 02:19 +0000 [r404553]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_pubsub.c: res_pjsip_pubsub: Ensure dialog
	  manipulation happens on proper thread. When destroying a
	  subscription we remove the serializer from its dialog and
	  decrease its reference count. Depending on which thread dropped
	  the subscription reference count to 0 it was possible for this to
	  occur in a thread where it is not possible. (closes issue
	  ASTERISK-22952) Reported by: Matt Jordan

2013-12-21 03:34 +0000 [r404531]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip/pjsip_cli.c: res_pjsip/pjsip_cli: fix compilation
	  error caused by passing ast_free When wanting to pass *free as a
	  function pointer, ast_free_ptr has to be used instead of
	  ast_free. This allows it to be compiled with MALLOC_DEBUG
	  enabled.

2013-12-20 22:02 +0000 [r404509]  David M. Lee <dlee@digium.com>

	* res/ari/resource_channels.h, rest-api/api-docs/applications.json,
	  rest-api/api-docs/channels.json, res/ari/resource_channels.c,
	  res/res_ari_channels.c: ari: Remove support for specifying
	  channel vars during origination. When we added support for
	  specifying channel variables for an origination, we didn't
	  consider how that would interact with another feature, namely
	  specifying request parameters in a JSON request body. The method
	  of specifying channel variables (as a flat JSON object passed in
	  the JSON body) interferes with parsing parameters out of the
	  request body. Unfortunately, fixing this would be a backward
	  incompatible change. In the interest of keeping the API sane and
	  keeping our release schedule, we're dropping the feature for
	  specifying channel variables in the origination request. We will
	  bring the feature back soon, as a backward compatible addition to
	  the API. (closes issue ASTERISK-23051) Review:
	  https://reviewboard.asterisk.org/r/3088

2013-12-20  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 12.0.0 Released.

2013-12-20 22:02 +0000 [r404509]  David M. Lee <dlee@digium.com>

	* rest-api/api-docs/channels.json, res/ari/resource_channels.c,
	  res/res_ari_channels.c, res/ari/resource_channels.h,
	  rest-api/api-docs/applications.json: ari: Remove support for
	  specifying channel vars during origination. When we added support
	  for specifying channel variables for an origination, we didn't
	  consider how that would interact with another feature, namely
	  specifying request parameters in a JSON request body. The method
	  of specifying channel variables (as a flat JSON object passed in
	  the JSON body) interferes with parsing parameters out of the
	  request body. Unfortunately, fixing this would be a backward
	  incompatible change. In the interest of keeping the API sane and
	  keeping our release schedule, we're dropping the feature for
	  specifying channel variables in the origination request. We will
	  bring the feature back soon, as a backward compatible addition to
	  the API. (closes issue ASTERISK-23051) Review:
	  https://reviewboard.asterisk.org/r/3088

2013-12-20 21:25 +0000 [r404480-404488]  Matthew Jordan <mjordan@digium.com>

	* /: Remove automerge properties

	* res/res_pjsip/pjsip_cli.c (added), include/asterisk/sorcery.h,
	  res/res_pjsip/pjsip_configuration.c,
	  res/res_pjsip/include/res_pjsip_private.h,
	  res/res_pjsip_registrar.c, main/sorcery.c,
	  include/asterisk/res_pjsip.h, CREDITS,
	  res/res_pjsip/config_auth.c, /,
	  res/res_pjsip_endpoint_identifier_ip.c,
	  include/asterisk/config.h, main/config.c, main/channel.c,
	  res/res_pjsip/location.c, include/asterisk/res_pjsip_cli.h
	  (added): res_pjsip: Add PJSIP CLI commands Implements the
	  following cli commands: pjsip list aors pjsip list auths pjsip
	  list channels pjsip list contacts pjsip list endpoints pjsip show
	  aor(s) pjsip show auth(s) pjsip show channels pjsip show
	  endpoint(s) Also... Minor modifications made to the AMI command
	  implementations to facilitate reuse. New function
	  ast_variable_list_sort added to config.c and config.h to
	  implement variable list sorting. (issue ASTERISK-22610) patches:
	  pjsip_cli_v2.patch uploaded by george.joseph (License 6322)

2013-12-20 21:16 +0000 [r404458]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, main/say.c: say.c: correct time for polish In
	  ast_say_date_with_format_pl(), change ast_say_number() to use
	  tm_sec instead of tm_mn. (closes issue ASTERISK-22856) Reported
	  by: Robert Mordec Review:
	  https://reviewboard.asterisk.org/r/3082/ Patches: say.c.patch
	  uploaded by veilen (license 6555) ........ Merged revisions
	  404456 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 404457 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-20 20:11 +0000 [r404439]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip_refer.c: Fix issue where PJSIP blind transferer
	  dialog may not complete as planned. When transferring to a
	  dialplan extension that will not place any outbound calls, the
	  only control frames that the PJSIP REFER framehook will receive
	  are inconsequential (such as unhold or srcchange). As such, we
	  shouldn't allow for the reception of those types of frames
	  prevent us from signaling to the transferring party that the
	  transfer has completed successfully once voice frames are read.
	  Thanks to Jonathan Rose for pointing this out.

2013-12-20 20:04 +0000 [r404437]  Matthew Jordan <mjordan@digium.com>

	* res/ari/resource_applications.h, res/res_stasis_device_state.c:
	  res_stasis_device_state: Set resource type for subscriptions to
	  deviceState The documentation for ARI already specifies that the
	  device state resource when used for subscribing for events is
	  "deviceState", not "device_state". The code, however, used
	  "device_state"; although this was inconsistent as well in doxygen
	  comments in resource_applications. Because the actual resource
	  being subscribed to is /deviceStates/{device}/, it makes sense
	  for the resource type specifier to be deviceState. Note that the
	  key value in the events is still "device_state".

2013-12-20 19:52 +0000 [r404434]  Richard Mudgett <rmudgett@digium.com>

	* res/res_pjsip/location.c, tests/test_cel.c,
	  res/ari/resource_channels.c, tests/test_scoped_lock.c,
	  tests/test_stasis.c, res/parking/parking_manager.c,
	  res/ari/resource_bridges.c, res/ari/resource_endpoints.c:
	  ao2_iterator: Mini-audit of the ao2_iterator loops in the new
	  code files. * Fixed several places where ao2_iterator_destroy()
	  was not called. * Fixed several iterator loop object variable
	  reference problems. * Fixed res_parking AMI actions returning
	  non-zero. Only the AMI logoff action can return non-zero. Review:
	  https://reviewboard.asterisk.org/r/3087/

2013-12-20 19:17 +0000 [r404421]  Matthew Jordan <mjordan@digium.com>

	* include/asterisk/manager.h: manager: bump version to 2.0.0 AMI
	  has received substantial updates over the past year. Not only has
	  the syntax been vastly improved and made consistent (which
	  entails many event changes), but the underlying things that those
	  events convey have changed substantially as well. After some
	  conversation in #asterisk-dev, it was agreed that this is a good
	  time to jump to 2. At the same time, since ARI will most likely
	  use semantic versioning, we might as well use that for AMI as
	  well. That also affords us greater meaning for the AMI version.

2013-12-20 19:06 +0000 [r404419]  Richard Mudgett <rmudgett@digium.com>

	* main/sounds_index.c: Whitespace fixes.

2013-12-20 17:21 +0000 [r404405]  Rusty Newton <rnewton@digium.com>

	* configs/pjsip.conf.sample: Documentation: Updates for info about
	  NAT-related settings and fixes for pjsip.conf.sample Added
	  another NAT example to pjsip.conf.sample. We had a few mentions
	  of NAT configuration throughout the sample, but I added another
	  for a little bit more clarity. Additionally many pjsip options
	  were affected by the change to snake case, so I fixed any
	  instances of those options in pjsip.conf. I regenerated the
	  config option list (at the bottom of the file) from a new xml
	  config doc dump, so all the snake case changes should be
	  reflected there, as well as any other changes to those options.
	  (issue ASTERISK-23004) (closes issue ASTERISK-23004) Reported by:
	  Matt Jordan Review: https://reviewboard.asterisk.org/r/3086/

2013-12-19 18:15 +0000 [r404375]  Richard Mudgett <rmudgett@digium.com>

	* CHANGES: Put notice in CHANGES as well as UPGRADE.txt.

2013-12-19 17:58 +0000 [r404369-404371]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip/pjsip_outbound_auth.c: res_pjsip: Ignore 401/407
	  responses for transactions and dialogs we don't know about. Under
	  normal conditions it is unlikely we will ever receive a response
	  for a transaction or dialog we don't know about but if any are
	  received ignore them.

	* res/res_pjsip_session.c: res_pjsip_session: Fix SDP negotiation
	  when resending an INVITE with authentication. The process for
	  resending an INVITE with authentication involves restarting the
	  UAC session. We were incorrectly passing in that a new offer is
	  being sent, causing the SDP negotiation to get into a
	  (technically speaking) funky state.

2013-12-19 17:15 +0000 [r404356]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/channel.h, res/res_pjsip.c, main/channel.c,
	  include/asterisk/autochan.h: Fix a deadlock that occurred due to
	  a conflict of masquerades. For the explanation, here is a
	  copy-paste of the review board explanation: Initially, it was
	  discovered that performing an attended transfer of a multiparty
	  bridge with a PJSIP channel would cause a deadlock. A PBX thread
	  started a masquerade and reached the point where it was calling
	  the fixup() callback on the "original" channel. For chan_pjsip,
	  this involves pushing a synchronous task to the session's
	  serializer. The problem was that a task ahead of the fixup task
	  was also attempting to perform a channel masquerade. However,
	  since masquerades are designed in a way to only allow for one to
	  occur at a time, the task ahead of the fixup could not continue
	  until the masquerade already in progress had completed. And of
	  course, the masquerade in progress could not complete until the
	  task ahead of the fixup task had completed. Deadlock. The initial
	  fix was to change the fixup task to be asynchronous. While this
	  prevented the deadlock from occurring, it had the frightful side
	  effect of potentially allowing for tasks in the session's
	  serializer to operate on a zombie channel. Taking a step back
	  from this particular deadlock, it became clear that the problem
	  was not really this one particular issue but that masquerades
	  themselves needed to be addressed. A PJSIP attended transfer
	  operation calls ast_channel_move(), which attempts to both set up
	  and execute a masquerade. The problem was that after it had set
	  up the masquerade, the PBX thread had swooped in and tried to
	  actually perform the masquerade. Looking at changes that had been
	  made to Asterisk 12, it became clear that there never is any time
	  now that anyone ever wants to set up a masquerade and allow for
	  the channel thread to actually perform the masquerade. Everyone
	  always is calling ast_channel_move(), performs the masquerade
	  itself before returning. In this patch, I have removed all blocks
	  of code from channel.c that will attempt to perform a masquerade
	  if ast_channel_masq() returns true. Now, there is no distinction
	  between setting up a masquerade and performing the masquerade. It
	  is one operation. The only remaining checks for
	  ast_channel_masq() and ast_channel_masqr() are in ast_hangup()
	  since we do not want to interrupt a masquerade by hanging up the
	  channel. Instead, now ast_hangup() will wait for a masquerade to
	  complete before moving forward with its operation. The
	  ast_channel_move() function has been modified to basically
	  in-line the logic that used to be in ast_channel_masquerade().
	  ast_channel_masquerade() has been killed off for real.
	  ast_channel_move() now has a lock associated with it that is used
	  to prevent any simultaneous moves from occurring at once. This
	  means there is no need to make sure that ast_channel_masq() or
	  ast_channel_masqr() are already set on a channel when
	  ast_channel_move() is called. It also means the channel container
	  lock is not pulling double duty by both keeping the container
	  locked and preventing multiple masquerades from occurring
	  simultaneously. The ast_do_masquerade() function has been renamed
	  to do_channel_masquerade() and is now internal to channel.c. The
	  function now takes explicit arguments of which channels are
	  involved in the masquerade instead of a single channel. While it
	  probably is possible to do some further refactoring of this
	  method, I feel that I would be treading dangerously. Instead, all
	  I did was change some comments that no longer are true after this
	  changeset. The other more minor change introduced in this patch
	  is to res_pjsip.c to make ast_sip_push_task_synchronous() run the
	  task in-place if we are already a SIP servant thread. This is
	  related to this patch because even when we isolate the channel
	  masquerade to only running in the SIP servant thread, we would
	  still deadlock when the fixup() callback is reached since we
	  would essentially be waiting forever for ourselves to finish
	  before actually running the fixup. This makes it so the fixup is
	  run without having to push a task into a serializer at all.
	  (closes issue ASTERISK-22936) Reported by Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/3069

2013-12-19 17:03 +0000 [r404354]  Richard Mudgett <rmudgett@digium.com>

	* main/udptl.c, addons/chan_ooh323.c, channels/chan_sip.c,
	  include/asterisk/udptl.h: udptl: Dead code elimination.
	  ast_udptl_bridge was not used. Removing dead code starting with
	  ast_udptl_bridge() eliminated the code in this change. Note: This
	  code has actually been dead since Asterisk v1.4 when it was first
	  put in. Review: https://reviewboard.asterisk.org/r/3079/

2013-12-19 17:02 +0000 [r404352]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, res/res_fax.c: res_fax.c: crash on framehook with no dsp in
	  fax detect In fax_detect_framehook() a null pointer reference can
	  occur where a voice frame is processed but no dsp is attached to
	  the fax detection structure. The code block that rejects frames
	  that detection cannot be processed on is checking for dsp but
	  falls through when it should instead return, as this change
	  implements. (closes issue ASTERISK-22942) Reported by: adomjan
	  Review: https://reviewboard.asterisk.org/r/3076/ ........ Merged
	  revisions 404351 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-19 16:37 +0000 [r404348]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.h, channels/chan_h323.c, main/app.c,
	  configs/sip.conf.sample, channels/sip/include/sip.h,
	  channels/chan_mgcp.c, apps/app_voicemail.c,
	  channels/chan_unistim.c, configs/chan_dahdi.conf.sample,
	  channels/chan_sip.c, configs/voicemail.conf.sample,
	  funcs/func_vmcount.c, UPGRADE.txt, res/res_xmpp.c,
	  configs/skinny.conf.sample, res/res_jabber.c, CHANGES,
	  channels/chan_iax2.c, channels/h323/chan_h323.h,
	  channels/sig_pri.c, configs/iax.conf.sample, channels/sig_pri.h,
	  include/asterisk/app.h, channels/chan_dahdi.c,
	  channels/chan_skinny.c: Voicemail: Remove mailbox identifier
	  format (box@context) assumptions in the system. This change is in
	  preparation for external MWI support. Removed code from the
	  system for normal mailbox handling that appends @default to the
	  mailbox identifier if it does not have a context. The only
	  exception is the legacy hasvoicemail users.conf option. The
	  legacy option will only work for app_voicemail mailboxes. The
	  system cannot make any assumptions about the format of the
	  mailbox identifer used by app_voicemail. chan_sip and
	  chan_dahdi/sig_pri had the most changes because they both tried
	  to interpret the mailbox identifier. chan_sip just stored and
	  compared the two components. chan_dahdi actually used the box
	  information. The ISDN MWI support configuration options had to be
	  reworked because chan_dahdi was parsing the box@context format to
	  get the box number. As a result the mwi_vm_boxes chan_dahdi.conf
	  option was added and is documented in the chan_dahdi.conf.sample
	  file. Review: https://reviewboard.asterisk.org/r/3072/

2013-12-19 16:31 +0000 [r404345]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, main/db.c: astdb: crash in sqlite3 during shutdown When
	  Asterisk is shut down, the astdb_atexit() function releases
	  (finalize) the previously initiated (prepared) SQL statements in
	  sqlite3. Another thread making a subsequent request can cause a
	  crash in sqlite3. This patch eliminates that issue by resetting
	  the statement pointer after it is released/cleared. The sqlite3
	  code detects the null pointer, and aborts the operation cleanly.
	  (closes issue AST-1265) Reported by: Alexander Hömig (closes
	  issue ASTERISK-22350) Reported by: Birger "WIMPy" Harzenetter
	  Review: https://reviewboard.asterisk.org/r/3078/ ........ Merged
	  revisions 404344 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-19 12:17 +0000 [r404332]  Joshua Colp <jcolp@digium.com>

	* main/channel.c: channel: Add a missing ast_channel_unlock when
	  allocating a Surrogate channel.

2013-12-19 08:19 +0000 [r404320]  Alexandr Anikin <may@telecom-service.ru>

	* addons/ooh323c/src/oochannels.c, addons/ooh323c/src/ooGkClient.c,
	  addons/chan_ooh323.c, /, addons/ooh323c/src/ooGkClient.h: Handle
	  temporary failures on gk registration Introduce new 'stopped'
	  state for gk client and restart gk client on failures Remove
	  ooh323 stack command lock as it is not need now. (closes issue
	  ASTERISK-21960) Reported by: Dmitry Melekhov Patches:
	  ASTERISK-21960.patch ASTERISK-21960-stacklockup-2.patch Tested
	  by: Dmitry Melekhov ........ Merged revisions 404318 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-19 02:53 +0000 [r404306]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Fixup some skinny bugs causing Fracks and
	  ao2 cleanup issues. Moved channel locking into setsubstate so
	  that a process can complete working on a sub before another
	  starts changing it. The existing code was causing some Fracks
	  with schedule deletion. Removed multiple rtp cleanup. Now only
	  cleansup up once, fixing ao2 object cleanup issues.

2013-12-19 00:47 +0000 [r404294]  Matthew Jordan <mjordan@digium.com>

	* apps/app_cdr.c, main/cdr.c, apps/app_forkcdr.c, main/pbx.c,
	  funcs/func_cdr.c, apps/app_disa.c, UPGRADE.txt,
	  include/asterisk/cdr.h, CHANGES: app_cdr,app_forkcdr,func_cdr:
	  Synchronize with engine when manipulating state When doing the
	  rework of the CDR engine that pushed all of the logic into cdr.c
	  and made it respond to changes in channel state over Stasis, we
	  knew that accessing the CDR engine from the dialplan would be
	  "slightly" non-deterministic. Dialplan threads would be accessing
	  CDRs while Stasis threads would be updating the state of said
	  CDRs - whereas in the past, everything happened on the dialplan
	  threads. Tests have shown that "slightly" is in reality "very".
	  This patch synchronizes things by making the dialplan
	  applications/functions that manipulate CDRs do so over Stasis.
	  ForkCDR, NoCDR, ResetCDR, CDR, and CDR_PROP now all use Stasis to
	  send their requests over to the CDR engine, and synchronize on
	  the channel Stasis topic via a subscription so that they return
	  their values/control to the dialplan at the appropriate time.
	  While going through this, the following changes were also made: *
	  DISA, which can reset the CDR when a user successfully
	  authenticates, now just uses the ResetCDR app to do this. This
	  prevents having to duplicate the same Stasis synchronization
	  logic in that application. * Answer no longer disables CDRs. It
	  actually didn't work anyway - calling DISABLE on the channel's
	  CDR doesn't stop the CDR from getting the Answer time - it just
	  kills all CDRs on that channel, which isn't what the caller would
	  intend. (closes issue ASTERISK-22884) (closes issue
	  ASTERISK-22886) Review: https://reviewboard.asterisk.org/r/3057/

2013-12-19 00:29 +0000 [r404292]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Fixup skinny registration following
	  network issues. On session registration, if device is already
	  reporting that it is connected to a device, an innocuous packet
	  (update time) is sent to the already connected device. If the tcp
	  connection is down, the device will be unregistered and the new
	  connection allowed. Without this patch, network issues can see a
	  situation where a device can not reregister until after
	  3*timeout.

2013-12-18 22:50 +0000 [r404279]  Jason Parker <jparker@digium.com>

	* main/manager.c, /: Add AMI event for presence state. Review:
	  https://reviewboard.asterisk.org/r/3039/ ........ Merged
	  revisions 404275 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-18 20:57 +0000 [r404263]  Richard Mudgett <rmudgett@digium.com>

	* addons/ooh323c/src/ooTimer.c, /: ooh323c: Fix gcc 4.6.3 compiler
	  warnings. ........ Merged revisions 404212 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404219 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-18 20:46 +0000 [r404237-404261]  Kevin Harwell <kharwell@digium.com>

	* channels/chan_oss.c: chan_oss.c: channel being locked twice and
	  unlocked once Removed channel lock as it is now being down in
	  ast_channel_alloc

	* main/pickup.c, include/asterisk/aoc.h,
	  include/asterisk/stasis_bridges.h, apps/app_disa.c,
	  apps/app_userevent.c, include/asterisk/channelstate.h,
	  channels/chan_console.c, main/core_local.c, channels/chan_iax2.c,
	  main/endpoints.c, channels/chan_oss.c,
	  res/parking/parking_bridge_features.c, apps/app_agent_pool.c,
	  main/channel.c, channels/chan_misdn.c, channels/chan_skinny.c,
	  pbx/pbx_realtime.c, channels/chan_alsa.c, main/stasis_channels.c,
	  main/bridge_channel.c, addons/chan_mobile.c,
	  res/parking/parking_manager.c, channels/chan_pjsip.c,
	  tests/test_cdr.c, channels/chan_mgcp.c, channels/chan_unistim.c,
	  main/pbx.c, funcs/func_timeout.c, apps/app_meetme.c,
	  main/bridge.c, tests/test_stasis_channels.c,
	  include/asterisk/channel.h, channels/chan_gtalk.c, main/cel.c,
	  apps/app_queue.c, channels/sig_pri.c, main/stasis_bridges.c,
	  channels/chan_jingle.c, main/dial.c, channels/chan_dahdi.c,
	  channels/chan_phone.c, include/asterisk/stasis_channels.h,
	  channels/sig_analog.c, res/res_agi.c, channels/chan_motif.c,
	  tests/test_cel.c, apps/app_confbridge.c, res/res_stasis.c,
	  res/res_pjsip_refer.c, apps/app_voicemail.c, apps/app_dial.c,
	  channels/chan_vpb.cc, addons/chan_ooh323.c: channel locking: Add
	  locking for channel snapshot creation Original commit message by
	  mmichelson (asterisk 12 r403311): "This adds channel locks around
	  calls to create channel snapshots as well as other functions
	  which operate on a channel and then end up creating a channel
	  snapshot. Functions that expect the channel to be locked prior to
	  being called have had their documentation updated to indicate
	  such." The above was initially committed and then reverted at
	  r403398. The problem was found to be in core_local.c in the
	  publish_local_bridge_message function. The ast_unreal_lock_all
	  function locks and adds a reference to the returned channels and
	  while they were being unlocked they were not being unreffed when
	  no longer needed. Fixed by unreffing the channels. Also in
	  bridge.c a lock was obtained on "other->chan", but then an
	  attempt was made to unlock "other" and not the previously locked
	  channel. Fixed by unlocking "other->chan" (closes issue
	  ASTERISK-22709) Reported by: John Bigelow

2013-12-18 19:20 +0000 [r404204]  Joshua Colp <jcolp@digium.com>

	* main/channel.c, channels/chan_dahdi.c, channels/chan_phone.c,
	  channels/chan_skinny.c, res/parking/parking_tests.c,
	  tests/test_voicemail_api.c, channels/chan_motif.c,
	  channels/chan_alsa.c, main/message.c, addons/chan_mobile.c,
	  tests/test_cdr.c, channels/chan_mgcp.c, main/pbx.c,
	  channels/chan_sip.c, tests/test_app.c,
	  apps/confbridge/conf_chan_record.c, tests/test_stasis_channels.c,
	  main/core_unreal.c, include/asterisk/channel.h,
	  channels/chan_console.c, channels/chan_oss.c,
	  channels/chan_jingle.c, channels/chan_misdn.c,
	  channels/chan_h323.c, tests/test_cel.c, channels/chan_nbs.c,
	  channels/chan_pjsip.c, apps/app_voicemail.c, res/res_calendar.c,
	  channels/chan_unistim.c, tests/test_substitution.c,
	  addons/chan_ooh323.c, channels/chan_vpb.cc,
	  channels/chan_multicast_rtp.c, apps/app_meetme.c,
	  res/res_stasis_snoop.c, channels/chan_gtalk.c,
	  channels/chan_iax2.c: channels: Return allocated channels locked.
	  This change makes ast_channel_alloc return allocated channels
	  locked. By doing so no other thread can acquire, lock, and
	  manipulate the channel before it is completely set up. (closes
	  issue AST-1256) Review: https://reviewboard.asterisk.org/r/3067/

2013-12-18 12:36 +0000 [r404184]  Matthew Jordan <mjordan@digium.com>

	* rest-api/api-docs/bridges.json,
	  rest-api/api-docs/recordings.json,
	  rest-api/api-docs/deviceStates.json,
	  rest-api/api-docs/endpoints.json, rest-api/api-docs/events.json,
	  rest-api/api-docs/asterisk.json,
	  rest-api/api-docs/applications.json,
	  rest-api/api-docs/playbacks.json,
	  rest-api/api-docs/channels.json, rest-api/api-docs/sounds.json,
	  rest-api/resources.json: ari: Bump the version of ARI to 1.0.0
	  (closes issue ASTERISK-23007)

2013-12-18 12:00 +0000 [r404137]  Joshua Colp <jcolp@digium.com>

	* res/res_calendar.c, /: res_calendar: Protect channel when adding
	  datastore. This change adds a missing channel lock when adding a
	  datastore to a channel. ........ Merged revisions 404135 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404136 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-18 00:35 +0000 [r404099]  Rusty Newton <rnewton@digium.com>

	* /, funcs/func_strings.c: func_strings: Documentation fix for
	  QUOTE() Example output was inaccurate. (issue ASTERISK-22970)
	  (closes issue ASTERISK-22970) Reported by: Gareth Palmer Patches:
	  func_strings.patch uploaded by Gareth Palmer (license 5169)
	  ........ Merged revisions 404081 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 404087 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-18 00:16 +0000 [r404050]  Matthew Jordan <mjordan@digium.com>

	* LICENSE: LICENSE: Update language to include ARI

2013-12-17 23:50 +0000 [r404048]  Jonathan Rose <jrose@digium.com>

	* tests/test_cel.c, tests/test_cdr.c: tests: fix
	  ast_bridge_base_new calls not using the additional arguments
	  r404042 gave ast_bridge_base_new two new arguments for setting a
	  bridge creator and name. Unfortunately since a couple test
	  modules aren't compiled by default, I missed the fact that this
	  change impacted those tests and caused compilation failures
	  against them.

2013-12-17 23:36 +0000 [r404046]  Rusty Newton <rnewton@digium.com>

	* include/asterisk/test.h, main/channel.c, main/rtp_engine.c,
	  channels/chan_iax2.c, apps/app_chanspy.c, apps/app_mixmonitor.c:
	  Several components: fixing Typos in comments and code,
	  "avaliable" instead of "available" (issue ASTERISK-23021) (closes
	  issue ASTERISK-23021) Reported by: Jeremy Lainé Tested by: Rusty
	  Newton Patches: available.patch uploaded by Jeremy Lainé (license
	  6561)

2013-12-17 23:17 +0000 [r404042]  Jonathan Rose <jrose@digium.com>

	* include/asterisk/bridge_internal.h, apps/app_confbridge.c,
	  res/res_stasis.c, include/asterisk/bridge.h,
	  res/res_ari_bridges.c, main/bridge.c, main/bridge_basic.c,
	  include/asterisk/stasis_bridges.h, include/asterisk/stasis_app.h,
	  apps/app_bridgewait.c, res/ari/ari_model_validators.c,
	  doc/appdocsxml.xslt, main/stasis_bridges.c,
	  rest-api/api-docs/bridges.json, res/ari/resource_bridges.c,
	  apps/app_agent_pool.c, res/parking/parking_bridge.c,
	  res/ari/ari_model_validators.h, main/manager_bridges.c,
	  res/ari/resource_bridges.h: bridging: Give bridges a name and a
	  known creator Bridges have two new optional properties, a creator
	  and a name. Certain consumers of bridges will automatically
	  provide bridges that they create with these properties. Examples
	  include app_bridgewait, res_parking, app_confbridge, and
	  app_agent_pool. In addition, a name may now be provided as an
	  argument to the POST function for creating new bridges via ARI.
	  (closes issue AFS-47) Review:
	  https://reviewboard.asterisk.org/r/3070/

2013-12-17 18:34 +0000 [r404027-404029]  Joshua Colp <jcolp@digium.com>

	* res/res_sorcery_config.c: res_sorcery_config: Output an error
	  message when an object can't be created. If object creation fails
	  an error message will now be output with the id, type, and
	  configuration file.

	* main/framehook.c: framehooks: Re-iterate if framehook provides
	  different frame. Framehooks can be used in a reactive manner to
	  execute specific logic when a frame is received with a certain
	  type and payload. Since it is possible for framehooks to provide
	  frames it was possible for this reactive framehook to be unaware
	  of frames it is looking for. This change makes it so that when
	  framehooks return a modified frame the code will now re-iterate
	  (from the beginning) and call any previous framehooks that have
	  not provided a modified frame themselves. Review:
	  https://reviewboard.asterisk.org/r/3046/

2013-12-17 14:33 +0000 [r404006]  David M. Lee <dlee@digium.com>

	* configs/asterisk.conf.sample, main/asterisk.c: Changed the
	  default for live_dangerously to no

2013-12-17 12:51 +0000 [r403993]  Matthew Jordan <mjordan@digium.com>

	* res/ari/resource_channels.c: ari/resource_channels: When creating
	  a channel, specify a default format (SLIN) When creating channels
	  via ARI, the current code fails to provide any default format
	  capabilities. For non-virtual channels this isn't really a
	  problem - the channels typically receive their capabilities as a
	  result of the underlying channel driver configuration. For
	  virtual channels (such as Local channels), the lack of any format
	  capabilities causes the Asterisk core to make some 'odd' choices
	  with respect to the translation paths. The issue reporter had
	  some paths that had 3 hops on each channel leg, causing multiple
	  transcodings and some really crappy audio/performance. By
	  specifying a baseline of SLIN, we prevent that from occurring.
	  Note that this is what AMI does when it performs an Originate, as
	  does res_clioriginate. Review:
	  https://reviewboard.asterisk.org/r/3068/ (issue ASTERISK-22962)
	  Reported by: Matt DiMeo

2013-12-16 18:31 +0000 [r403959]  David M. Lee <dlee@digium.com>

	* UPGRADE.txt, include/asterisk/pbx.h, main/asterisk.c,
	  funcs/func_realtime.c, main/pbx.c, main/tcptls.c,
	  funcs/func_db.c, /, README-SERIOUSLY.bestpractices.txt,
	  configs/asterisk.conf.sample, funcs/func_shell.c,
	  funcs/func_env.c, funcs/func_lock.c: security: Inhibit execution
	  of privilege escalating functions This patch allows individual
	  dialplan functions to be marked as 'dangerous', to inhibit their
	  execution from external sources. A 'dangerous' function is one
	  which results in a privilege escalation. For example, if one were
	  to read the channel variable SHELL(rm -rf /) Bad Things(TM) could
	  happen; even if the external source has only read permissions.
	  Execution from external sources may be enabled by setting
	  'live_dangerously' to 'yes' in the [options] section of
	  asterisk.conf. Although doing so is not recommended. Also, the
	  ABI was changed to something more reasonable, since Asterisk 12
	  does not yet have a public release. (closes issue ASTERISK-22905)
	  Review: http://reviewboard.digium.internal/r/432/ ........ Merged
	  revisions 403913 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 403917 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-16 18:22 +0000 [r403957]  Jonathan Rose <jrose@digium.com>

	* main/bridge.c: transfers: Fix bug setting both BLINDTRANSFER and
	  ATTENDEDTRANSFER The ast_bridge_set_transfer_variables function
	  is supposed to wipe whichever variable isn't being set. Instead
	  it was setting both to the new value. Oops. (issue AFS-24)

2013-12-16 16:11 +0000 [r403856-403864]  Scott Griepentrog <sgriepentrog@digium.com>

	* main/pbx.c, /: pbx.c: put copy of ast_exten.data on stack to
	  prevent memory corruption During dialplan execution in
	  pbx_extension_helper(), the contexts global read lock prevents
	  link list corruption, but was released with a pointer to the
	  ast_exten and data later used in variable substitution. Instead,
	  this patch removes pbx_substitute_variables() and locates a copy
	  of the ast_exten data on the stack before releasing the lock,
	  where ast_exten could get free'd by another thread performing a
	  module reload. (issue AST-1179) Reported by: Thomas Arimont
	  (issue AST-1246) Reported by: Alexander Hömig Review:
	  https://reviewboard.asterisk.org/r/3055/ ........ Merged
	  revisions 403862 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 403863 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* apps/app_sms.c: app_sms: BufferOverflow when receiving odd length
	  16 bit message This patch prevents an infinite loop overwriting
	  memory when a message is received into the unpacksms16()
	  function, where the length of the message is an odd number of
	  bytes. (closes issue ASTERISK-22590) Reported by: Jan Juergens
	  Tested by: Jan Juergens

2013-12-15 01:38 +0000 [r403823]  Matthew Jordan <mjordan@digium.com>

	* channels/pjsip/dialplan_functions.c: pjsip/dialplan_functions:
	  Use the right buffer length when printing URIs While
	  entertaining, sizeof(buflen) is not the same as buflen. Doh.

2013-12-14 17:25 +0000 [r403808-403811]  Joshua Colp <jcolp@digium.com>

	* include/asterisk/res_pjsip.h, res/res_pjsip/location.c,
	  res/res_pjsip/pjsip_options.c, res/res_pjsip.c: res_pjsip: Apply
	  outbound proxy to all SIP requests. Objects which are involved in
	  SIP request creation and sending now allow an outbound proxy to
	  be specified. For cases where an endpoint is used the outbound
	  proxy specified there will be applied. (closes issue
	  ASTERISK-22673) Reported by: Antti Yrjola Review:
	  https://reviewboard.asterisk.org/r/3022/

	* main/stasis_channels.c, apps/app_queue.c,
	  res/ari/ari_model_validators.c, apps/app_dial.c,
	  res/ari/ari_model_validators.h, main/dial.c,
	  include/asterisk/stasis_channels.h,
	  rest-api/api-docs/events.json, res/stasis/app.c: res_stasis:
	  Expose event for call forwarding and follow forwarded channel.
	  This change adds an event for when an originated call is
	  redirected to another target. This event contains the original
	  channel and the newly created channel. If a stasis subscription
	  exists on the original originated channel for a stasis
	  application then a new subscription will also be created on the
	  stasis application to the redirected channel. This allows the
	  application to follow the call path completely. (closes issue
	  ASTERISK-22719) Reported by: Joshua Colp Review:
	  https://reviewboard.asterisk.org/r/3054/

2013-12-13 21:24 +0000 [r403796]  Jonathan Rose <jrose@digium.com>

	* res/res_pjsip_messaging.c, main/message.c: documentation: Add
	  PJSIP technology to messaging documentation

2013-12-13 20:06 +0000 [r403782]  Richard Mudgett <rmudgett@digium.com>

	* main/test.c: test.c: Fix too sticky unit test failed status.
	  Rerunning a failed unit test after loading any required modules
	  should allow the test to report a pass status if it now passes.

2013-12-13 20:04 +0000 [r403781]  Jonathan Rose <jrose@digium.com>

	* include/asterisk/bridge.h, res/parking/parking_bridge_features.c,
	  res/parking/parking_manager.c, main/bridge.c,
	  main/bridge_basic.c: Transfers: Make Asterisk set
	  ATTENDEDTRANSFER/BLINDTRANSFER more reliably There were still a
	  few cases in which ATTENDEDTRANSFER and BLINDTRANSFER wouldn't be
	  set on channels involved with blind and attended transfers. This
	  would happen with features that were initialized by channel
	  driver specific mechanisms in multiparty calls. This patch
	  resolves those cases while attempted to keep the behavior for
	  setting those variables as consistent as possible. (closes issue
	  AFS-24) Review: https://reviewboard.asterisk.org/r/3040/

2013-12-13 19:55 +0000 [r403779-403780]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/app.h, tests/test_voicemail_api.c, main/app.c:
	  test_voicemail_api: Add check for a registered voicemail provider
	  before tests. It is much nicer diagnosing a test failure if
	  app_voicemail is actually loaded. ........ Merged revisions
	  403726 from http://svn.asterisk.org/svn/asterisk/trunk

	* main/app.c, apps/app_voicemail.c, include/asterisk/app.h,
	  include/asterisk/doxyref.h: app_voicemail: Voicemail callback
	  registration/unregistration function improvements. * The
	  voicemail registration/unregistration functions now take a struct
	  of callbacks instead of a lengthy parameter list of callbacks. *
	  The voicemail registration/unregistration functions now prevent a
	  competing module from interfering with an already registered
	  callback supplying module. ........ Merged revisions 403643 from
	  http://svn.asterisk.org/svn/asterisk/trunk

2013-12-13 18:24 +0000 [r403749-403767]  Kevin Harwell <kharwell@digium.com>

	* channels/chan_sip.c, include/asterisk/channel.h,
	  bridges/bridge_native_rtp.c, channels/chan_pjsip.c,
	  main/channel.c: bridge_native_rtp: Deadlock during 4-way
	  conference creation The change contains a slightly adjusted patch
	  that was on the issue (submitted by kmoore). A fix was made by
	  adding in a bridge lock while calling bridge_start/stop from the
	  framehook callback. Since the framehook callback is not called
	  from the bridging core the bridge is not locked, but needs to be
	  before calling bridge_start. (closes issue ASTERISK-22749)
	  Reported by: Kinsey Moore Review:
	  https://reviewboard.asterisk.org/r/3066/ Patches:
	  lock_inversion.diff uploaded by kmoore (license 6273)

	* main/http.c, rest-api/api-docs/channels.json,
	  res/ari/resource_channels.c, res/res_ari_channels.c,
	  res/ari/resource_channels.h: ARI: Allow specifying channel
	  variables during a POST /channels Added the ability to specify
	  channel variables when creating/originating a channel in ARI. The
	  variables are sent in the body of the request and should be
	  formatted as a single level JSON object. No nested objects
	  allowed. For example: {"variable1": "foo", "variable2": "bar"}.
	  (closes issue ASTERISK-22872) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/3052/

	* res/res_ari_bridges.c, res/stasis/command.c,
	  res/res_stasis_playback.c, res/stasis/control.c,
	  res/stasis/command.h, include/asterisk/stasis_app.h,
	  include/asterisk/stasis_app_impl.h, res/res_stasis_recording.c,
	  res/res_stasis_answer.c, rest-api/api-docs/bridges.json,
	  res/ari/resource_bridges.c: ARI: Adding a channel to a bridge
	  while a live recording is active blocks Added the ability to have
	  rules that are checked when adding and/or removing channels
	  to/from a bridge. In this case, if a channel is currently
	  recording and someone attempts to add it to a bridge an "is
	  recording" rule is checked, fails, and a 409 conflict is
	  returned. Also command functions now return an integer value that
	  can be descriptive of what kind of problems, if any, occurred
	  before or during execution. (closes issue ASTERISK-22624)
	  Reported by: Joshua Colp Review:
	  https://reviewboard.asterisk.org/r/2947/

2013-12-13 16:27 +0000 [r403748]  David M. Lee <dlee@digium.com>

	* channels/pjsip: Setting svn:ignore

2013-12-13 05:00 +0000 [r403736]  Matthew Jordan <mjordan@digium.com>

	* channels/Makefile: channels/Makefile: clean pjsip directory

2013-12-12 19:44 +0000 [r403713]  Scott Griepentrog <sgriepentrog@digium.com>

	* contrib/ast-db-manage/config/versions/581a4264e537_adding_extensions.py
	  (added): realtime: Create extensions in alembic ast-db-manage
	  contribution When the alembic scripts were written for creating
	  Asterisk realtime databases the extensions table for dialplan
	  wasn't included. This update creates the extensions table.
	  (closes issue ASTERISK-22815) Reported by: Zone Conkle Review:
	  https://reviewboard.asterisk.org/r/3064/

2013-12-12 19:12 +0000 [r403705]  Jonathan Rose <jrose@digium.com>

	* channels/chan_pjsip.c: chan_pjsip: Revert r403587 This patch was
	  intended to eliminate a deadlock that occurs when masquerades
	  occur in pjsip channels, but has some potential side effects.
	  Mark Michelson is currently working on addressing this problem
	  from another angle. (issue ASTERISK-22936) Reported by: Jonathan
	  Rose

2013-12-11 20:11 +0000 [r403680]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip/pjsip_configuration.c, res/res_pjsip_messaging.c,
	  res/res_pjsip/include/res_pjsip_private.h, res/res_pjsip.c,
	  include/asterisk/res_pjsip.h, res/res_pjsip/config_global.c,
	  configs/pjsip.conf.sample: res_pjsip_messaging: send message to a
	  default outbound endpoint In some cases messages need to be sent
	  to a direct URI (sip:<ip address>). This patch adds in that
	  support by using a default outbound endpoint. When sending
	  messages, if no endpoint can be found then the default one is
	  used. To facilitate this a new default_outbound_endpoint option
	  was added to the globals section for pjsip.conf. Review:
	  https://reviewboard.asterisk.org/r/2944/

2013-12-11 19:18 +0000 [r403639]  Russell Bryant <russell@russellbryant.com>

	* /, channels/chan_sip.c: Reset peer outboundproxy on sip.conf
	  reload If you set a peer's outboundproxy and then removed it from
	  the config, this would not get picked up in a config reload. This
	  patch fixes that by resetting it in set_peer_defaults(). Closes
	  ASTERISK-19454 Review: https://reviewboard.asterisk.org/r/3065/
	  ........ Merged revisions 403634 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 403635 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-11 13:05 +0000 [r403616-403618]  Matthew Jordan <mjordan@digium.com>

	* funcs/func_channel.c, channels/pjsip/include (added),
	  channels/pjsip/include/dialplan_functions.h (added),
	  res/res_pjsip_t38.c, channels/pjsip/include/chan_pjsip.h (added),
	  channels/Makefile, channels/chan_pjsip.c, main/xmldoc.c,
	  channels/pjsip/dialplan_functions.c (added),
	  include/asterisk/res_pjsip_session.h, channels/pjsip (added):
	  func_channel, chan_pjsip: Add CHANNEL read function support for
	  chan_pjsip This patch adds CHANNEL read support for chan_pjsip.
	  This allows the dialplan to use the CHANNEL function on a
	  chan_pjsip channel to obtain run-time information about the
	  channel from the PJSIP channel driver and the PJSIP stack. This
	  includes: * RTP information, including source/destination media
	  addresses, whether or not the media is secure, held, and other
	  properties. * RTCP information. This includes sets of parseable
	  information, as well as individual statistic attriutes. * PJSIP
	  information. This includes URIs, local/remote signalling
	  addresses, whether or not the signalling is secure, and other
	  properties. * The endpoint name. This can be used in conjunction
	  with the PJSIP_ENDPOINT function to obtain more detailed endpoint
	  information. Review: https://reviewboard.asterisk.org/r/3038/

	* Makefile, funcs/func_pjsip_endpoint.c (added), doc/snapshots.xslt
	  (removed), doc/appdocsxml.xslt (added), doc/appdocsxml.dtd,
	  main/sorcery.c: func_pjsip_endpoint: Add PJSIP_ENDPOINT function
	  for querying endpoint details This patch adds a new function,
	  PJSIP_ENDPOINT, which lets the dialplan query, for any endpoint,
	  any property configured on an endpoint. This function is a
	  companion to the CHANNEL function, which can be used to extract
	  the endpoint name for a channel. Review:
	  https://reviewboard.asterisk.org/r/3035

2013-12-09 22:47 +0000 [r403587]  Jonathan Rose <jrose@digium.com>

	* channels/chan_pjsip.c: chan_pjsip: Fix a sticking channel lock
	  caused by channel masquerades (closes issue ASTERISK-22936)
	  Reported by: Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/3042/

2013-12-09 19:23 +0000 [r403545-403559]  Richard Mudgett <rmudgett@digium.com>

	* res/res_sorcery_astdb.c: Reverting regex part of -r403545 at
	  request of file. res_sorcery_astdb.c: Fix get multiple records by
	  regex. * Fix sorcery_astdb_retrieve_regex() pattern matching. Let
	  the regexec() function match the stored key values instead of
	  having astdb prefilter them. Previoiusly you could only use a
	  simple regex pattern when the pattern began with '^'.

	* res/res_sorcery_astdb.c: res_sorcery_astdb.c: Fix get multiple
	  records by regex. * Fix sorcery_astdb_retrieve_regex() pattern
	  matching. Let the regexec() function match the stored key values
	  instead of having astdb prefilter them. Previoiusly you could
	  only use a simple regex pattern when the pattern began with '^'.
	  * Fix off nominal memory leak in sorcery_astdb_retrieve_regex().

2013-12-09 18:31 +0000 [r403542]  Joshua Colp <jcolp@digium.com>

	* main/endpoints.c: endpoints: Keep a reference to channel ids when
	  creating snapshot. The snapshot process for endpoints uses the
	  channel ids present on the endpoint itself. Without keeping a
	  reference it was possible for the strings to be freed underneath
	  any consumer of an endpoint snapshot. A reference is now held by
	  the snapshot to the channel ids and released when the snapshot is
	  destroyed. (issue ASTERISK-22801) Reported by: Matt Jordan

2013-12-09 18:31 +0000 [r403527-403541]  Richard Mudgett <rmudgett@digium.com>

	* main/sorcery.c: sorcery: Eliminate shadowing a varaible that
	  caused confusion. * Eliminated shadowing of the
	  __ast_sorcery_apply_config() name parameter causing confusion. *
	  Fix potential crash from sorcery.conf user input in
	  __ast_sorcery_apply_config() if the user supplied a malformed
	  config line that is missing the sorcery object type name. *
	  Remove redundant test in __ast_sorcery_apply_config(). !config
	  and config == CONFIGS_STATUS_FILEMISSING are identical.

	* main/sorcery.c: sorcery: Whitespace You would think that a new
	  file would start off without any whitespace oddities.

2013-12-09 16:40 +0000 [r403510]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_nat.c: res_pjsip_nat: Add NAT module to session
	  dialogs. Due to the way pjproject internally works it was
	  possible for the NAT module to not be invoked on messages with-in
	  a session dialog. This means that the various parts of the
	  message would not get rewritten with the source IP address and
	  port. This change uses a session supplement to add the NAT module
	  to the dialog on the first incoming or outgoing INVITE. (closes
	  issue ASTERISK-22941) Reported by: Leif Madsen

2013-12-09 03:19 +0000 [r403435-403458]  Matthew Jordan <mjordan@digium.com>

	* res/res_fax_spandsp.c, /: res_fax_spandsp: Always init T.38
	  session to avoid crashes during state change Prior to this patch,
	  res_fax_spandsp was conservative with how it initialized the
	  spandsp T.38 context. It would only initialize it if the driver
	  thought the current state was a T.38 fax. While this works fine
	  in nominal situations, in certain off nominal situations,
	  res_fax_spandsp can believe that a T.38 fax will not occur when
	  in fact one has started. In particular, this was discovered when
	  res_fax would fall back to audio after timing out on a T.38
	  upgrade. The SIP channel driver would continue to retry the
	  re-INVITE and - if the remote end responded after res_fax timed
	  out with a 200 OK - a T.38 frame would be delivered to the
	  res_fax stack when it no longer expected it. As it turns out,
	  there does not appear to be any downside to always initializing
	  the T.38 context, other than the actual memory allocation. Since
	  that avoids this off nominal situation (and others which are
	  equally likely hard to predict), this is the safest way to avoid
	  this problem. Much thanks to Torrey as well for providing a
	  scenario that reproduces this issue. (closes issue
	  ASTERISK-21242) Reported by: Ashley Winters Tested by: Torrey
	  Searle patches: always-init-t38.patch uploaded by awinters
	  (License 6477) A_PARTY.xml uploaded by tsearle (License 5334)
	  ........ Merged revisions 403449 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 403450 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_config_sqlite.c: res_config_sqlite: Check for CDR
	  unregistration failures If the CDR unregistration fails due to an
	  inflight CDR, the res_config_sqlite module needs to bail on
	  unloading itself. Otherwise, the config could be unloaded
	  (including the CDR table name) while the CDR engine posts a CDR
	  to the still registered backend, resulting in a crash.

2013-12-05 20:49 +0000 [r403398]  David M. Lee <dlee@digium.com>

	* main/core_unreal.c, tests/test_stasis_channels.c,
	  include/asterisk/channel.h, channels/chan_gtalk.c,
	  channels/sig_pri.c, apps/app_queue.c, main/cel.c,
	  main/stasis_bridges.c, channels/chan_jingle.c,
	  channels/chan_phone.c, channels/chan_dahdi.c, main/dial.c,
	  include/asterisk/stasis_channels.h, channels/sig_analog.c,
	  channels/chan_motif.c, res/res_agi.c, channels/chan_h323.c,
	  tests/test_cel.c, apps/app_confbridge.c, res/res_stasis.c,
	  res/res_pjsip_refer.c, apps/app_voicemail.c, apps/app_dial.c,
	  channels/chan_vpb.cc, addons/chan_ooh323.c, channels/chan_sip.c,
	  main/pickup.c, include/asterisk/aoc.h,
	  include/asterisk/stasis_bridges.h, apps/app_disa.c,
	  apps/app_userevent.c, main/core_local.c, channels/chan_console.c,
	  include/asterisk/channelstate.h, channels/chan_iax2.c,
	  main/endpoints.c, channels/chan_oss.c,
	  res/parking/parking_bridge_features.c, apps/app_agent_pool.c,
	  main/channel.c, channels/chan_misdn.c, channels/chan_skinny.c,
	  channels/chan_alsa.c, pbx/pbx_realtime.c, main/stasis_channels.c,
	  channels/chan_nbs.c, main/bridge_channel.c, addons/chan_mobile.c,
	  channels/chan_pjsip.c, tests/test_cdr.c,
	  res/parking/parking_manager.c, channels/chan_mgcp.c,
	  channels/chan_unistim.c, main/pbx.c, funcs/func_timeout.c,
	  apps/app_meetme.c, main/bridge.c: Reverting r403311. It's causing
	  ARI tests to hang.

2013-12-04 21:41 +0000 [r403377]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_registrar.c: res_pjsip_registrar: undefined
	  function pointer symbol Used a static wrapper around the
	  offending function to alleviate the issue. Reported by: rmudgett

2013-12-04 20:53 +0000 [r403364]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_t38.c: res_pjsip_t38: Don't pass T.38 control
	  frames through to other hooks. This crept up during gateway
	  testing where the gateway would receive the request to negotiate
	  and assume it came from the remote side, causing the gateway
	  state machine to go a little, to a use a technical term, "wonky".

2013-12-04 18:40 +0000 [r403349]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip.c: Initialize the hash value argument to
	  pj_hash_get() to 0. Passing a non-zero value causes PJLIB to use
	  the given input as the hash value. Passing zero causes the
	  parameter to become an output parameter that receives the hash
	  value that was computed based on the given key. This change
	  essentially makes ast_sip_dict_get() properly retrieve the
	  desired value.

2013-12-03 20:17 +0000 [r403342]  David M. Lee <dlee@digium.com>

	* res/stasis/control.c: ari: Fix deadlock problem with functions
	  that use autoservice. The code for getting channel variables from
	  ARI assumed that you needed to lock the channel in order to
	  properly execute functions and read channel variables.
	  Apparently, this is not the case, since any dialplan function
	  that puts the channel into autoservice deadlocks when attempting
	  to remove the channel from autoservice.

2013-12-03 17:59 +0000 [r403329]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_session.c, configure,
	  include/asterisk/autoconfig.h.in, configure.ac:
	  res_pjsip_session: Add support for
	  PJMEDIA_SDP_NEG_ALLOW_MEDIA_CHANGE flag. Newer versions of PJSIP
	  have changed to using a flag for the
	  PJMEDIA_SDP_NEG_ALLOW_MEDIA_CHANGE instead of a define. This adds
	  a configure check to detect the presence of the flag and use it
	  if found.

2013-12-03 17:23 +0000 [r403324]  Richard Mudgett <rmudgett@digium.com>

	* main/bucket.c, include/asterisk/sorcery.h,
	  res/res_pjsip/pjsip_configuration.c,
	  res/res_pjsip_registrar_expire.c, res/res_pjsip/pjsip_options.c,
	  tests/test_sorcery.c, include/asterisk/bucket.h, main/sorcery.c:
	  sorcery, bucket: Change observer remove calls to take const
	  callbacks struct. * Make ast_sorcery_observer_remove() accept a
	  const callbacks struct. * Make ast_sorcery_observer_remove()
	  tolerant of the sorcery parameter being NULL. Now it can be
	  called within a module unload routine if the sorcery
	  initialization fails. * Fix ast_sorcery_observer_add() to fail if
	  the container link fails.

2013-12-03 16:37 +0000 [r403312]  Joshua Colp <jcolp@digium.com>

	* main/media_index.c: media_index: Make media indexing tolerable of
	  bad symlinks. Media indexing will now skip over files and
	  directories that stat will not return information about. This can
	  occur under normal conditions when a symbolic link points to a
	  location that no longer exists.

2013-12-03 16:33 +0000 [r403311]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/stasis_bridges.h, apps/app_disa.c,
	  apps/app_userevent.c, main/core_local.c,
	  include/asterisk/channelstate.h, channels/chan_console.c,
	  channels/chan_iax2.c, main/endpoints.c, channels/chan_oss.c,
	  res/parking/parking_bridge_features.c, apps/app_agent_pool.c,
	  main/channel.c, channels/chan_misdn.c, channels/chan_skinny.c,
	  channels/chan_alsa.c, pbx/pbx_realtime.c, main/stasis_channels.c,
	  channels/chan_nbs.c, main/bridge_channel.c, addons/chan_mobile.c,
	  channels/chan_pjsip.c, tests/test_cdr.c,
	  res/parking/parking_manager.c, channels/chan_mgcp.c,
	  channels/chan_unistim.c, main/pbx.c, funcs/func_timeout.c,
	  apps/app_meetme.c, main/bridge.c, tests/test_stasis_channels.c,
	  main/core_unreal.c, include/asterisk/channel.h,
	  channels/chan_gtalk.c, channels/sig_pri.c, apps/app_queue.c,
	  main/cel.c, main/stasis_bridges.c, channels/chan_jingle.c,
	  channels/chan_phone.c, channels/chan_dahdi.c, main/dial.c,
	  include/asterisk/stasis_channels.h, channels/sig_analog.c,
	  channels/chan_motif.c, res/res_agi.c, channels/chan_h323.c,
	  tests/test_cel.c, apps/app_confbridge.c, res/res_stasis.c,
	  res/res_pjsip_refer.c, apps/app_voicemail.c, apps/app_dial.c,
	  channels/chan_vpb.cc, addons/chan_ooh323.c, main/pickup.c,
	  channels/chan_sip.c, include/asterisk/aoc.h: Add channel locking
	  for channel snapshot creation. This adds channel locks around
	  calls to create channel snapshots as well as other functions
	  which operate on a channel and then end up creating a channel
	  snapshot. Functions that expect the channel to be locked prior to
	  being called have had their documentation updated to indicate
	  such.

2013-12-03 16:32 +0000 [r403310]  Joshua Colp <jcolp@digium.com>

	* res/res_ari.c: Revert revision 403304: Fixed the filename for the
	  ari.conf docs The changed value refers to the name of the module.
	  The name of the configuration file is specified in the configFile
	  section.

2013-12-02 18:34 +0000 [r403304]  David M. Lee <dlee@digium.com>

	* res/res_ari.c: Fixed the filename for the ari.conf docs

2013-12-02 18:03 +0000 [r403290-403291]  Alexandr Anikin <may@telecom-service.ru>

	* /: remove unwanted property svn:mergeinfo

	* /, addons/chan_ooh323.c: Check and reject non-digits e164 values
	  on peers and general sections in ooh323.conf Regenerate e164
	  endpoint list on reload ooh323 (issue ASTERISK-22901) Reported
	  by: Cyril CONSTANTIN Patches: ASTERISK-22901.patch ........
	  Merged revisions 403288 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-12-01 21:12 +0000 [r403256-403271]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_session.c: res_pjsip_session: Apply fromuser and
	  fromdomain to all requests as documented.

	* res/res_pjsip_t38.c: res_pjsip_t38: Add the framehook to the
	  channel only on first INVITE. The check for determining whether
	  the T.38 framehook should be added to the channel or not has now
	  been changed to guarantee adding only occurs on the first
	  incoming or outgoing INVITE.

	* res/res_pjsip_transport_websocket.c,
	  include/asterisk/res_pjsip.h, res/res_pjsip/location.c,
	  res/res_pjsip/security_events.c, res/res_pjsip/pjsip_options.c,
	  res/res_pjsip.c: res_pjsip_transport_websocket: Fix security
	  events and simplify implementation. Transport type determination
	  for security events has been simplified to use the type present
	  on the message itself instead of searching through configured
	  transports to find the transport used. The actual WebSocket
	  transport has also been simplified. It now leverages the existing
	  PJSIP transport manager for finding the active WebSocket
	  transport for outgoing messages. This removes the need for
	  res_pjsip_transport_websocket to store a mapping itself. (closes
	  issue ASTERISK-22897) Reported by: Max E. Reyes Vera J. Review:
	  https://reviewboard.asterisk.org/r/3036/

2013-11-30 14:11 +0000 [r403240]  Joshua Colp <jcolp@digium.com>

	* res/ari/ari_model_validators.c, res/ari/ari_model_validators.h,
	  rest-api/api-docs/events.json: res_ari: Add Recording events to
	  the validator.

2013-11-28 02:12 +0000 [r403179-403223]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_sdp_rtp.c: res_pjsip_sdp_rtp: Don't produce an
	  invalid media stream with no formats. Depending on configuration
	  it was possible for a media stream to be created without any
	  media formats. The produced SDP would fail internal validation
	  and cause a crash. The code will now no longer add media streams
	  with no formats to the SDP, allowing it to pass validation and
	  work. (closes issue ASTERISK-22858) Reported by: Anthony Messina

	* res/res_pjsip_header_funcs.c: res_pjsip_header_funcs: Don't add
	  headers to re-INVITEs. When sending a re-INVITE to an endpoint it
	  was possible for received headers to be added as well (since they
	  are stored for retrieval using the PJSIP_HEADER dialplan
	  function). This caused a broken (and potentially large) SIP
	  INVITE to be produced and sent. This changes the module so it
	  will no longer add headers to re-INVITEs. (closes issue
	  ASTERISK-22882) Reported by: David M. Lee

	* res/res_stasis_playback.c: res_stasis_playback: Add 'number',
	  'digits', and 'characters' URI scheme implementations. This
	  change adds new URI scheme implementations for playing numbers,
	  digits, and characters. This is done as part of the normal
	  playback mechanism and can be used with queueing to create a
	  combined sentence. Review:
	  https://reviewboard.asterisk.org/r/3028/

	* res/res_pjsip/pjsip_configuration.c, res/res_pjsip.c,
	  res/res_pjsip_session.c, include/asterisk/res_pjsip.h:
	  res_pjsip_session: Add configurable behavior for redirects. The
	  action taken when a redirect occurs is now configurable on a
	  per-endpoint basis. The redirect can either be treated as a
	  redirect to a local extension, to a URI that is dialed through
	  the Asterisk core, or to a URI that is dialed within PJSIP
	  itself. (closes issue ASTERISK-21710) Reported by: Matt Jordan
	  Review: https://reviewboard.asterisk.org/r/2963/

	* res/res_pjsip/pjsip_configuration.c: res_pjsip: Fix crash when
	  reloading certain configurations. Certain options available that
	  specify a SIP URI perform validation on the provided URI using
	  the PJSIP URI parser. This operation requires that the thread
	  executing it be registered with the PJLIB library. During reloads
	  this was done on a thread which was NOT registered with it. This
	  fixes the problem by creating a task which reloads the
	  configuration on a PJSIP thread. (closes issue ASTERISK-22923)
	  Reported by: Anthony Messina

2013-11-27 15:36 +0000 [r403175]  David M. Lee <dlee@digium.com>

	* res/res_ari_channels.c, include/asterisk/ari.h,
	  rest-api-templates/param_parsing.mustache,
	  include/asterisk/http.h, res/res_ari_recordings.c,
	  res/res_ari_endpoints.c, main/http.c,
	  rest-api-templates/swagger_model.py, res/res_ari_playbacks.c,
	  res/res_ari_sounds.c, rest-api-templates/asterisk_processor.py,
	  res/res_ari_bridges.c, tests/test_ari.c, res/res_ari.c,
	  res/res_ari_device_states.c, res/res_ari_asterisk.c,
	  rest-api-templates/res_ari_resource.c.mustache,
	  res/res_ari_applications.c: ari:Add application/json parameter
	  support The patch allows ARI to parse request parameters from an
	  incoming JSON request body, instead of requiring the request to
	  come in as query parameters (which is just weird for POST and
	  DELETE) or form parameters (which is okay, but a bit asymmetric
	  given that all of our responses are JSON). For any operation that
	  does _not_ have a parameter defined of type body (i.e.
	  "paramType": "body" in the API declaration), if a request
	  provides a request body with a Content type of
	  "application/json", the provided JSON document is parsed and
	  searched for parameters. The expected fields in the provided JSON
	  document should match the query parameters defined for the
	  operation. If the parameter has 'allowMultiple' set, then the
	  field in the JSON document may optionally be an array of values.
	  (closes issue ASTERISK-22685) Review:
	  https://reviewboard.asterisk.org/r/2994/

2013-11-27 15:31 +0000 [r403160-403173]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip/pjsip_configuration.c: res_pjsip: Update handling
	  of some options to work with new option names. Some options (such
	  as call_group and pickup_group) share the same configuration
	  handler and decide what logic to use based on the name of the
	  option. These handlers were not updated to check for the new
	  option names and were treating the options as invalid. This
	  change simply updates the handlers with the proper names of the
	  options. (closes issue ASTERISK-22922) Reported by: Anthony
	  Messina

	* configure, include/asterisk/autoconfig.h.in, configure.ac: Fix a
	  configure issue with PJSIP transaction group lock detection. The
	  configure check did not use the provided paths for pjproject if
	  provided when looking for transaction group lock support.

2013-11-23 17:38 +0000 [r403131-403134]  Kevin Harwell <kharwell@digium.com>

	* include/asterisk/stasis_app.h, main/devicestate.c,
	  res/stasis/app.h, rest-api/resources.json,
	  res/res_stasis_device_state.c (added),
	  res/ari/ari_model_validators.c, res/ari/ari_model_validators.h,
	  res/ari/resource_device_states.c (added),
	  rest-api/api-docs/deviceStates.json (added),
	  rest-api-templates/ari.make.mustache, res/ari.make,
	  rest-api/api-docs/applications.json,
	  include/asterisk/stasis_app_device_state.h (added),
	  res/ari/resource_device_states.h (added),
	  res/ari/resource_applications.h, res/res_stasis.c,
	  include/asterisk/devicestate.h,
	  res/res_stasis_device_state.exports.in (added),
	  rest-api/api-docs/events.json, res/res_ari_device_states.c
	  (added), res/stasis/app.c: ARI: Implement device state API
	  Created a data model and implemented functionality for an ARI
	  device state resource. The following operations have been added
	  that allow a user to manipulate an ARI controlled device:
	  Create/Change the state of an ARI controlled device PUT
	  /deviceStates/{deviceName}&{deviceState} Retrieve all ARI
	  controlled devices GET /deviceStates Retrieve the current state
	  of a device GET /deviceStates/{deviceName} Destroy a device-state
	  controlled by ARI DELETE /deviceStates/{deviceName} The ARI
	  controlled device must begin with 'Stasis:'. An example
	  controlled device name would be Stasis:Example. A
	  'DeviceStateChanged' event has also been added so that an
	  application can subscribe and receive device change events. Any
	  device state, ARI controlled or not, can be subscribed to. While
	  adding the event, the underlying subscription control mechanism
	  was refactored so that all current and future resource
	  subscriptions would be the same. Each event resource must now
	  register itself in order to be able to properly handle
	  [un]subscribes. (issue ASTERISK-22838) Reported by: Matt Jordan
	  Review: https://reviewboard.asterisk.org/r/3025/

	* res/res_pjsip_exten_state.c, include/asterisk/res_pjsip_pubsub.h,
	  res/res_pjsip/location.c, res/res_pjsip_outbound_registration.c,
	  res/res_pjsip_mwi.c, include/asterisk/sorcery.h,
	  res/res_pjsip/pjsip_configuration.c, include/asterisk/strings.h,
	  res/res_pjsip_pubsub.c,
	  res/res_pjsip/include/res_pjsip_private.h,
	  res/res_pjsip/config_transport.c, res/res_pjsip_registrar.c,
	  main/sorcery.c, include/asterisk/res_pjsip.h,
	  include/asterisk/acl.h, res/res_pjsip/config_auth.c,
	  include/asterisk/utils.h, res/res_pjsip.exports.in,
	  res/res_pjsip_endpoint_identifier_ip.c, main/acl.c, main/utils.c,
	  res/res_pjsip.c: res_pjsip: AMI commands and events. Created the
	  following AMI commands and corresponding events for res_pjsip:
	  PJSIPShowEndpoints - Provides a listing of all pjsip endpoints
	  and a few select attributes on each. Events: EndpointList - for
	  each endpoint a few attributes. EndpointlistComplete - after all
	  endpoints have been listed. PJSIPShowEndpoint - Provides a detail
	  list of attributes for a specified endpoint. Events:
	  EndpointDetail - attributes on an endpoint. AorDetail - raised
	  for each AOR on an endpoint. AuthDetail - raised for each
	  associated inbound and outbound auth TransportDetail - transport
	  attributes. IdentifyDetail - attributes for the identify object
	  associated with the endpoint. EndpointDetailComplete - last event
	  raised after all detail events. PJSIPShowRegistrationsInbound -
	  Provides a detail listing of all inbound registrations. Events:
	  InboundRegistrationDetail - inbound registration attributes for
	  each registration. InboundRegistrationDetailComplete - raised
	  after all detail records have been listed.
	  PJSIPShowRegistrationsOutbound - Provides a detail listing of all
	  outbound registrations. Events: OutboundRegistrationDetail -
	  outbound registration attributes for each registration.
	  OutboundRegistrationDetailComplete - raised after all detail
	  records have been listed. PJSIPShowSubscriptionsInbound - A
	  detail listing of all inbound subscriptions and their attributes.
	  Events: SubscriptionDetail - on each subscription detailed
	  attributes SubscriptionDetailComplete - raised after all detail
	  records have been listed. PJSIPShowSubscriptionsOutbound - A
	  detail listing of all outboundbound subscriptions and their
	  attributes. Events: SubscriptionDetail - on each subscription
	  detailed attributes SubscriptionDetailComplete - raised after all
	  detail records have been listed. (issue ASTERISK-22609) Reported
	  by: Matt Jordan Review: https://reviewboard.asterisk.org/r/2959/

2013-11-23 12:51 +0000 [r403117-403119]  Joshua Colp <jcolp@digium.com>

	* res/ari/ari_model_validators.h, res/res_stasis_playback.c,
	  rest-api/api-docs/events.json, res/res_stasis_recording.c,
	  res/ari/ari_model_validators.c,
	  rest-api/api-docs/recordings.json: ari: Add events for playback
	  and recording. While there were events defined for playback and
	  recording these were not actually sent. This change implements
	  the to_json handlers which produces them. (closes issue
	  ASTERISK-22710) Reported by: Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/3026/

	* main/audiohook.c, res/ari/resource_channels.c,
	  res/res_stasis_snoop.c (added), res/res_ari_channels.c,
	  res/ari/resource_channels.h, res/res_stasis_snoop.exports.in
	  (added), include/asterisk/stasis_app_snoop.h (added),
	  rest-api/api-docs/channels.json: ari: Add Snoop operation for
	  spying/whispering on channels. The Snoop operation can be invoked
	  on a channel to spy or whisper on it. It returns a channel that
	  any channel operations can then be invoked on (such as record to
	  do monitoring). (closes issue ASTERISK-22780) Reported by: Matt
	  Jordan Review: https://reviewboard.asterisk.org/r/3003/

2013-11-22 23:44 +0000 [r403094]  Kinsey Moore <kmoore@digium.com>

	* tests/test_stasis.c, tests/test_stasis_channels.c: Make sure unit
	  tests compile This fixes the unit tests that were broken by
	  r403069 and several functions requiring a new parameter for
	  sanitization of JSON messages generated from object snapshots.

2013-11-22 22:24 +0000 [r403082]  Kevin Harwell <kharwell@digium.com>

	* contrib/ast-db-manage/config/versions/43956d550a44_add_tables_for_pjsip.py,
	  res/res_pjsip/pjsip_configuration.c: res_pjsip: convert
	  configuration settings names to snake case some more Updated the
	  alembic script for pjsip. Also, the dtls config parsing stuff was
	  expecting strings with no underscores, so removed the underscores
	  from the option name before passing it to the parser.

2013-11-22 20:01 +0000 [r403069]  Kinsey Moore <kmoore@digium.com>

	* main/stasis_endpoints.c, res/ari/resource_endpoints.c,
	  main/rtp_engine.c, res/stasis/app.c,
	  include/asterisk/stasis_bridges.h, include/asterisk/stasis_app.h,
	  include/asterisk/stasis.h, main/stasis_bridges.c,
	  res/ari/resource_bridges.c, main/json.c, main/stasis_message.c,
	  include/asterisk/stasis_channels.h, main/stasis_channels.c,
	  res/ari/resource_channels.c, include/asterisk/stasis_endpoints.h,
	  res/res_stasis.c: ARI: Don't leak implementation details This
	  change prevents channels used as implementation details from
	  leaking out to ARI. It does this by preventing creation of JSON
	  blobs of channel snapshots created from those channels and
	  sanitizing JSON blobs of bridge snapshots as they are created.
	  This introduces a framework for excluding information from output
	  targeted at Stasis applications on a consumer-by-consumer basis
	  using channel sanitization callbacks which could be extended to
	  bridges or endpoints if necessary. This prevents unhelpful error
	  messages from being generated by ast_json_pack. This also
	  corrects a bug where BridgeCreated events would not be created.
	  (closes issue ASTERISK-22744) Review:
	  https://reviewboard.asterisk.org/r/2987/ Reported by: David M.
	  Lee

2013-11-22 17:19 +0000 [r403022]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_acl.c, res/res_pjsip.c,
	  res/res_pjsip/config_transport.c, res/res_pjsip/config_global.c,
	  configs/pjsip.conf.sample, res/res_pjsip/config_system.c,
	  contrib/scripts/sip_to_pjsip/sip_to_pjsip.py,
	  res/res_pjsip/pjsip_configuration.c: res_pjsip: convert
	  configuration settings names to snake case Renamed, where
	  appropriate, the configuration options for chan/res_pjsip to use
	  snake case (compound words separated by an underscore). For
	  example, faxdetect will become fax_detect, recordofffeature will
	  become record_off_feature, etc... Review:
	  https://reviewboard.asterisk.org/r/3002/

2013-11-22 17:11 +0000 [r403016]  Joshua Colp <jcolp@digium.com>

	* /, main/translate.c: translate: Move freeing of frame to after it
	  is used. When translating from one format to another it is
	  possible to inform the translation function that the source frame
	  should be freed. This was previously done immediately but shortly
	  afterwards the frame that was freed was accessed and used again.
	  This change moves code around a bit so that the frame is now
	  freed after it has been completely used. (closes issue
	  ASTERISK-22788) Reported by: Corey Farrell Patches:
	  translate-access-after-free-11up.patch uploaded by coreyfarrell
	  (license 5909) translate-access-after-free-1.8.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 403014 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 403015 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-21 22:35 +0000 [r402981-402993]  David M. Lee <dlee@digium.com>

	* rest-api-templates/ari_resource.c.mustache,
	  rest-api-templates/res_ari_resource.c.mustache: ari: Fix #include
	  to match generated headers for snakeCase resource files

	* rest-api-templates/make_ari_stubs.py: ari: Fix generators for
	  resources with camelCase names. For the new deviceState resource,
	  we need to properly generate device_state.[ch] files.

2013-11-21 19:21 +0000 [r402968]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip_session.c: res_pjsip_session: Fix memory leak of
	  direct media format capabilities The direct media format
	  capabilities are always allocated in ast_sip_session_alloc and
	  were not freed in the session destructor. Whoops. (This being the
	  third whoops caught by Scott and Nitesh's valgrind work for the
	  Asterisk Test Suite. Nifty!)

2013-11-21 19:08 +0000 [r402944-402956]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/app.h: voicemail: Fixup some doxygen comments.

	* main/bucket.c: bucket: Fix scheme ref leak in
	  __ast_bucket_scheme_register().

2013-11-21 17:52 +0000 [r402940-402941]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip_sdp_rtp.c: res_pjsip_sdp_rtp: Fix use of
	  uninitialized value in PJSIP In PJMEDIA,
	  pjmedia_sdp_rtpmap_to_attr will attempt to use the string
	  rtpmap.param regardless of its length value. Simply setting the
	  length to 0 does not prevent the garbage on the stack in
	  rtpmap.param.ptr from being formatted in a sprintf call. This
	  patch initializes the string to NULL so that at the very least,
	  something is provided to the function that is predictable.

	* res/res_pjsip_mwi.c: res_pjsip_mwi: Fix memory leak of MWI
	  subscriptions container This patch fixes a reference counting
	  memory leak on the ao2_container created as part of
	  create_mwi_subscriptions. When we create the container in this
	  routine, the intent is to hand lifetime ownership over to the
	  global container unsolicited_mwi. When
	  ao2_global_obj_replace_unref is called, the reference count on
	  mwi_subscriptions (the container) will be bumped by 1; however,
	  the function does not decrement the reference count on
	  mwi_subscriptions when this occurs. This will prevent the
	  container from being fully disposed of when Asterisk exits (or on
	  any subsequent call to this operation, such as during a reload).

2013-11-21 15:55 +0000 [r402926]  David M. Lee <dlee@digium.com>

	* res/stasis/control.c, include/asterisk/stasis_app.h,
	  rest-api/api-docs/channels.json, res/ari/resource_channels.c,
	  res/res_ari_channels.c, res/ari/resource_channels.h: ari: Add
	  silence generator controls This patch adds the ability to start a
	  silence generator on a channel via ARI. This generator will play
	  silence on the channel (avoiding audio timeouts on the peer)
	  until it is stopped, or some other media operation is started
	  (like playing media, starting music on hold, etc.). (closes issue
	  ASTERISK-22514) Review: https://reviewboard.asterisk.org/r/3019/

2013-11-19 23:17 +0000 [r402891]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_caller_id.c: res_pjsip_caller_id: Don't overwrite
	  user portion of the From header when fromuser is set. The
	  fromuser option is used to explicitly set the user within the
	  From header. The res_pjsip_caller_id module did not take this
	  setting into account when determining if the From header could be
	  modified or not. (closes issue ASTERISK-22866) Reported by:
	  Anthony Messina

2013-11-16 13:44 +0000 [r402864]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip/pjsip_distributor.c, configure,
	  include/asterisk/autoconfig.h.in, configure.ac: res_pjsip: Add
	  support for building against pjproject with SIP transaction group
	  lock support. SIP transaction group lock support has been
	  backported into our pjproject. Since the code now internally uses
	  a group lock the code is now changed to unlock it if present.
	  Note that the act of finding the transaction is what actually
	  returns it locked. For further information about group locks
	  check out the wiki page at:
	  http://trac.pjsip.org/repos/wiki/Group_Lock (issue
	  ASTERISK-22818) Reported by: Matt Jordan

2013-11-15 14:35 +0000 [r402838]  Kinsey Moore <kmoore@digium.com>

	* main/cel.c: CEL: Fix crash when using CELGenUserEvent This fixes
	  a crash when CELGenUserEvent is called from the dialplan while
	  CEL is disabled. Currently, CEL does not create its topics and
	  forwards if it is not enabled and external entities may depend on
	  these topics blindly since they should always be available. This
	  patch breaks up route creation and topic/forward creation such
	  that the CEL topics and forwards will always exist while the
	  router and its associated routes will be torn down and recreated
	  as necessary. (closes issue ASTERISK-22799) Review:
	  https://reviewboard.asterisk.org/r/3010/ Reported by: Matt Jordan

2013-11-14 15:01 +0000 [r402817]  David M. Lee <dlee@digium.com>

	* res/res_stasis.c: stasis: Fixed scoping problem with bridge
	  tracking.

2013-11-13 23:09 +0000 [r402804]  Joshua Colp <jcolp@digium.com>

	* res/stasis/control.c, include/asterisk/stasis_app.h,
	  rest-api/api-docs/channels.json, res/ari/resource_channels.c,
	  res/res_ari_channels.c, res/ari/resource_channels.h:
	  res_ari_channels: Add the ability to stop locally generated
	  ringing on a channel. Using the 'ring' operation it is possible
	  to start locally generated ringback if the channel is answered.
	  This change adds the ability to stop it by using DELETE.

2013-11-12 23:16 +0000 [r402787-402793]  Kevin Harwell <kharwell@digium.com>

	* res/ari/resource_endpoints.c: ari endpoints: GET
	  /ari/endpoints/{invalid-tech} should return a 404 Was returning a
	  404 on a valid technology with an empty list of endpoints. Now
	  checking against the channel tech to make sure the tech itself is
	  valid and not just an empty list of endpoints. (issue
	  ASTERISK-22803) Reported by: David M. Lee

	* rest-api/api-docs/endpoints.json, res/ari/resource_endpoints.c,
	  res/res_ari_endpoints.c: ari endpoints: GET
	  /ari/endpoints/{invalid-tech} should return a 404 Implementation
	  listing endpoints by technology returned an empty array if no
	  matching endpoints were found. Fixed so a "404 Not Found" will be
	  returned instead. (closes issue ASTERISK-22803) Reported by:
	  David M. Lee

2013-11-12 19:11 +0000 [r402767-402769]  Mark Michelson <mmichelson@digium.com>

	* main/channel.c: Switch to a scoped lock to avoid missing unlocks
	  in failure returns.

	* main/channel.c: Move a NULL check to a place that makes more
	  sense. Two variables were being checked for NULLity immediately
	  after being declared NULL. I moved the NULL check until after the
	  variables are allocated. This allows for the "channelvars" option
	  in manager.conf to work as intended again.

2013-11-12 16:45 +0000 [r402757]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_messaging.c, res/res_pjsip_header_funcs.c:
	  pjsip_messaging, pjsip_header_funcs: Crashes due to NULL pointer
	  dereferences Both res_pjsip_messaging and res_pjsip_header_funcs
	  were causing asterisk to crash because they were trying to
	  dereference a NULL pointer. In the case of res_pjsip_messaging it
	  was attempting to "print" a contact header that did not exist. In
	  fact contact headers should not be part of a SIP MESSAGE, so the
	  offending code was simply removed. In the case of
	  res_pjsip_header_funcs a null private channel tech was being
	  passed to the function and then later dereferenced. Added null
	  checks (and error logging) to the read/write function handlers to
	  guard against crashing. (closes issue ASTERISK-22821) Reported
	  by: Anthony Messina

2013-11-12 16:33 +0000 [r402755]  Kinsey Moore <kmoore@digium.com>

	* apps/app_celgenuserevent.c: CELGenUserEvent: Fix error message
	  from ast_json_pack This prevents NULL from being passed into an
	  ast_json_pack call when no extra information is passed to the
	  application which prevents an error message about NULL arguments
	  from being generated.

2013-11-12 15:26 +0000 [r402738]  David M. Lee <dlee@digium.com>

	* res/ari/ari_model_validators.h, rest-api/api-docs/events.json:
	  Fixed a typ.

2013-11-12 15:02 +0000 [r402710]  Kinsey Moore <kmoore@digium.com>

	* channels/chan_dahdi.c, /: chan_dahdi: Fix crash during caller ID
	  read Asterisk will sometimes core dump during caller id read on
	  analog channels due to a negative return value from the read() in
	  my_get_callerid that slips through as a negative length argument
	  to callerid_feed() if the errno returned by DAHDI is ELAST. This
	  change ensures that the negative return is treated properly even
	  when it is ELAST. (closes issue ASTERISK-22746) Reported by:
	  Michael Walton Patches: chan_dahdi_cid_crash_fix.r401410.patch
	  uploaded by Michael Walton (License 6502) ........ Merged
	  revisions 402708 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 402709 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-11 19:26 +0000 [r402687]  Mark Michelson <mmichelson@digium.com>

	* /, apps/app_confbridge.c: Get rid of some inaccurate comments.
	  I'm doing some unrelated work in app_confbridge and finding these
	  "invalid pin" comments to be annoying. Get out! ........ Merged
	  revisions 402686 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-11 15:36 +0000 [r402647]  Kinsey Moore <kmoore@digium.com>

	* apps/app_queue.c, /: app_queue: Honor penalty limits of 0 In the
	  current app_queue code from 1.8 up to trunk the upper and lower
	  penalties can be set to 0 but the value is interpreted to be
	  disabled instead of actually setting limits. This is especially
	  evident if min and max limits are set to 0 and members with
	  penalties of 0 and 1 are in the queue since the member with
	  penalty 1 will still receive calls. This patch adjusts the
	  special disabled value to be INT_MAX instead of 0. (closes issue
	  ASTERISK-20862) Review: https://reviewboard.asterisk.org/r/2995/
	  Reported by: Schmooze Com ........ Merged revisions 402645 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 402646 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-08 23:04 +0000 [r402606]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, channels/chan_sip.c, channels/sip/include/sip.h: chan_sip:
	  keep same local (from) tag for outgoing register requests For
	  outbound register requests the tag on the From line was updated
	  every 20 seconds prior to a successful registration and also once
	  for each registration renewal. That behavior can possibly cause
	  the registration to be denied because of the different tag, and
	  is not aligned with the intention of RFC 3261 8.1.3.5 "...
	  request constitutes a new transaction and SHOULD have the same
	  value of the Call-ID, To, and From of the previous request...".
	  This updates chan_sip to have a field to keep the local tag in
	  the registration structure and use that tag for registration
	  requests where the callid is also unchanged. (closes issue
	  ASTERISK-12117) Reported by: Pawel Pierscionek Review:
	  https://reviewboard.asterisk.org/r/2988/ ........ Merged
	  revisions 402604 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 402605 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-08 20:20 +0000 [r402593]  Richard Mudgett <rmudgett@digium.com>

	* res/res_stasis.c: res_stasis.c: Fix locking issues with the
	  app_bridge_moh container. * Fix unlinking from the
	  app_bridges_moh container in remove_bridge_moh() without a lock
	  under normal circumstances. * Made check
	  ast_bridge_set_after_callback() return value in
	  bridge_moh_create() to handle failure. * Fixed SCOPED_AO2LOCK()
	  locking over too much scope in stasis_app_bridge_moh_channel()
	  and stasis_app_bridge_moh_stop(). * Fixed unusual usage of
	  ao2_unlink_flag() in control_unlink(). * Fixed orphaned bridge
	  from off nominal path in stasis_app_bridge_create(). * Fixed
	  strange construct in stasis_app_unsubscribe(). From a bad merge?
	  * Made load_module() cleanup on failure. Review:
	  https://reviewboard.asterisk.org/r/2962/

2013-11-08 19:28 +0000 [r402584]  Jonathan Rose <jrose@digium.com>

	* configs/manager.conf.sample, CHANGES, include/asterisk/manager.h,
	  main/manager.c, main/security_events.c: security_events: Push out
	  security events over AMI events Security Events will now be
	  written to any listener of the new 'security' class Review:
	  https://reviewboard.asterisk.org/r/2998/

2013-11-08 19:22 +0000 [r402582]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip.c: Clarify an ambiguous error message.

2013-11-08 18:48 +0000 [r402561-402570]  David M. Lee <dlee@digium.com>

	* res/res_pjsip/config_system.c: res_pjsip: Print a helpful error
	  message if sorcery registration fails

	* res/ari/resource_playbacks.h: Changes from make ari-stubs after
	  r402560

2013-11-08 17:39 +0000 [r402560]  Kevin Harwell <kharwell@digium.com>

	* res/ari/resource_playbacks.h (added), res/ari.make,
	  rest-api/api-docs/playback.json (removed),
	  res/ari/resource_playback.c (removed), res/res_ari_playback.c
	  (removed), rest-api/api-docs/playbacks.json (added),
	  res/ari/resource_playbacks.c (added), rest-api/resources.json,
	  res/ari/resource_playback.h (removed), res/res_ari_playbacks.c
	  (added): ARI playback: Rename ARI Playback to Playbacks Before
	  playback was the only non plural resource. It has been renamed to
	  playbacks for consistency. (closes issue ASTERISK-22737) Reported
	  by: Paul Belanger

2013-11-08 17:28 +0000 [r402555]  David M. Lee <dlee@digium.com>

	* res/res_ari.c, main/manager.c, main/http.c: ari: Add
	  application/x-www-form-urlencoded parameter support ARI POST
	  calls only accept parameters via the URL's query string. While
	  this works, it's atypical for HTTP API's in general, and
	  specifically frowned upon with RESTful API's. This patch adds
	  parsing for application/x-www-form-urlencoded request bodies if
	  they are sent in with the request. Any variables parsed this way
	  are prepended to the variable list supplied by the query string.
	  (closes issue ASTERISK-22743) Review:
	  https://reviewboard.asterisk.org/r/2986/

2013-11-07 23:16 +0000 [r402537]  Jonathan Rose <jrose@digium.com>

	* res/res_pjsip_authenticator_digest.c: PJSIP: Improve error
	  handling in digest authenticator Previously, regardless of
	  whether failure to authenticate was due to lacking any
	  authentication or actually failing authentication, the Digest
	  Authenticator would simply return that a challenge was still
	  needed. It will continue to do that when no authentication
	  information is in the received SIP digest, but when
	  authentication information is present and does not pass
	  authentication, that will be treated as an authentication error.
	  This is to ensure that PJSIP will issue security events indicated
	  failed auths.

2013-11-07 21:09 +0000 [r402528]  David M. Lee <dlee@digium.com>

	* rest-api-templates/swagger_model.py, res/ari/resource_asterisk.h,
	  rest-api-templates/ari_resource.c.mustache,
	  rest-api-templates/asterisk_processor.py, res/res_ari_bridges.c,
	  rest-api/api-docs/endpoints.json, res/ari/resource_endpoints.c,
	  res/ari/resource_endpoints.h, res/res_ari_applications.c,
	  res/res_ari_playback.c, res/res_ari_channels.c,
	  rest-api/api-docs/bridges.json, res/ari/resource_bridges.c,
	  res/res_ari_recordings.c, res/ari/resource_bridges.h,
	  res/res_ari_events.c, res/ari/resource_applications.c,
	  res/ari/resource_playback.c, rest-api/api-docs/channels.json,
	  res/ari/resource_applications.h, res/ari/resource_channels.c,
	  res/ari/resource_playback.h, res/res_ari_sounds.c,
	  rest-api/api-docs/recordings.json, res/ari/resource_recordings.c,
	  res/ari/resource_channels.h,
	  rest-api-templates/ari_resource.h.mustache,
	  res/ari/resource_events.c, res/ari/resource_recordings.h,
	  rest-api-templates/rest_handler.mustache, res/res_ari_asterisk.c,
	  rest-api-templates/res_ari_resource.c.mustache,
	  res/ari/resource_events.h, rest-api/api-docs/sounds.json,
	  res/ari/resource_sounds.c, res/ari/resource_sounds.h,
	  rest-api/api-docs/asterisk.json,
	  rest-api/api-docs/applications.json, res/res_ari_endpoints.c,
	  res/ari/resource_asterisk.c, rest-api/api-docs/playback.json:
	  ari: User better nicknames for ARI operations While working on
	  building client libraries from the Swagger API, I noticed a
	  problem with the nicknames. channel.deleteChannel()
	  channel.answerChannel() channel.muteChannel() Etc. We put the
	  object name in the nickname (since we were generating C code),
	  but it makes OO generators redundant. This patch makes the
	  nicknames more OO friendly. This resulted in a lot of name
	  changing within the res_ari_*.so modules, but not much else.
	  There were a couple of other fixed I made in the process. * When
	  reversible operations (POST /hold, POST /unhold) were made more
	  RESTful (POST /hold, DELETE /unhold), the path for the second
	  operation was left in the API declaration. This worked, but
	  really the two operations should have been on the same API. * The
	  POST /unmute operation had still not been REST-ified. Review:
	  https://reviewboard.asterisk.org/r/2940/

2013-11-06 21:57 +0000 [r402517]  Kevin Harwell <kharwell@digium.com>

	* apps/app_queue.c: app_queue: crash if first agent is "busy" If
	  the first agent/member (via CLI "queue show") in a queue is
	  "busy" (dnd, circuit busy, etc...) and no agents answered then
	  app_queue would crash. This occurred because while the calling of
	  agent(s) remained valid the channel on "busy" agent would be set
	  to NULL and then later dereferenced upon a second "rna" function
	  call. The original intention of the code is to have only valid
	  "call attempt" objects (channels != NULL) checked while
	  attempting to call agent(s). It does this by building a
	  "call_next" list of valid "call attempt" objects. In the case of
	  the "busy" agent subsequent builds of the valid "call attempt"
	  list would sometimes include (the case mentioned above) an
	  invalid "call attempt" object. The fix was to make sure the "call
	  attempt" list was appropriately built on every iteration. A NULL
	  sanity check was also added at the original offending spot of the
	  crash just in case another one slipped by somehow. (closes issue
	  ASTERISK-22644) Reported by: Marco Signorini Review:
	  https://reviewboard.asterisk.org/r/2983/

2013-11-05 21:16 +0000 [r402501-402507]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_sip.c: chan_sip: Use AST_AF* defined constant when
	  calling ast_get_ip While the structure passed to ast_get_ip
	  should be set memset to 0, thus initializing the ss_family member
	  to 0, explicitly setting it to AST_AF_UNSPEC is more portable.

	* channels/chan_iax2.c: chan_iax2: Fix incorrect usage of
	  ast_get_ip involving uninitialized struct This started off as a
	  fix for the failing IAX2 acl_call test in the Asterisk Test
	  Suite. When inspecting why that test was failing, it became clear
	  that all attempts to bind to any local loopback address was
	  failing: [Nov 2 15:56:28] VERBOSE[15787] chan_iax2.c: == Binding
	  IAX2 to address 127.0.0.1:4569 [Nov 2 15:56:28] DEBUG[15787]
	  netsock2.c: Splitting '127.0.0.1' into... [Nov 2 15:56:28]
	  DEBUG[15787] netsock2.c: ...host '127.0.0.1' and port ''. [Nov 2
	  15:56:28] ERROR[15787] netsock2.c: getaddrinfo("127.0.0.1",
	  "(null)", ...): ai_family not supported [Nov 2 15:56:28]
	  WARNING[15787] acl.c: Unable to lookup '127.0.0.1' While there's
	  conceivably other ways for getaddrino to return EAI_FAMILY, the
	  most common way is if AF_INET, AF_INET6, or AF_UNSPEC is not
	  provided as the desired family. The culprit was the call to
	  ast_get_ip, defined in acl.h. This function uses the family from
	  the passed in addr object (which it will also populate when it
	  returns!) when it eventually calls getaddrinfo. This patch fixes
	  the use of ast_get_ip that were not specifying the family in
	  chan_iax2. This prevents uninitialized use of the structure, so
	  that the addresses resolve correctly. Review:
	  https://reviewboard.asterisk.org/r/2991

	* include/asterisk/netsock2.h, include/asterisk/acl.h: netsock2:
	  Define AST_AF_* enum constants to their AF_* equivalents This
	  patch explicitly defines AST_AF_* enum constants to their
	  sys/socket.h defined equivalents. It is certainly unclear why
	  these constants actually have to exist, given that netsock2.h
	  includes sys/socket.h; however, since the code base is already
	  liberally sprinkled with the usage of AST_AF_* (as well as with
	  direct calls to AF_*), this will at least keep the semantics
	  consistent between their usage across systems.

	* main/stasis_channels.c: stasis_channels: Don't give preference to
	  ANI info in channel snapshots When publishing channel snapshots,
	  we currently compute the caller ID name and number by giving
	  preference first to ani.{name|number}, then to id.{name|number}.
	  However, when a channel driver (such as chan_sip) updates the
	  caller ID, it typically only updates the caller ID stored in
	  id.{name|number}. This means that we are currently giving
	  preference to stale information. When looking at the rest of the
	  code base, the only other place where we appear to use this same
	  logic is in app_amd. Everywhere else, we treat the party
	  information in ani as being separate to the party information in
	  id. This patch publishes only the caller ID name and number in
	  the snapshot field for caller_name and caller_num. Note that the
	  information in ANI is still available in caller_ani. Review:
	  https://reviewboard.asterisk.org/r/2992/

2013-11-04 20:56 +0000 [r402452]  Kevin Harwell <kharwell@digium.com>

	* /, channels/chan_sip.c: chan_sip: notify dialog info ignores
	  presentation indicator in callerid The presentation indicator in
	  a callerid (e.g. set by dialplan function
	  Set(CALLERID(name-pres)= ...)) is not checked when SIP Dialog
	  Info Notifies are generated during extension monitoring. Added a
	  check to make sure the name and/or number presentations on the
	  callee (remote identity) are set to allow. If they are restricted
	  then "anonymous" is used instead. (closes issue AST-1175)
	  Reported by: Thomas Arimont Review:
	  https://reviewboard.asterisk.org/r/2976/ ........ Merged
	  revisions 402450 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-02 04:30 +0000 [r402398-402438]  Richard Mudgett <rmudgett@digium.com>

	* main/stasis.c, main/stasis_message_router.c,
	  include/asterisk/vector.h: vector: Uppercase API to follow C
	  convention. C does not support templates like C++.

	* main/stasis.c, main/stasis_message_router.c,
	  include/asterisk/vector.h, include/asterisk/lock.h: vector:
	  Update API to be more flexible. Made the vector macro API be more
	  like linked lists. 1) Added a name parameter to ast_vector() to
	  name the vector struct. 2) Made the API take a pointer to the
	  vector struct instead of the struct itself. 3) Added an element
	  cleanup macro/function parameter when removing an element from
	  the vector for ast_vector_remove_cmp_unordered() and
	  ast_vector_remove_elem_unordered(). 4) Added
	  ast_vector_get_addr() in case the vector element is not a simple
	  pointer. * Converted an inline vector usage in
	  stasis_message_router to use the vector API. It needed the API
	  improvements so it could be converted. * Fixed topic reference
	  leak in router_dtor() when the stasis_message_router is
	  destroyed. * Fixed deadlock potential in stasis_forward_all() and
	  stasis_forward_cancel(). Locking two topics at the same time
	  requires deadlock avoidance. * Made internal_stasis_subscribe()
	  tolerant of a NULL topic. * Made stasis_message_router_add(),
	  stasis_message_router_add_cache_update(),
	  stasis_message_router_remove(), and
	  stasis_message_router_remove_cache_update() tolerant of a NULL
	  message_type. * Promoted a LOG_DEBUG message to LOG_ERROR as
	  intended in dispatch_message(). Review:
	  https://reviewboard.asterisk.org/r/2903/

	* apps/confbridge/conf_state_single.c,
	  apps/confbridge/conf_state_inactive.c,
	  apps/confbridge/conf_state_single_marked.c, /,
	  apps/confbridge/include/confbridge.h,
	  apps/confbridge/conf_state_multi.c, apps/app_confbridge.c,
	  apps/confbridge/conf_state_multi_marked.c,
	  apps/confbridge/conf_state.c: confbridge: Separate user muting
	  from system muting overrides. The system overrides the user
	  muting requests when MOH is playing or a waitmarked user is
	  waiting for a marked user to join. System muting overrides
	  interfere with what the user may wish the muting to be when the
	  system override ends. * User muting requests are now independent
	  of the system muting overrides. The effective muting is now the
	  logical or of the user request and system override. * Added a
	  Muted flag to the CLI "confbridge list <conference>" command. *
	  Added a Muted header to the AMI ConfbridgeList action
	  ConfbridgeList event. (closes issue AST-1102) Reported by: John
	  Bigelow Review: https://reviewboard.asterisk.org/r/2960/ ........
	  Merged revisions 402425 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, main/config.c, apps/confbridge/conf_config_parser.c,
	  configs/confbridge.conf.sample: config: Allow ConfBridge DTMF
	  menus to have '#' as the first digit. ConfBridge allows custom
	  DTMF menus to be created in the confbridge.conf file by assigning
	  a DTMF key sequence to a sequence of actions as follows:
	  DTMF-sequence = action,action... Unfortunately, the normal config
	  file processing code interprets an initial '#' character as
	  starting a directive such as #include. * Add the ability to
	  escape the first non-blank character in a config line so the '#'
	  character can be used without triggering the directive processing
	  code. (closes issue AFS-2) (closes issue ASTERISK-22478) Reported
	  by: Nicolas Tanski Patches: jira_asterisk_22478_v11.patch
	  (license #5621) patch uploaded by rmudgett (modified) Review:
	  https://reviewboard.asterisk.org/r/2969/ ........ Merged
	  revisions 402407 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/app.c, include/asterisk/app.h: voicemail: Simplify callback
	  pointer declarations and add doxygen. * Typedefed and added
	  doxegen for the voicemail callback functions. * Simplified the
	  prototypes for ast_install_vm_functions() and
	  ast_install_vm_test_functions() to use the new function typedefs.
	  * Simplified the voicemail callback function pointer variable
	  declarations to use the new function typedefs.

2013-11-01 21:49 +0000 [r402387]  Scott Griepentrog <sgriepentrog@digium.com>

	* main/bridge.c, include/asterisk/bridge.h, main/manager_bridges.c:
	  Manager: Add equivalent AMI actions for the bridge CLI commands.
	  Adds the following AMI events, closely following their CLI
	  counterparts: BridgeDestroy BridgeKick BridgeTechnologyList
	  BridgeTechnologySuspend BridgeTechnologyUnsuspend BridgeDestroy
	  kicks an entire bridge, where BridgeKick kicks just one channel
	  off the bridge. When kicking a channel, specifying the bridge
	  also (optional) insures it is not removed from the wrong bridge.
	  The BridgeTechnology events allow viewing and changing suspension
	  status, which affects only subsequent not active bridging.
	  (closes ASTERISK-22356) Reported by: Richard Mudgett Review:
	  https://reviewboard.asterisk.org/r/2973/

2013-11-01 16:31 +0000 [r402367]  David M. Lee <dlee@digium.com>

	* rest-api-templates/api.wiki.mustache: ari wiki docs: add notes
	  about allowMultiple parameters. This patch adds a note to any
	  parameter that has 'allowMultiple' set in the Swagger
	  documentation. (closes issue ASTERISK-22704)

2013-11-01 14:37 +0000 [r402358]  Joshua Colp <jcolp@digium.com>

	* include/asterisk/stasis_app.h, rest-api/api-docs/channels.json,
	  res/ari/resource_channels.c, res/res_ari_channels.c,
	  res/ari/resource_channels.h, res/res_stasis_playback.c,
	  res/stasis/control.c: res_ari_channels: Add ring operation, dtmf
	  operation, hangup reasons, and tweak early media. The ring
	  operation sends ringing to the specified channel it is invoked
	  on. The dtmf operation can be used to send DTMF digits to the
	  specified channel of a specific length with a wait time in
	  between. Finally hangup reasons allow you to specify why a
	  channel is being hung up (busy, congestion). Early media behavior
	  has also been tweaked slightly. When playing media to a channel
	  it will no longer automatically answer. If it has not been
	  answered a progress indication is sent instead. (closes issue
	  ASTERISK-22701) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/2916/

2013-11-01 12:38 +0000 [r402348]  Kinsey Moore <kmoore@digium.com>

	* include/asterisk/rtp_engine.h, res/res_rtp_asterisk.c, /,
	  channels/chan_sip.c: chan_sip: Fix RTCP port for SRFLX ICE
	  candidates This corrects one-way audio between Asterisk and
	  Chrome/jssip as a result of Asterisk inserting the incorrect RTCP
	  port into RTCP SRFLX ICE candidates. This also exposes an ICE
	  component enumeration to extract further details from candidates.
	  (closes issue ASTERISK-21383) Reported by: Shaun Clark Review:
	  https://reviewboard.asterisk.org/r/2967/ ........ Merged
	  revisions 402345 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-11-01 12:31 +0000 [r402336-402346]  Joshua Colp <jcolp@digium.com>

	* include/asterisk/stasis_app.h, res/ari/resource_channels.c:
	  res_ari_channels: Fix a deadlock when originating multiple
	  channels close to eachother. If a Stasis application is specified
	  an implicit subscription is done on the originated channel. This
	  was previously done with the channel lock held which is dangerous
	  as the underlying code locks the container and iterates items.
	  This change releases the lock on the originated channel before
	  subscribing occurs. (closes issue ASTERISK-22768) Reported by:
	  Matt Jordan Review: https://reviewboard.asterisk.org/r/2979/

	* res/stasis/control.c: res_stasis: Ensure the channel is always
	  departed from the bridge when it leaves. This change adds a
	  command to the command queue to explicitly depart the channel
	  from the bridge when it is told it has left. If the channel has
	  already been departed or has entered a different bridge this
	  command will become a no-op. (closes issue ASTERISK-22703)
	  Reported by: John Bigelow (closes issue ASTERISK-22634) Reported
	  by: Kevin Harwell Review:
	  https://reviewboard.asterisk.org/r/2965/

2013-10-31 22:08 +0000 [r402327]  Mark Michelson <mmichelson@digium.com>

	* contrib/scripts/sip_to_res_sip (removed),
	  contrib/scripts/sip_to_pjsip (added),
	  contrib/scripts/sip_to_pjsip/astconfigparser.py,
	  contrib/scripts/sip_to_pjsip/astdicts.py,
	  contrib/scripts/sip_to_pjsip/sip_to_pjsip.py: Update the
	  conversion script from sip.conf to pjsip.conf (closes issue
	  ASTERISK-22374) Reported by Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/2846

2013-10-31 16:04 +0000 [r402285-402289]  Matthew Jordan <mjordan@digium.com>

	* main/loader.c, /: core/loader: Don't call dlclose in a while loop
	  For awhile now, we've noticed continuous integration builds
	  hanging on CentOS 6 64-bit build agents. After resolving a number
	  of problems with symbols, strange locks, and other shenanigans,
	  the problem has persisted. In all cases, gdb shows the Asterisk
	  process stuck in loader.c on one of the infinite while loops that
	  calls dlclose repeatedly until success. The documentation of
	  dlclose states that it returns 0 on success; any other value on
	  error. It does not state that repeatedly calling it will
	  eventually clear those errors. Most likely, the repeated calls to
	  dlclose was to force a close by exhausting the references on the
	  library; however, that will never succeed if: (a) There is some
	  fundamental error at work in the loaded library that precludes
	  unloading it (b) Some other loaded module is referencing a symbol
	  in the currently loaded module This results in Asterisk sitting
	  forever. Since we have matching pairs of dlopen/dlclose, this
	  patch opts to only call dlclose once, and log out as an ERROR if
	  dlclose fails to return success. If nothing else, this might help
	  to determine why on the CentOS 6 64-bit build agent things are
	  not closing successfully. Review:
	  https://reviewboard.asterisk.org/r/2970 ........ Merged revisions
	  402287 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 402288 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/media_index.c: medix_index: Display errors when library
	  calls fail Based on feedback from ipengineer in #asterisk, when
	  the media indexer cannot access a sound file on the system (or
	  otherwise fails) Asterisk displays a "Cannot frob file" error but
	  fails to tell you why. This is especially problematic as the
	  media_indexer failing will rpevent Asterisk from starting, as it
	  is in the core. We now display the errno error messages so folks
	  can figure out what they've done wrong.

2013-10-31 14:43 +0000 [r402276]  David M. Lee <dlee@digium.com>

	* res/stasis/app.c: stasis: add functions embarrassingly missing
	  from r400522 I neglected to implement two of the endpoint
	  subscription functions when I did the work. Normally, you'll only
	  hit that when you unsubscribe from a specific endpoint.

2013-10-30 17:52 +0000 [r402265]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_messaging.c, channels/chan_pjsip.c:
	  pjsip_messaging: Added debug for in dialog messaging (issue
	  ASTERISK-22777) Reported by: Matt Jordan

2013-10-29 23:43 +0000 [r402226]  Rusty Newton <rnewton@digium.com>

	* sounds/Makefile, /: Updates for 1.4.25 core sounds and 1.4.14
	  extra sounds, plus new en_GB language set The new sound packages
	  relate to issues: ASTERISK-22544, ASTERISK-22411, ASTERISK-21413,
	  ASTERISK-20782 Modified sounds/Makefile for the new sound
	  versions and to account for the new en_GB language set. (issue
	  ASTERISK-22659) (closes issue ASTERISK-22659) (closes issue
	  ASTERISK-22411) (closes issue ASTERISK-22544) ........ Merged
	  revisions 402224 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 402225 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-29 12:53 +0000 [r402154]  Matthew Jordan <mjordan@digium.com>

	* /, main/translate.c, main/xmldoc.c, main/channel.c, main/pbx.c:
	  Remove some spammy debug messages; improve clarity of others
	  Debug messages aren't free. Even when the debug level is
	  sufficiently low such that the messages are never evaluated,
	  there is a cost to having to parse Asterisk logs that contain
	  debug messages that (a) fail to convey sufficient information or
	  (b) occur so frequently as to be next to meaningless. Based on
	  having to stare at lots of DEBUG messages, this patch makes the
	  following changes: * channel.c: When copying variables from a
	  parent channel to a child channel, specify the channels involved.
	  Do not log anything for a variable that is not inherited; the
	  fact that it doesn't have an _ or __ already signifies that it
	  won't be inherited. * pbx.c: Specify what function evaluation has
	  occurred that created the result. * translate.c: Bump up the
	  translator path messages to 10. I've never once had to use these
	  debug messages, and for each format that is registered (on
	  startup) and unregistered (on shutdown) the entire f^2 matrix is
	  logged out. For short tests in the Asterisk Test Suite, this
	  should make finding the actual test much easier. * xmldoc.c: The
	  debug message that 'blah' is not found in the tree is expected.
	  Often, description elements - which are not required - are not
	  provided. This debug message adds no additional value, as it is
	  not indicative of an error or helpful in debugging which element
	  did not contain a 'blah' element as a child. If an element is
	  supposed to contain a child element, then that XML tree should
	  have failed validation in the first place. Review:
	  https://reviewboard.asterisk.org/r/2966/ ........ Merged
	  revisions 402150 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 402151 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-29 12:51 +0000 [r402148-402152]  Kinsey Moore <kmoore@digium.com>

	* res/ari/resource_channels.h, rest-api/api-docs/channels.json,
	  res/ari/resource_channels.c, res/res_ari_channels.c: ARI: Remove
	  channels/{channelId}/dial This removes the
	  /ari/channels/{channelId}/dial URI since it is redundant, overly
	  complex, is likely to become more externally complex over time,
	  and is too high-level compared with other ARI operations. See the
	  following for further information:
	  http://lists.digium.com/pipermail/asterisk-app-dev/2013-October/000002.html
	  (closes issue ASTERISK-22784) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/2968/

	* bridges/bridge_native_rtp.c: bridge_native_rtp: Ensure bridge is
	  torn down When a bridge transitions away from one tech to
	  another, the tech going away is provided a dummy bridge with no
	  channels in it to tear down. Currently this means that the
	  teardown code exits prematurely and does not tear anything down.
	  This change tears down RTP bridging for the channel provided in
	  the leave bridge tech callback. This also reverts the majority of
	  r400403 since it is now redundant. (closes issue ASTERISK-22628)
	  (closes issue ASTERISK-22676) Reported by: John Bigelow Reported
	  by: Kevin Harwell Tested by: John Bigelow Review:
	  https://reviewboard.asterisk.org/r/2905/ Patches:
	  native_rtp_fix.diff uploaded by Kinsey Moore (License 6273)

2013-10-29 11:15 +0000 [r402139]  Joshua Colp <jcolp@digium.com>

	* res/res_ari_playback.c, rest-api/api-docs/playback.json:
	  res_ari_playback: Add missing 404 error response for GET and
	  DELETE. (closes issue ASTERISK-22722) Reported by: Richard
	  Mudgett

2013-10-28 21:30 +0000 [r402127]  David M. Lee <dlee@digium.com>

	* doc: Ignore full docs

2013-10-28 15:05 +0000 [r402112-402115]  Michael L. Young <elgueromexicano@gmail.com>

	* UPGRADE-11.txt, UPGRADE.txt: Fix UPGRADE.txt Due To Merging From
	  Branch 11 When merging in the patch for ASTERISK-22728, the
	  UPGRADE.txt file was changed incorrectly. That change should have
	  gone into ASTERISK-11.txt. This commit is to fix that. Also,
	  another comment in the UPGRADE-11.txt was missing and this commit
	  adds that as well.

	* UPGRADE.txt, /, channels/chan_sip.c: chan_sip: Clarify
	  'Forcerport' Setting Displayed When Running "sip show peers"
	  While looking at ASTERISK-22236, Walter Doekes pointed out that
	  when running "sip show peers", the setting being displayed can be
	  confusing. The display of "N" used to mean NAT (i.e. yes). The
	  NAT setting has gone through many different changes resulting in
	  the display of different characters to try and convey what the
	  current setting is for 'Forcerport' (A for Auto and Forcerport is
	  currently on, a for Auto but Forcerport is off, Y for yes, and N
	  for no). During the initial code review to try and clarify these
	  settings (especially since "N" no longer meant what it used to
	  mean in prior versions of Asterisk), Mark Michelson suggested
	  using the full space available to display the settings which
	  helped to make the settings very clear. That was a great
	  suggestion. Therefore, this patch does the following: * The
	  column for 'Forcerport' now will show: Auto (Yes), Auto (No),
	  Yes, or No. * A column for the 'Comedia' setting has been added.
	  It too will display the setting in a non-cryptic way: Auto (Yes),
	  Auto (No), Yes, or No. * UPGRADE.txt has been updated to document
	  this change. (closes issue ASTERISK-22728) Reported by: Walter
	  Doekes Tested by: Michael L. Young Patches:
	  asterisk-forcerport-display-clarification_v3.diff uploaded by
	  Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2941 ........ Merged revisions
	  402111 from http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-27 23:22 +0000 [r402081-402090]  Matthew Jordan <mjordan@digium.com>

	* main/cdr.c: Filter out internal channels from dial message
	  handling Surrogate channels would pop up from time to time in
	  dial message handling. This would cause a WARNING message to
	  appear, indicating that the Surrogate channel had no CDR. This
	  patch filters out those channels that have the internal
	  implementation flag set, such that the WARNING message isn't
	  displayed.

	* main/cdr.c, cdr/cdr_sqlite3_custom.c, cdr/cdr_syslog.c,
	  cdr/cdr_sqlite.c, UPGRADE.txt, cdr/cdr_adaptive_odbc.c,
	  addons/cdr_mysql.c, include/asterisk/cdr.h, cdr/cdr_pgsql.c,
	  cdr/cdr_odbc.c, cdr/cdr_radius.c, cdr/cdr_custom.c,
	  cdr/cdr_manager.c, cdr/cdr_tds.c, cdr/cdr_csv.c: Prevent CDR
	  backends from unregistering while billing data is in flight This
	  patch makes it so that CDR backends cannot be unregistered while
	  active CDR records exist. This helps to prevent billing data from
	  being lost during restarts and shutdowns. Review:
	  https://reviewboard.asterisk.org/r/2880/

2013-10-26 12:55 +0000 [r402064]  Joshua Colp <jcolp@digium.com>

	* include/asterisk/res_pjsip_session.h, channels/chan_pjsip.c:
	  chan_pjsip: Fix a crash when direct media is enabled and an ACK
	  is received after the channel is hung up. (closes issue
	  ASTERISK-22731) Reported by: Kinsey Moore

2013-10-26 00:34 +0000 [r402044-402055]  Richard Mudgett <rmudgett@digium.com>

	* res/res_stasis.c: res_stasis.c: Made use the ao2_container
	  callback templates. * Made res_stasis.c use the OBJ_SEARCH_XXX
	  defines.

	* main/taskprocessor.c: taskprocessor: Made use pthread_equal() to
	  compare thread ids. * Removed another silly use of RAII_VAR().
	  RAII_VAR() and SCOPED_LOCK() are not silver bullets that allow
	  you to turn off your brain.

2013-10-25 23:48 +0000 [r402043]  Scott Griepentrog <sgriepentrog@digium.com>

	* include/asterisk/rtp_engine.h, main/rtp_engine.c, /: rtp_engine:
	  fix rtp payloads copy and improve argument names In function
	  ast_rtp_instance_early _bridge_make_compatible the use of
	  instance 0/1 as arguments doesn't clearly communicate a direction
	  that the copying of payloads from the source channel to the
	  destination channel will occur, making it more probable to have
	  the arguments to ast_rtp_codecs_payloads_copy() put in the
	  reverse order. This patch renames the arguments with _dst and
	  _src suffixes and corrects the copy direction. (closes issue
	  ASTERISK-21464) Reported by: Kevin Stewart Review:
	  https://reviewboard.asterisk.org/r/2894/ ........ Merged
	  revisions 402000 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 Test shows
	  rtpmap:119 being copied per this change, but is not in sip invite
	  ........ Merged revisions 402042 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-25 22:02 +0000 [r402003]  Richard Mudgett <rmudgett@digium.com>

	* res/stasis/app.c: You'd think that new files would be free of
	  whitespace issues. But you would be wrong.

2013-10-25 21:53 +0000 [r401973-402001]  Jonathan Rose <jrose@digium.com>

	* rest-api/api-docs/channels.json, res/ari/resource_channels.c,
	  res/res_ari_channels.c, rest-api/api-docs/bridges.json,
	  res/ari/resource_bridges.c, res/res_ari_bridges.c: ARI:
	  channel/bridge recording errors when invalid format specified
	  Asterisk will now issue 422 if recording is requested against
	  channels or bridges with an unknown format (closes issue
	  ASTERISK-22626) Reported by: Joshua Colp Review:
	  https://reviewboard.asterisk.org/r/2939/

	* res/res_ari_channels.c, rest-api/api-docs/bridges.json,
	  rest-api/api-docs/recordings.json, res/ari/resource_bridges.c,
	  res/ari/ari_model_validators.h, res/res_ari_bridges.c,
	  rest-api/api-docs/events.json, res/res_stasis_recording.c,
	  rest-api/api-docs/channels.json, res/ari/resource_channels.c,
	  res/ari/ari_model_validators.c: ARI recordings: Issue HTTP
	  failures for recording requests with file conflicts If a file
	  already exists in the recordings directory with the same name as
	  what we would record, issue a 422 instead of relying on the
	  internal failure and issuing success. (closes issue
	  ASTERISK-22623) Reported by: Joshua Colp Review:
	  https://reviewboard.asterisk.org/r/2922/

2013-10-25 20:47 +0000 [r401961]  Scott Griepentrog <sgriepentrog@digium.com>

	* include/asterisk/pbx.h, main/pbx.c, /: pbx.c: fix confused match
	  caller id that deleted exten still in hash This fixes a bug where
	  a zero length callerid match adjacent to a no match callerid
	  extension entry would be deleted together, which then resulted in
	  hashtable references to free'd memory. A third state of the
	  matchcid value has been added to indicate match to any extension
	  which allows enforcing comparison of matchcid on/off without
	  errors. (closes issue AST-1235) Reported by: Guenther Kelleter
	  Review: https://reviewboard.asterisk.org/r/2930/ ........ Merged
	  revisions 401959 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401960 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-25 17:34 +0000 [r401897-401938]  Jonathan Rose <jrose@digium.com>

	* res/res_pjsip/pjsip_distributor.c,
	  res/res_pjsip_endpoint_identifier_user.c: PJSIP: Add log messages
	  when requests are received for non-existent endpoints (closes
	  issue ASTERISK-22552) Reported by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/2934/

	* utils/clicompat.c, utils/refcounter.c, /: Put clicompat-r2.patch
	  back in We've figured out how to resolve the problems this was
	  causing in 12/trunk, so this can go back in now. (issue
	  ASTERISK-22467) Reported by: Corey Farrell Patches:
	  clicompat-r2.patch uploaded by coreyfarrell (license 5909)
	  ........ Merged revisions 401914 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401935 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, utils/clicompat.c: revert clicompat-r2.patch from r401704
	  Patch caused the following build errors against testsuite
	  https://bamboo.asterisk.org/bamboo/browse/AST-ATRUNKBUILD4-244
	  (issue ASTERISK-22467) Reported by: Corey Farrell ........ Merged
	  revisions 401895 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401896 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-25 16:07 +0000 [r401885]  Kevin Harwell <kharwell@digium.com>

	* /, channels/chan_sip.c: chan_sip: Allow a sip peer to accept both
	  AVP and AVPF calls Adapts the behaviour of avpf to only impact
	  the format of outgoing calls. For inbound calls, both AVP and
	  AVPF calls will be accepted regardless of the value of avpf in
	  the configuration. (closes issue ASTERISK-22005) Reported by:
	  Torrey Searle Patches: optional_avpf_trunk.patch uploaded by
	  tsearle (license 5334) ........ Merged revisions 401884 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-25 13:48 +0000 [r401872]  David M. Lee <dlee@digium.com>

	* tests/test_json.c: test_json: Fix deprecation warnings After a
	  series of upgrades over recent weeks, I've discovered that
	  test_json.c won't compile in dev mode any more for me. One of
	  gcc-4.8.2, OS X Mavericks or Xcode 5 has decided to deprecate
	  tempnam. Which, in general, is a good thing. But for test code
	  that just needs a temporary file, it's just annoying. This patch
	  replaces usage of tempname with mkstemp, avoiding the deprecation
	  warning. It also removes the temporary files when the test is
	  complete, which apparently we weren't doing before (oops).
	  Review: https://reviewboard.asterisk.org/r/2957/

2013-10-24 20:56 +0000 [r401835]  Kevin Harwell <kharwell@digium.com>

	* /, main/logger.c: Logging: Logging types ignored after specifying
	  a verbose level If one specified a verbose level within a logging
	  facility in logger.conf then any component after it was ignored.
	  Fixed so all values are correctly read. (closes issue
	  ASTERISK-22456) Reported by: Kevin Harwell ........ Merged
	  revisions 401833 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-24 20:34 +0000 [r401706-401831]  Jonathan Rose <jrose@digium.com>

	* main/utils.c, /: utils: Fix memory leaks and missed
	  unregistration of CLI commands on shutdown Final set of patches
	  in a series of memory leak/cleanup patches by Corey Farrell
	  (closes issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  main-utils-1.8.patch uploaded by coreyfarrell (license 5909)
	  main-utils-11.patch uploaded by coreyfarrell (license 5909)
	  main-utils-12up.patch uploaded by coreyfarrell (license 5909)
	  ........ Merged revisions 401829 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401830 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* tests/test_linkedlists.c, /: test_linkedlists: Fix memory leak
	  (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  test_linkedlists-1.8.patch uploaded by coreyfarrell (license
	  5909) test_linkedlists-11up.patch uploaded by coreyfarrell
	  (license 5909) ........ Merged revisions 401790 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401791 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, main/jitterbuf.c: jitterbuf: Fix memory leak on jitter buffer
	  reset (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  jitterbuf-jb_reset-leak-1.8.patch
	  jitterbuf-jb_reset-leak-11up.patch ........ Merged revisions
	  401786 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 401787 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* /, main/astobj2.c: astobj2: Unregister debug CLI commands at exit
	  (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  astobj2-clean-debug-cli-1.8-11.patch uploaded by coreyfarrell
	  (license 5909) astobj2-clean-debug-cli-12up.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 401781 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401783 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* apps/app_voicemail.c, /: app_voicemail: Memory Leaks against
	  tests (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  app_voicemail-1.8.patch uploaded by coreyfarrell (license 5909)
	  app_voicemail-11up.patch uploaded by coreyfarrell (license 5909)
	  ........ Merged revisions 401743 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401744 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/app.c, main/asterisk.c, utils/clicompat.c,
	  channels/chan_dahdi.c, codecs/ilbc/doCPLC.c, main/data.c, /:
	  memory leaks: Memory leak cleanup patch by Corey Farrell (second
	  set) Also covers ast_app_parse_timelen-fail-zero-length.patch,
	  but the patch was replaced with one of my own. (issue
	  ASTERISK-22467) Reported by: Corey Farrell Patches:
	  chan_dahdi-cleanup_push.patch uploaded by coreyfarrell (license
	  5909) clicompat-r2.patch uploaded by coreyfarrell (license 5909)
	  codecs-ilbc-doCPLC.patch uploaded by coreyfarrell (license 5909)
	  data-cleanup-test-registration.patch uploaded by coreyfarrell
	  (license 5909) main-asterisk-kill-listener.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 401704 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401705 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-24 03:12 +0000 [r401701]  David M. Lee <dlee@digium.com>

	* rest-api-templates/ari_model_validators.c.mustache,
	  rest-api-templates/models.wiki.mustache,
	  rest-api/api-docs/events.json,
	  rest-api-templates/swagger_model.py: The Swagger 1.2
	  specification for type extension ended up being slightly
	  different than my proposal. Instead of putting an 'extends' field
	  on the subtype, the base type has a 'subTypes' field, which is a
	  list of the subTypes. Given that its a messaging model and not an
	  object model, kinda makes sense. This patch changes the
	  events.json api-doc, and the python translators to take the new
	  format into account. Other changes that are in Swagger 1.2 were
	  not adopted, since the spec is still in flux, and could change
	  before it's finalized. A summary of changes to the Swagger-1.2
	  spec can be found at
	  https://github.com/wordnik/swagger-core/wiki/1.2-transition.
	  (closes issue ASTERISK-22440) Review:
	  https://reviewboard.asterisk.org/r/2909/

2013-10-23 20:02 +0000 [r401621-401662]  Jonathan Rose <jrose@digium.com>

	* /, tests/test_dlinklists.c, funcs/func_math.c,
	  channels/sip/reqresp_parser.c, main/test.c,
	  main/editline/readline.c: memory leaks: Memory leak cleanup patch
	  by Corey Farrell (first set) (issue ASTERSIK-22467) Reported by:
	  Corey Farrell Patches:
	  chan_sip-parse_contact_header_test-free-contacts.patch uploaded
	  by coreyfarrell (license 5909) cli-filename-completion-leak.patch
	  uploaded by coreyfarrell (license 5909) func_math.patch uploaded
	  by corefarrell (license 5909) main-test-cleanup.patch uploaded by
	  coreyfarrell (license 5909) test_dlinklists.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 401660 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401661 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_rtp_asterisk.c, /, main/translate.c: res_rtp_asterisk:
	  Address jittery DTMF events in RTP streams (closes issue
	  ASTERISK-21170) Reported by: NITESH BANSAL Patches:
	  dtmf-timestamp.patch uploaded by NITESH BANSAL (license 6418)
	  Review: https://reviewboard.asterisk.org/r/2938/ ........ Merged
	  revisions 401619 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401620 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-23 16:49 +0000 [r401581]  Richard Mudgett <rmudgett@digium.com>

	* cdr/cdr_adaptive_odbc.c, /: cdr_adaptive_odbc: Also apply a
	  filter when the CDR value is empty. Extra CDR records are written
	  if a filtered CDR value is empty because the filter is not
	  checked. (closes issue ASTERISK-22272) Reported by: Jordi Llull
	  Chavarria ........ Merged revisions 401577 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401579 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-23 16:37 +0000 [r401578]  John Bigelow <jbigelow@digium.com>

	* main/bridge_channel.c: Add a test suite event to indicate when
	  the atxfer 3-way feature is detected This adds a test suite event
	  that indicates to tests when the attended transfer three-way call
	  feature is detected. Review:
	  https://reviewboard.asterisk.org/r/2912/

2013-10-23 15:23 +0000 [r401539]  Kinsey Moore <kmoore@digium.com>

	* channels/chan_mgcp.c, /: chan_mgcp: Properly handle malformed
	  media lines This corrects a situation in which a media line was
	  not parsed properly and resulted in a crash. (closes issue
	  ASTERISK-21190) Reported by: adomjan Patches:
	  chan_mgcp.c-sscnaf_fix uploaded by adomjan (License 5448)
	  ........ Merged revisions 401537 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401538 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-23 11:14 +0000 [r401499]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: chan_sip: Fix an issue where an
	  incompatible audio format may be added to SDP. If preferred
	  codecs included any non-audio format the code would mistakenly
	  add the audio format, even if it was not a joint capability with
	  the remote side. (closes issue ASTERISK-21131) Reported by:
	  nbougues Patches: patch_unsupported_codec_1.8.patch uploaded by
	  nbougues (license 6470) ........ Merged revisions 401497 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401498 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-23 02:31 +0000 [r401488]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/chan_iax2.c, configs/iax.conf.sample: chan_iax2: Fix
	  Binding To Multiple Addresses Again When reworking chan_iax2 for
	  IPv6, the ability to bind to multiple addresses was removed by
	  mistake. This patch restores this functionality and adds notes
	  about IPv6 addresses in the sample config. (closes issue
	  ASTERISK-22741) Reported by: Joshua Colp Tested by: Michael L.
	  Young Patches: asterisk-22741-fix-binding-multiple-addr.diff
	  uploaded by Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2945/

2013-10-22 22:50 +0000 [r401447]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: res_rtp_asterisk: Fix crash when RTCP
	  is not available during SSRC change In r400089, a patch was put
	  in to correct erroneous RTCP statistic resets. Unfortunately,
	  ast_rtp_read can be called on an RTP instance that does not have
	  RTCP information. This patch prevents that crash by only
	  resetting the statistics if we do actually have an RTCP instance.
	  (issue AST-1174) (closes issue ASTERISK-22667) Reported by: John
	  Bigelow ........ Merged revisions 401445 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401446 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-22 19:03 +0000 [r401420-401434]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_queue.c, /: app_queue: Fix CLI "queue remove member"
	  queue_log entry. The queue_log entry resulting from CLI "queue
	  remove member" when log_membername_as_agent is enabled is wrong.
	  It always uses the interface name instead of the member name in
	  the queue_log entry. * Get the queue member before removing it
	  from the queue so the member name is available for the queue_log
	  entry. (closes issue ASTERISK-21826) Reported by: Oscar Esteve
	  Patches: fix_membername.diff (license #6505) patch uploaded by
	  Oscar Esteve (modified to fix potential ref leak) ........ Merged
	  revisions 401433 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/bridge_channel.c,
	  include/asterisk/bridge_channel_internal.h, main/bridge.c:
	  Bridging: Fix orphaned bridge if neither of the joining channels
	  can join. The original issue noted that the bridge is orphaned
	  when res_parking.so is not loaded and a call uses the dial kK
	  flags. A similar issue happens when only one of the park flags is
	  used. In this case you have the bridge with one or the other
	  channel left in it. The channel and bridge will stay around until
	  the channel hangs up. * Fixed the initial bridge channel push
	  failure to act as if the channel were kicked out of the bridge.
	  The bridge then decides if it needs to be dissolved. (closes
	  issue ASTERISK-22629) Reported by: Kevin Harwell Review:
	  https://reviewboard.asterisk.org/r/2928/

	* res/parking/parking_bridge_features.c,
	  res/parking/parking_bridge.c: res_parking: Give parking timeout
	  comebacktoorigin channel DTMF features. Parking timeouts did not
	  set any DTMF features for the channel calling the parker back. *
	  Added code to set the parkedcalltransfers, parkedcallreparking,
	  parkedcallhangup, and parkedcallrecording options appropriately
	  for the channels when a parking timeout occurs. The recall
	  channel DTMF options are set using the BRIDGE_FEATURES channel
	  variable to allow the other timeout options to have the DTMF
	  features available. (closes issue ASTERISK-22630) Reported by:
	  Kevin Harwell Review: https://reviewboard.asterisk.org/r/2942/

	* res/res_parking.c: res_parking: Update XML documention for DTMF
	  features after parking timeout. * Updated the XML documentation
	  to indicate that the parkedcalltransfers, parkedcallreparking,
	  parkedcallhangup, and parkedcallrecording configuration options
	  also apply to parking timeouts. (issue ASTERISK-22630) Reported
	  by: Kevin Harwell Review:
	  https://reviewboard.asterisk.org/r/2942/

2013-10-21 21:05 +0000 [r401364]  Mark Michelson <mmichelson@digium.com>

	* main/bridge_channel.c: Remove a noisy debug message from bridging
	  code. This particular debug message, during a stress test, was
	  logged so often that it appeared that there may be a memory leak
	  in the logger code. In actuality, there was no memory leak, but
	  the logger thread was having a hard time keeping up with the
	  demands of the rest of the system. Since this debug message has
	  no value at all, the best way to fix the problem was to just
	  remove the message. (closes issue AST-1225) reported by John
	  Bigelow Patches: spammy_log.diff uploaded by Mark Michelson
	  (License #5049)

2013-10-21 19:48 +0000 [r401327]  Kevin Harwell <kharwell@digium.com>

	* main/editline/term.c, /: Segfault in LIBEDIT_INTERNAL after
	  tgetstr(), when libncurses5-dev isn't installed Include the
	  appropriate declarations when not using termcap, but term+curses
	  and [n]curses do not exist. (closes issue ASTERISK-22351)
	  Reported by: A. Iglesias Patches:
	  issueA22351_libedit_internal_without_ncurses_dev.patch uploaded
	  by wdoekes (license 5674) ........ Merged revisions 401325 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401326 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-21 18:58 +0000 [r401315]  David M. Lee <dlee@digium.com>

	* rest-api/api-docs/channels.json: Fixing r401281; the model name
	  is Channel, with a capital C

2013-10-19 21:53 +0000 [r401291]  Kinsey Moore <kmoore@digium.com>

	* channels/chan_iax2.c: Fix IAX2 incoming call address lookups This
	  fixes address lookup for incoming calls without a peer
	  definition. The address family was unset instead of being set to
	  AST_AF_UNSPEC which was causing lookup failures on "127.0.0.1".
	  This is one of the causes of the current failure of the app_page
	  integration test. Review:
	  https://reviewboard.asterisk.org/r/2933/

2013-10-19 14:43 +0000 [r401281]  Joshua Colp <jcolp@digium.com>

	* res/res_ari_channels.c, res/ari/resource_channels.h, main/pbx.c,
	  rest-api/api-docs/channels.json, res/ari/resource_channels.c:
	  Return a channel snapshot when originating using ARI, and
	  subscribe the Stasis application to it. This change allows a user
	  of ARI to know what channel it has originated and also follow any
	  progress. If a Stasis application is provided it will be
	  automatically subscribed to the originated channel immediately.
	  (closes issue ASTERISK-22485) Reported by: David Lee Review:
	  https://reviewboard.asterisk.org/r/2910/

2013-10-18 22:51 +0000 [r401271]  Richard Mudgett <rmudgett@digium.com>

	* res/parking/parking_controller.c: res_parking: Remove setting
	  useless flag.

2013-10-18 21:49 +0000 [r401261]  David M. Lee <dlee@digium.com>

	* contrib/scripts/get_swagger_ui.sh (added), Makefile, static-http:
	  This is just a quick script for dumping swagger-ui into
	  static-http, so that it can be served by the Asterisk web server.
	  I had to change the Makefile in order to recursively install
	  content from the static-http directory, hence the code review
	  instead of just putting it in. Review:
	  https://reviewboard.asterisk.org/r/2924/

2013-10-18 18:33 +0000 [r401248]  Mark Michelson <mmichelson@digium.com>

	* main/manager.c, main/bridge.c, main/bucket.c, main/sorcery.c,
	  main/cli.c: Resolve some memory leaks due to incorrect for loop /
	  ao2 ref usage. A common idiom in Asterisk is to due something
	  like: for (ao2_obj = list_beginning; ao2_obj = next_item;
	  ao2_ref(ao2_obj, -1)) { ...do stuff... } This is nice because it
	  automatically takes care of the object references for you.
	  However, there is a pitfall here. If a break statement is in the
	  for loop, then the current reference is not cleaned up. In some
	  cases, this is on purpose, but in others there is a leak. This
	  commit fixes the leak cases.

2013-10-18 16:52 +0000 [r401232-401239]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_dial.c, main/channel.c, res/res_fax.c,
	  include/asterisk/channel.h: Add channel lock protection around
	  translation path setup. Most callers of
	  ast_channel_make_compatible() happen before the channels enter a
	  two party bridge. With the new bridging framework, two party
	  bridging technologies may also call ast_channel_make_compatible()
	  when there is more than one thread involved with the two
	  channels. * Added channel lock protection in set_format() and
	  ast_channel_make_compatible_helper() when dealing with the
	  channel's native formats while setting up a translation path. *
	  Fixed best_src_fmt and best_dst_fmt usage consistency in
	  ast_channel_make_compatible_helper(). The call to
	  ast_translator_best_choice() got them backwards. * Updated some
	  callers of ast_channel_make_compatible() and the function
	  documentation. There is actually a difference between the two
	  channels passed in. * Fixed the deadlock potential in res_fax.c
	  dealing with ast_channel_make_compatible(). The deadlock
	  potential was already there anyway because res_fax called
	  ast_channel_make_compatible() with chan locked. (closes issue
	  ASTERISK-22542) Reported by: Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/2915/

	* include/asterisk/bridge.h: Tweak ast_bridge_depart() doxygen.

2013-10-18 16:05 +0000 [r401212-401223]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/bridge.h: Remove the bit about requiring
	  ast_bridge_depart() to be called before ast_bridge_destroy().

	* include/asterisk/bridge.h: Clarify in ast_bridge_destroy() about
	  how departable channels must be handled.

2013-10-18 15:13 +0000 [r401183]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Remove Port Restriction When Checking For
	  NAT When trying to determine if a peer is behind NAT, we should
	  not be using the ports when comparing addresses. This patch
	  removes the port from being checked and just useds the addresses
	  now. (closes issue ASTERISK-22729) Reported by: Michael L. Young
	  Tested by: Michael L. Young Patches:
	  asterisk-remove-using-port-for-nat-check.diff uploaded by Michael
	  L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2927/ ........ Merged
	  revisions 401182 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-18 14:47 +0000 [r401180]  Walter Doekes <walter+asterisk@wjd.nu>

	* main/channel.c, /: Properly copy/remove the device state cache
	  flag over a masquerade. In r378303 the
	  AST_FLAG_DISABLE_DEVSTATE_CACHE flag was added that tells the
	  devstate system to not cache states for non-real devices.
	  However, when optimizing away channels (ast_do_masquerade), that
	  flag wasn't copied. In my case, using Local devices as queue
	  members created a situation where the endpoint was considered in
	  use, but the state change of the device being available again was
	  ignored (not cached). The endpoint channel was optimized into the
	  (previously) Local channel, but kept the do-not-cache flag. The
	  end result being that the queue member apparently stayed in use
	  forever. (closes issue ASTERISK-22718) Reported by: Walter Doekes
	  Review: https://reviewboard.asterisk.org/r/2925/ ........ Merged
	  revisions 401178 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401179 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-17 20:37 +0000 [r401168]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix Setting A chan_sip Dialog's
	  SIP_NAT_FORCE_RPORT Flag A condition was added in a commit to fix
	  ASTERISK-21374, that, if the SIP_PAGE3_NAT_AUTO_RPORT flag was
	  set, to then copy a peer's SIP_NAT_FORCE_RPORT flag to the
	  dialog. This condition should not have been there since it
	  assumed that if Asterisk is in an environment where NAT is
	  involved, that the auto_* nat settings or force_rport setting
	  would be on in the global settings. If the nat setting in the
	  global setting is set to 'nat=no' and then turned on for peers
	  (which is not quite the recommended way, although it is allowed)
	  this flag is never copied to the dialog resulting in problems
	  like, REGISTER replies going to the wrong port. This patch
	  removes this conditional check and will now always use the peer's
	  flag which by this point in the code the checks on whether the
	  peer is behind NAT or not (if using auto_force_rport) have
	  already been run. (closes issue ASTERISK-22236) Reported by:
	  Filip Frank Tested by: Michael L. Young Patches:
	  asterisk-2236-always-set-rport.diff uploaded by Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2919/
	  ........ Merged revisions 401167 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-17 18:16 +0000 [r401158]  Jonathan Rose <jrose@digium.com>

	* res/res_parking.c: res_parking: Fix bug where reloading
	  immediately wipes new parkpos extensions (closes issue
	  ASTERISK-22631) Reported by: Kevin Harwell

2013-10-17 15:40 +0000 [r401121]  Kinsey Moore <kmoore@digium.com>

	* /, res/res_xmpp.c, res/res_jabber.c: Reduce log level of a
	  non-pubsub error message Drop an error log message to debug level
	  1 since distributed device state functions correctly when
	  receiving this message and it spams the logs. (closes issue
	  ASTERISK-22410) Reported by: abelbeck Patches:
	  asterisk-1.8-res_jabber-log-nonpubsub-error-to-debug.patch
	  uploaded by abelbeck (License 5903)
	  asterisk-11-res_xmpp-log-nonpubsub-error-to-debug.patch uploaded
	  by abelbeck (License 5903) ........ Merged revisions 401119 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401120 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-16 21:20 +0000 [r401107]  Richard Mudgett <rmudgett@digium.com>

	* res/ari/resource_playback.c: ARI: Fix crash when POST
	  /playback/{id}/control does not have an operation parameter.
	  (closes issue ASTERISK-22680) Reported by: John Bigelow

2013-10-16 21:17 +0000 [r401096-401106]  David M. Lee <dlee@digium.com>

	* res/res_ari.c: Fixed malformed Access-Control-Allow-Methods
	  header. Was causing Safari to barf on POST and DELETE.

	* rest-api/resources.json: Oops. Leftover /stasis reference

2013-10-16 14:01 +0000 [r401087]  Kinsey Moore <kmoore@digium.com>

	* res/ari/resource_bridges.h, rest-api/api-docs/channels.json,
	  rest-api/api-docs/bridges.json, res/ari/resource_channels.h:
	  Clarify documentation for channel and bridge list This makes it
	  clear that the ARI API calls for listing channels and bridges
	  will list all channels or bridges in the system and not just
	  those that are in or are controlled by a Stasis application.
	  (closes issue ASTERISK-22635) Reported by: Kevin Harwell

2013-10-16 12:12 +0000 [r401077]  Walter Doekes <walter+asterisk@wjd.nu>

	* apps/app_queue.c, /: Don't check all realtime queues when doing
	  "queue show some_queue". When using realtime queues, queues have
	  to be fetched from the database every now and then to see if any
	  info has been changed or to see if the queue has been removed.
	  When fetching info for an individual queue, the pruning of other
	  queues is unnecessarily costly. Review:
	  https://reviewboard.asterisk.org/r/2907/ ........ Merged
	  revisions 401049 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 401076 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-16 00:02 +0000 [r401040]  Paul Belanger <paul.belanger@polybeacon.com>

	* res/res_ari_bridges.c, rest-api/api-docs/bridges.json: Use POST /
	  DELETE to toggle ARI bridge moh Review:
	  https://reviewboard.asterisk.org/r/2911/

2013-10-15 20:25 +0000 [r401030]  Richard Mudgett <rmudgett@digium.com>

	* channels/dahdi/bridge_native_dahdi.c: bridge_native_dahdi: Return
	  channel join failure if could not make the channels compatible.

2013-10-15 20:02 +0000 [r401018]  Kinsey Moore <kmoore@digium.com>

	* rest-api/api-docs/bridges.json, res/res_ari_bridges.c: Ensure
	  bridge record error responses validate This adds the list of
	  expected errors to the /bridges/{bridgeId}/record ARI
	  documentation so that outbound 4xx errors validate properly.
	  Previously, this would result in a response validation failure.
	  (closes issue ASTERISK-22627) Reported by: Joshua Colp

2013-10-15 20:01 +0000 [r401017]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_iax2.c: chan_iax2: Fix channel left locked in
	  off nominal code path. ........ Merged revisions 401016 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-15 15:26 +0000 [r400999]  Paul Belanger <paul.belanger@polybeacon.com>

	* rest-api/api-docs/channels.json, res/res_ari_channels.c: Use POST
	  / DELETE to toggle hold / moh for ARI channels This change
	  updates how we handle toggle events, rather then create two
	  different function names, we'll just use POST / DELETE from HTTP
	  to handle it. Review: https://reviewboard.asterisk.org/r/2906/

2013-10-15 15:21 +0000 [r400984]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Prevent chan_sip from sending duplicate
	  BYEs. When a 200 OK for an initial INVITE is received, we were
	  doing the right thing by ACKing and sending an immediate BYE.
	  However, we also were doing the wrong thing and queuing an answer
	  frame, thus causing the call to be answered. This would cause the
	  call to be hung up by the channel thread, thus resulting in a
	  second BYE being sent out. In this fix, I also have set the
	  hangupcause to be correct since the initial BYE being sent by
	  Asterisk had an unknown hangup cause. I have changed to using
	  "Bearer capabilty not available" since the call was hung up due
	  to an SDP offer/answer error. (closes issue ASTERISK-22621)
	  reported by Kinsey Moore ........ Merged revisions 400970 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400971 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-15 13:43 +0000 [r400958]  David M. Lee <dlee@digium.com>

	* rest-api-templates/asterisk_processor.py: My doc correction in
	  r400842 had a silly bug. Because I added a wiki_description to
	  models and not their properties, the rendered wiki page had the
	  model description instead of the property descriptions, which
	  looks very silly indeed. (closes issue ASTERISK-22705)

2013-10-14 21:55 +0000 [r400911]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_dahdi.h, channels/chan_dahdi.c: chan_dahdi:
	  Reflect the set software gain in the CLI "dahdi show channel"
	  output. * Remember the swgain setting from CLI "dahdi set swgain"
	  command so the CLI "dahdi show channel" output will reflect the
	  current setting. * Updated CLI "dahdi set hwgain" and "dahdi set
	  swgain" documentation. (issue ASTERISK-22429) Reported by: Jaco
	  Kroon Patches: jira_asterisk_22429_v1.8_v2.patch (license #5621)
	  patch uploaded by rmudgett ........ Merged revisions 400907 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400909 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-14 21:52 +0000 [r400910]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: chan_sip: Do not increment the SDP
	  version between 183 and 200 responses. Bumping the SDP version
	  number can cause interoperability problems since receivers of the
	  responses will expect that a 200 SDP will be identical to a
	  previous 183 SDP. (closes issue ASTERISK-21204) reported by
	  NITESH BANSAL Patches:
	  dont-increment-session-version-in-2xx-after-183.patch uploaded by
	  NITESH BANSAL (License #6418) ........ Merged revisions 400906
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8 ........
	  Merged revisions 400908 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-14 15:52 +0000 [r400890]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip_outbound_registration.c: pjsip outbound
	  registration: Log message says received a 408 when we didn't If
	  the server didn't exist that we are trying to register to the log
	  message would say that a 408 was received from that server when
	  in reality one wasn't. Added log messages stating no response was
	  received if the response does not exist. (closes issue
	  ASTERISK-22554) Reported by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/2893/

2013-10-14 14:57 +0000 [r400881]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip_mwi.c: Remove duplicate module info block The
	  module info block was repeated twice. Once is sufficient.

2013-10-13 15:41 +0000 [r400872]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_session.c: Fix a race condition in
	  res_pjsip_session with rapidly terminating the session. The
	  INVITE session state callback wrongly assumes that a session will
	  always exist, but when rapidly terminating the session this
	  assumption goes out the window. As all handler code for the
	  INVITE session state callback requires the session it will now
	  just exit immediately if no session exists. (closes issue
	  ASTERISK-22668) Reported by: John Bigelow

2013-10-12 16:49 +0000 [r400863]  Kinsey Moore <kmoore@digium.com>

	* res/res_pjsip_outbound_authenticator_digest.c: Fix realm
	  comparison for outbound auth When generating the list of
	  authentication credentials to pass to PJSIP, Asterisk was using
	  the raw pointer of a pj_str_t which is not always
	  NULL-terminated. This sometimes resulted in incorrect text for
	  the realm and a failure to match the realm for authentication
	  purposes which was causing the outbound nominal auth pjsip basic
	  call test to bounce. This now uses the pj_str_t that contains the
	  realm instead of generating a new one. Thanks to John Bigelow for
	  helping to narrow this down.

2013-10-11 16:53 +0000 [r400849-400854]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/channel.h: channel.h: whitespace changes.

	* bridges/bridge_softmix.c: Softmix: Fix crash when switching from
	  softmix to another bridge technology. The crash is caused by a
	  race condition when switching between native RTP and softmix
	  bridging technologies. In this situation, the bridging technology
	  is switched from native RTP to softmix, and then back to native
	  RTP fast enough that the softmix private data gets destroyed
	  before the softmix mixing thread gets started. Thanks to Kinsey
	  Moore for the crash analysis. * Fix race condition when starting
	  the softmix mixing thread and switching to another bridge
	  technology. (closes issue ASTERISK-22678) Reported by: John
	  Bigelow Patches: jira_asterisk_22678_v12.patch (license #5621)
	  patch uploaded by rmudgett Tested by: John Bigelow

2013-10-11 16:18 +0000 [r400842-400848]  David M. Lee <dlee@digium.com>

	* res/ari/resource_playback.h, rest-api/api-docs/playback.json: Fix
	  a stupid copy/paste error in ARI docs. Patches: ari-doc-patch.txt
	  uploaded by jbigelow (license 5091)

	* res/ari/resource_bridges.h, rest-api/api-docs/channels.json,
	  rest-api/api-docs/bridges.json, res/ari/resource_channels.h:
	  Updated /play resource docs. The playback of http: resources
	  isn't implemented... yet

	* rest-api-templates/models.wiki.mustache,
	  rest-api-templates/api.wiki.mustache,
	  rest-api-templates/asterisk_processor.py: Correct some ARI wiki
	  rendering errors

2013-10-10 18:21 +0000 [r400824-400833]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip/location.c: Perform validation of permanent
	  contacts on AORs in res_pjsip.

	* res/res_pjsip/pjsip_configuration.c, res/res_pjsip.c: Fix an
	  assertion in res_pjsip when specifying an invalid outbound proxy.
	  This change fixes two issues when setting an outbound proxy: 1.
	  The outbound proxy URI was not parsed and validated during
	  configuration. 2. If an outgoing dialog was created and the
	  outbound proxy could not be set an assertion would occur because
	  the usage count on the dialog was not decremented. The
	  documentation has also been updated to specify that a full URI
	  must be specified for the outbound proxy. (closes issue
	  ASTERISK-22672) Reported by: Antti Yrjola

2013-10-09 11:00 +0000 [r400771-400812]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip_header_funcs.c: Use 'z' as the format specifier for
	  size_t Using 'lu' will produce a compiler warning for some
	  versions of gcc and on some architectures. 'z' should be portable
	  as a format specifier for size_t.

	* res/res_pjsip_header_funcs.c (added): Add PJSIP_HEADER function
	  for manipulation of SIP headers in the PJSIP stack This patch
	  adds support to the PJSIP stack in Asterisk for SIP header
	  manipulation. Note that this is analagous to
	  SIPAddHeader/SIPRemoveHeader. For PJSIP_HEADER, an incoming
	  supplemental session callback is registered that takes the
	  pjsip_hdrs from the incoming session and stores them in a linked
	  list in the session datastore. Calls to PJSIP_HEADER traverse
	  over the list and return the nth matching header where 'n' is the
	  'number' argument to the function. When adding a header, the
	  first call creates a datastore and linked list and adds the
	  datastore to the session. The header is then created as a
	  pjsip_hdr and added to the list. An outgoing supplemental session
	  callback then traverses the list and adds the headers to the
	  outgoing pjsip_msg. When removing a header, the list created with
	  PJSIP_HEADER(add,...) is traversed and all matching entries are
	  removed. (closes issue ASTERISK-22498) Reported by: George Joseph
	  patch: res_pjsip_header_funcs_v1.patch uploaded by george.joseph
	  (License 6322)

2013-10-08 22:30 +0000 [r400769]  Kinsey Moore <kmoore@digium.com>

	* /, configure, configure.ac: Add warning when compiling with iODBC
	  support When running configure, libiodbc2 development headers
	  will fulfill the requirement for ODBC development headers, but
	  will not function properly. This adds a warning when libiodbc2
	  development headers are detected instead of unixodbc development
	  headers. (closes issue ASTERISK-22459) Reported by: Patrick
	  Maille Tested by: Walter Doekes Patches:
	  issueA22459_warn_when_using_iodbc.patch uploaded by Walter Doekes
	  (License 5674) ........ Merged revisions 400767 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400768 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-08 21:19 +0000 [r400754]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_agent_pool.c: app_agent_pool: Fix AMI/CLI AgentLogoff
	  soft preventing agents from logging back in. * Clear the
	  deferred_logoff flag when an agent logs in. (closes issue
	  ASTERISK-22669) Reported by: John Bigelow

2013-10-08 20:51 +0000 [r400749]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip.c, res/res_pjsip/config_transport.c: Switch from
	  using pjsip_strerror to pj_strerror. pjsip_strerror is only aware
	  of PJSIP-specific error codes. pj_strerror() is aware of all
	  PJProject error codes and OS-specific error codes. This
	  specifically fixes an oft-seen error in transport configuration
	  code where EADDRINUSE would result in "Unknown PJSIP error
	  120098" instead of a useful message.

2013-10-08 20:16 +0000 [r400724-400742]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_confbridge.c, CHANGES,
	  apps/confbridge/conf_config_parser.c,
	  configs/confbridge.conf.sample, /,
	  apps/confbridge/include/confbridge.h: app_confbridge: Can now set
	  the language used for announcements to the conference. ConfBridge
	  now has the ability to set the language of announcements to the
	  conference. The language can be set on a bridge profile in
	  confbridge.conf or by the dialplan function
	  CONFBRIDGE(bridge,language)=en. (closes issue ASTERISK-19983)
	  Reported by: Jonathan White Patches: M19983_rev2.diff (license
	  #5138) patch uploaded by junky (modified) Tested by: rmudgett
	  ........ Merged revisions 400741 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* apps/confbridge/conf_config_parser.c, /: app_confbridge: Fix
	  duplicate default_user profile. * Fixed looking in the wrong
	  profiles container to see if the default_user profile is already
	  created in verify_default_profiles(). The bridge profile
	  container is never going to hold user profiles. :) ........
	  Merged revisions 400723 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-08 18:19 +0000 [r400682-400701]  Kinsey Moore <kmoore@digium.com>

	* funcs/func_config.c, /: Fix func_config list entry allocation The
	  AST_CONFIG dialplan function defined in func_config.c allocates
	  its config file list entries using ast_malloc. List entry
	  allocations destined for use with Asterisk's linked list API must
	  be ast_calloc()d or otherwise initialized so that list pointers
	  are set to NULL. These uses of ast_malloc have been replaced by
	  ast_calloc to prevent dereferencing of uninitialized pointer
	  values when traversing the list. (closes issue ASTERISK-22483)
	  Reported by: Brian Scott ........ Merged revisions 400694 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400697 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* res/res_rtp_asterisk.c, /: Fix STUN crash when using IPv6 any
	  address Ensure that when chan_sip binds to the IPv6 any address
	  ([::]), IPv4 candidates are also added. (closes issue
	  ASTERISK-21917) Reported by: Torrey Searle Patches:
	  0023_ipv6_stun_crash.patch uploaded by Torrey Searle (License
	  5334) ........ Merged revisions 400681 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-08 15:36 +0000 [r400680]  Mark Michelson <mmichelson@digium.com>

	* res/res_pjsip/pjsip_options.c: Push CLI qualify into the
	  threadpool. If you run Asterisk in the background and then
	  connect to it through a separate console, the thread that runs
	  CLI commands is not registered with PJLIB. Thus PJLIB does not
	  like it when you attempt to send OPTIONS requests from that
	  thread. So now we push the task into the threadpool, which we
	  know to be registered with PJLIB. Thanks to Antti Yrjola for
	  reporting this.

2013-10-08 15:11 +0000 [r400661-400671]  Richard Mudgett <rmudgett@digium.com>

	* res/res_agi.c, apps/app_queue.c: Make app_queue and res_agi
	  independent of AMI being enabled. The
	  https://reviewboard.asterisk.org/r/2888/ review changes manager
	  to not subscribe to stasis when it is disabled for performance
	  reasons. When manager is disabled app_queue and res_agi decline
	  to load and fail to clean up what they have already allocated. *
	  Made app_queue and res_agi clean up allocated resources when they
	  decline to load. * Made app_queue and res_agi use their own
	  subscriptions to the stasis topics instead of borrowing manager's
	  message router structure inappropriately. (closes issue
	  ASTERISK-22604) Reported by: rmudgett Review:
	  https://reviewboard.asterisk.org/r/2902/

	* include/asterisk/stasis.h, apps/app_queue.c,
	  include/asterisk/manager.h: Miscellaneous stand alone comment
	  cleanups.

2013-10-06 17:11 +0000 [r400624]  Michael L. Young <elgueromexicano@gmail.com>

	* apps/app_queue.c, /: app_queue: Fix Queuelog EXITWITHKEY only
	  logging two of four fields Commit r62462 added two extra fields
	  for logging "the original position the caller entered the queue
	  at, and the amount of time the caller was waiting in the queue."
	  But when r75969 was merged from 1.4 into trunk (r75977), these
	  two fields disappeared. Those two extra fields were not logged in
	  1.4 and when the patch was merged, those fields went away.
	  Therefore, this is a regression and was caught by the reporter
	  because he was reading the awesome "Asterisk: The Definitive
	  Guide" book. (closes issue ASTERISK-22197) Reported by: Dalius M.
	  Tested by: Dalius M. Patches:
	  asterisk-22197-q-log-exitwithkey.diff uploaded by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2901/ ........ Merged
	  revisions 400622 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400623 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-05 00:41 +0000 [r400588]  Richard Mudgett <rmudgett@digium.com>

	* channels/iax2/include/parser.h: chan_iax2: Fix compile error.

2013-10-04 21:40 +0000 [r400567]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/iax2/include/parser.h, main/acl.c,
	  include/asterisk/netsock2.h, CHANGES, channels/chan_iax2.c,
	  channels/iax2/parser.c, main/netsock.c, main/netsock2.c: Add IPv6
	  Support To chan_iax2 This patch adds IPv6 support to chan_iax2.
	  Yay! (closes issue ASTERISK-22025) Patches:
	  iax2-ipv6-v5-reviewboard.diff by Michael L. Young (license 5026)
	  Review: https://reviewboard.asterisk.org/r/2660/

2013-10-04 19:31 +0000 [r400552]  David M. Lee <dlee@digium.com>

	* rest-api/api-docs/applications.json (added): Added missing file
	  from r400522

2013-10-04 18:42 +0000 [r400532-400542]  Jonathan Rose <jrose@digium.com>

	* res/res_pjsip_logger.c: chan_pjsip: Make logger togglable without
	  loading/unloading This patch makes the res_pjsip_logger do a few
	  things... First, it will be built and installed by default now,
	  so end users won't need to enable it in menuselect. Second, while
	  it is loaded, it no longer will immediately issue log messages.
	  Upon loading, it is in the disabled state and must be turned on
	  with the new CLI command. The CLI command 'pjsip set logger
	  <on/off/host> has been added and can be used to do the following:
	  pjsip set logger on: Enables logger for all PJSIP traffic pjsip
	  set logger off: Disables logger for all PJSIP traffic pjsip set
	  logger host <host>: Enables logger for the specific host Review:
	  https://reviewboard.asterisk.org/r/2900/

	* contrib/ast-db-manage/config/versions/4da0c5f79a9c_create_tables.py,
	  configs/extconfig.conf.sample, configs/sorcery.conf.sample,
	  contrib/ast-db-manage/config/versions/43956d550a44_add_tables_for_pjsip.py
	  (added): chan_pjsip: Add alembic scripts for generating db tables
	  for PJSIP Also updates sample configurations for sorcery and
	  extconfig to demonstrate how to use databases created by that
	  alembic script. (closes issue ASTERISK-22133) Reported by: Matt
	  Jordan Review: https://reviewboard.asterisk.org/r/2892/

2013-10-04 15:54 +0000 [r400522]  Matthew Jordan <mjordan@digium.com>

	* res/stasis/app.h, rest-api/resources.json,
	  include/asterisk/_private.h, main/endpoints.c,
	  res/ari/ari_model_validators.c, res/ari/ari_model_validators.h,
	  res/res_ari_model.c, main/json.c, res/ari.make,
	  res/ari/resource_applications.c (added),
	  res/ari/resource_applications.h (added), res/res_stasis.c,
	  main/asterisk.c, rest-api/api-docs/endpoints.json,
	  rest-api/api-docs/events.json, res/stasis/app.c,
	  include/asterisk/endpoints.h,
	  rest-api-templates/ari_model_validators.h.mustache,
	  res/res_ari_applications.c (added), res/ari/resource_endpoints.h,
	  include/asterisk/stasis_app.h: ARI: Add subscription support This
	  patch adds an /applications API to ARI, allowing explicit
	  management of Stasis applications. * GET /applications - list
	  current applications * GET /applications/{applicationName} - get
	  details of a specific application * POST
	  /applications/{applicationName}/subscription - explicitly
	  subscribe to a channel, bridge or endpoint * DELETE
	  /applications/{applicationName}/subscription - explicitly
	  unsubscribe from a channel, bridge or endpoint Subscriptions work
	  by a reference counting mechanism: if you subscript to an event
	  source X number of times, you must unsubscribe X number of times
	  to stop receiveing events for that event source. Review:
	  https://reviewboard.asterisk.org/r/2862 (issue ASTERISK-22451)
	  Reported by: Matt Jordan

2013-10-04 15:48 +0000 [r400510-400520]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip.c: Enclose the To URI and update its user portion
	  if a request user has been specified.

	* res/res_pjsip_session.c: Replace the connection address at the
	  SDP level if altering the SDP with the external media address.

2013-10-04 04:54 +0000 [r400508]  David M. Lee <dlee@digium.com>

	* rest-api/api-docs/playback.json, res/res_ari_playback.c:
	  Corrected response class for stopPlayback

2013-10-03 23:11 +0000 [r400471]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Don't ignore expires value in
	  contact header if it lacks semicolon (closes issue
	  ASTERISK-22574) Reported by: Filip Jenicek Patches:
	  chan_sip_expires.patch uploaded by Filip Jenicek (license 6277)
	  ........ Merged revisions 400469 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400470 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-03 21:40 +0000 [r400460]  Matthew Jordan <mjordan@digium.com>

	* main/channel_internal_api.c: Remove publication of a channel
	  snapshot when the technology is set This patch removes said
	  publication for a few reasons: (1) It is unnecessary. Association
	  of the channel technology with a specific channel is an
	  implementation detail that should be assumed to "just happen",
	  and consumers of Stasis don't need to be informed about it. (2)
	  Publication of said message can now cause crashes, as the actual
	  creation of a channel in normal locations now stages its
	  messages. As a result, things that create dummy channels (such as
	  the SIP RTP QOS unit test) and associate them with a channel
	  technology were now crashing, as the channel itself was not known
	  by Stasis.

2013-10-03 19:31 +0000 [r400442]  Joshua Colp <jcolp@digium.com>

	* main/cdr.c: When serializing CDR variables (like for "core show
	  channels") don't output an error if CDRs aren't enabled.

2013-10-03 19:29 +0000 [r400440]  Kinsey Moore <kmoore@digium.com>

	* /, main/security_events.c: Fix security events for AMI invalid
	  password In r337595, additional security events were added for
	  chan_sip authentication failures. The new IEs added to the
	  existing invalid password event were defined as required IEs, but
	  existing users of the event did not set the new IEs and could not
	  since they didn't apply to existing uses. They are now marked as
	  optional IEs. (closes issue ASTERISK-22578) Reported by: Matt
	  Jordan ........ Merged revisions 400421 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-03 19:11 +0000 [r400403]  Mark Michelson <mmichelson@digium.com>

	* include/asterisk/bridge_technology.h,
	  bridges/bridge_native_rtp.c: Fix assumption in
	  bridge_native_rtp.c regarding number of participants in a bridge.
	  When a party leaves a bridge, there may be more participants in
	  the bridge than expected. As such, it is important not to make
	  assumptions regarding the list of channels in a bridge. This
	  change makes it so that when a party leaves a native RTP bridge,
	  we unbridge it and the party it was bridged with. Previously, the
	  first and last channels in the list were unbridged since it was
	  assumed that these were the two channels that had been bridged.
	  As previously stated, a new party had been inserted into the
	  bridge, so this logic did not work properly. (closes issue
	  ASTERISK-22615) reported by Matt Jordan (closes issue
	  ASTERISK-22532) reported by Matt Jordan Review:
	  https://reviewboard.asterisk.org/r/2899

2013-10-03 19:05 +0000 [r400401]  Joshua Colp <jcolp@digium.com>

	* res/ari/resource_channels.c: Fix a crash caused by muting and
	  unmuting a channel in ARI without specifying a direction. (closes
	  issue ASTERISK-22637) Reported by: Scott Griepentrog Patch by
	  Matt Jordan, whose office I have taken over in the name of
	  Canada.

2013-10-03 18:44 +0000 [r400398]  Richard Mudgett <rmudgett@digium.com>

	* main/cel.c: cel: Some whitespace cleanups

2013-10-03 18:28 +0000 [r400384-400395]  Kinsey Moore <kmoore@digium.com>

	* res/res_rtp_multicast.c, /: res_rtp_multicast: Ensure SSRC is set
	  properly This fixes a bug where the SSRC field on multicast RTP
	  can be stuck at 0 which can cause problems for endpoints trying
	  to make sense of incoming streams. (closes issue ASTERISK-22567)
	  Reported by: Simone Camporeale Patches:
	  22567_res_mulitcast_ssrc.patch uploaded by Simone Camporeale
	  (License 6536) ........ Merged revisions 400393 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400394 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* configure, include/asterisk/autoconfig.h.in, configure.ac,
	  main/xml.c: Detect and use xsltCleanupGlobals when available This
	  introduces usage of an additional libxslt cleanup function,
	  xsltCleanupGlobals, when the configure script detects that it is
	  available. Early versions of the library did not include this
	  function. (closes issue ASTERISK-22570) Reported by: Corey
	  Farrell Patches: xsltCleanupGlobals.patch uploaded by Corey
	  Farrell (License 5909)

2013-10-03 17:55 +0000 [r400383]  Matthew Jordan <mjordan@digium.com>

	* contrib/ast-db-manage/config/env.py,
	  contrib/ast-db-manage/config/versions/4da0c5f79a9c_create_tables.py,
	  contrib/ast-db-manage/voicemail/env.py: Update Alembic database
	  scripts for external scripting and PostgreSQL, Oracle This patch
	  does the following: 1) The env scripts have been updated to be
	  tolerant of a NULL configuration file. This occurs when
	  configuration is provided by an external script, such that the
	  actual config.ini file is not used. 2) Enum types have all been
	  given names. This is needed for PostgreSQL script generation. 3)
	  The identifier meetme_confno_starttime_endtime is greater than 30
	  characters, and hence invalid for Oracle databases. This has been
	  truncated down to meetme_confno_start_end.

2013-10-03 16:22 +0000 [r400373]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_vpb.cc: chan_vpb: Make compile again.

2013-10-03 14:56 +0000 [r400362]  Mark Michelson <mmichelson@digium.com>

	* tests/test_cel.c: Get rid of uses of stasis_topic_wait()

2013-10-03 14:51 +0000 [r400360]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_sdp_rtp.c, res/res_pjsip_t38.c: Fix crashes in
	  res_pjsip_sdp_rtp and res_pjsip_t38 when a stream is rejected and
	  external_media_address is set. The callback function for changing
	  the media address in streams wrongly assumes that a connection
	  line will always be present. This is false as no line is present
	  if a stream has been rejected. (closes issue ASTERISK-22645)
	  Reported by: Rusty Newton

2013-10-02 22:34 +0000 [r400318-400356]  Mark Michelson <mmichelson@digium.com>

	* main/rtp_engine.c, addons/chan_ooh323.c,
	  channels/chan_multicast_rtp.c, main/ccss.c, apps/app_meetme.c,
	  bridges/bridge_holding.c, main/bridge_basic.c,
	  bridges/bridge_softmix.c, channels/chan_gtalk.c,
	  channels/chan_iax2.c, main/media_index.c, main/channel.c,
	  channels/chan_phone.c, channels/chan_dahdi.c, main/dial.c,
	  main/manager.c, pbx/pbx_spool.c, channels/chan_skinny.c,
	  main/format_cap.c, channels/chan_motif.c, res/res_agi.c,
	  channels/chan_alsa.c, apps/app_confbridge.c,
	  addons/chan_mobile.c, channels/chan_mgcp.c,
	  res/res_clioriginate.c, channels/chan_sip.c,
	  channels/chan_bridge_media.c, res/res_pjsip_sdp_rtp.c,
	  tests/test_format_api.c, bridges/bridge_simple.c,
	  apps/app_originate.c, res/parking/parking_applications.c,
	  main/core_local.c, channels/chan_console.c, channels/chan_oss.c,
	  include/asterisk/format_cap.h, res/res_pjsip_session.c,
	  res/ari/resource_bridges.c, channels/chan_jingle.c,
	  channels/chan_misdn.c, channels/dahdi/bridge_native_dahdi.c,
	  channels/chan_h323.c, main/file.c,
	  res/res_pjsip/pjsip_configuration.c, tests/test_config.c,
	  channels/chan_nbs.c, bridges/bridge_native_rtp.c,
	  res/res_stasis.c, channels/chan_pjsip.c, channels/chan_unistim.c:
	  Cache string values of formats on ast_format_cap() to save
	  processing. Channel snapshots have string representations of the
	  channel's native formats. Prior to this change, the format
	  strings were re-created on ever channel snapshot creation. Since
	  channel native formats rarely change, this was very wasteful.
	  Now, string representations of formats may optionally be stored
	  on the ast_format_cap for cases where string representations may
	  be requested frequently. When formats are altered, the string
	  cache is marked as invalid. When strings are requested, the cache
	  validity is checked. If the cache is valid, then the cached
	  strings are copied. If the cache is invalid, then the string
	  cache is rebuilt and copied, and the cache is marked as being
	  valid again. Review: https://reviewboard.asterisk.org/r/2879

	* /: Remove svn:mergeinfo property.

	* main/stasis_endpoints.c, main/stasis_wait.c (removed),
	  res/ari/resource_endpoints.c, /, include/asterisk/stasis.h,
	  tests/test_cel.c, include/asterisk/stasis_endpoints.h,
	  channels/chan_pjsip.c, main/stasis.c: Remove unnecessary waits
	  from stasis. Since caches are updated on publisher threads, there
	  is no need to wait for the cache updates to occur after a stasis
	  message is published. In the case of chan_pjsip device state
	  changes, this set of changes caused an improvement to
	  performance. Review: https://reviewboard.asterisk.org/r/2890

2013-10-02 21:32 +0000 [r400316]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_iax2.c: Cast Integer Argument To Unsigned Char
	  The member reg in the peercnt structure is an unsigned char and
	  peercnt_modify() is expecting an unsigned char argument which
	  gets assigned to peercnt->reg. This patch fixes that by casting
	  the integer argument being passed to peercnt_modify to unsigned
	  char. ........ Merged revisions 400314 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400315 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-02 21:25 +0000 [r400312]  Matthew Jordan <mjordan@digium.com>

	* main/cel.c, main/cdr.c, main/manager.c: Only create Stasis
	  subscriptions when enabled Subscribing to Stasis isn't free. As
	  such, this patch makes AMI, CDR, and CEL - the "big 3" - only
	  subscribe when enabled. Toggling their availability via a .conf
	  file will unsubscribe/subscribe as appropriate. Review:
	  https://reviewboard.asterisk.org/r/2888/

2013-10-02 20:30 +0000 [r400303]  Richard Mudgett <rmudgett@digium.com>

	* main/pbx.c: Originate: Make setting caller id on outgoing call
	  use either name or number. Previous code was requiring both name
	  and number to be available. Also restored a comment block on why
	  caller id is also set on an outgoing call leg in addition to
	  connected line from earlier versions of Asterisk.

2013-10-02 19:19 +0000 [r400291]  Kinsey Moore <kmoore@digium.com>

	* rest-api/api-docs/asterisk.json: Correct allowable values for ARI
	  general information filter

2013-10-02 18:57 +0000 [r400286]  Matthew Jordan <mjordan@digium.com>

	* main/cdr.c: Fix the CDR CLI command 'cdr show active {channel}'
	  When the switch from channel names to channel unique IDs
	  happened, the poor CLI command got left in the dust. This fixes
	  the command so that users can once again see how Asterisk is
	  messing up your billing information.

2013-10-02 18:42 +0000 [r400284]  Joshua Colp <jcolp@digium.com>

	* res/res_pjsip_t38.c: Fix a crash in res_pjsip_t38 caused by the
	  wrong assumption that a session will always have a channel. When
	  starting up or shutting down this assumption is false.

2013-10-02 18:25 +0000 [r400281]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* Makefile, doc/astdb2sqlite3.8 (added), /, doc/astdb2bdb.8
	  (added): man pages for astdb2bdb and astdb2sqlite3 Review:
	  https://reviewboard.asterisk.org/r/2898/ ........ Merged
	  revisions 400279 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-10-02 17:11 +0000 [r400268-400270]  Richard Mudgett <rmudgett@digium.com>

	* main/utils.c, apps/app_stack.c, res/stasis_recording/stored.c,
	  main/json.c, main/stasis_cache.c, res/res_ari.c: MALLOC_DEBUG:
	  Fix some misuses of free() when MALLOC_DEBUG is enabled. * There
	  were several places in ARI where an external library was
	  mallocing memory that must always be released with free(). When
	  MALLOC_DEBUG is enabled, free() is redirected to the MALLOC_DEBUG
	  version. Since the external library call still uses the normal
	  malloc(), MALLOC_DEBUG complains that the freed memory block is
	  not registered and will not free it. These cases must use
	  ast_std_free(). * Changed calls to asprintf() and vasprintf() to
	  the equivalent ast_asprintf() and ast_vasprintf() versions
	  respectively.

	* channels/sig_ss7.c: sig_ss7: Fix compiler warnings.

2013-10-02 16:20 +0000 [r400245-400265]  Joshua Colp <jcolp@digium.com>

	* channels/chan_jingle.c, main/channel.c, main/dial.c,
	  channels/chan_dahdi.c, include/asterisk/stasis_channels.h,
	  channels/chan_skinny.c, channels/chan_motif.c,
	  channels/chan_alsa.c, main/stasis_channels.c,
	  channels/chan_pjsip.c, channels/sig_ss7.c, channels/chan_mgcp.c,
	  channels/chan_unistim.c, apps/app_dial.c, main/pbx.c,
	  channels/chan_sip.c, main/bridge.c, include/asterisk/channel.h,
	  channels/chan_gtalk.c, channels/chan_console.c,
	  channels/sig_pri.c, channels/chan_iax2.c: Reduce channel snapshot
	  creation and publishing by up to 50%. This change introduces the
	  ability to stage channel snapshot creation and publishing by
	  suppressing the implicit creation and publishing that some
	  functions have. Once all operations are executed the staging is
	  marked as done and a single snapshot is created and published.
	  Review: https://reviewboard.asterisk.org/r/2889/

	* res/res_pjsip_session.c: Fix a random one way audio issue in
	  PJSIP. Due to the asynchronous design of the PJMEDIA SDP
	  negotiator it was possible for the SDP to be negotiated *after* a
	  channel was created and after it was being wait on by an
	  application. It is only after negotiation occurs that the file
	  descriptors for RTP are placed on the channel. Since the channel
	  was already being waited on these file descriptors were not
	  monitored, causing incoming media to never be read. This change
	  wakes up any application waiting on the channel so that added
	  file descriptors end up being monitored. (closes issue AST-1227)
	  Reported by: John Bigelow

	* res/stasis/control.c, include/asterisk/stasis_app.h,
	  res/ari/resource_channels.c: Allow specifying a channel to dial
	  an extension and context in an ARI dial operation. (issue
	  ASTERISK-22625) Reported by: Scott Griepentrog

	* res/res_pjsip_session.c: Retrieve and store the hostname only
	  once so multiple threads do not potentially initialize it at the
	  same time.

2013-10-01 21:17 +0000 [r400227-400236]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, channels/sig_analog.c: chan_dahdi: Fix
	  analog parking using flash-hook. Transferring an analog call
	  using a flash-hook to parking would fail to park the call and
	  result in an invalid ao2 object unref. * Park the correct bridged
	  channel.

	* main/features_config.c: Features: Rearm the parking config
	  options have moved warning for each reload.

2013-10-01 15:48 +0000 [r400217]  Matthew Jordan <mjordan@digium.com>

	* main/cdr.c: Filter out internal channels for bridge leave
	  messages and parked call messages Granted, if you manage to park
	  a Conference announcer channel, something has gone horrifically
	  wrong.

2013-09-30 21:31 +0000 [r400205]  Jonathan Rose <jrose@digium.com>

	* configs/res_parking.conf.sample, configs/features.conf.sample:
	  configuration samples: Pull all parking related stuff out of
	  features.conf This patch also adds documentation for parking from
	  features.conf to res_parking.conf

2013-09-30 19:57 +0000 [r400194-400196]  Matthew Jordan <mjordan@digium.com>

	* funcs/func_cdr.c: Parse arguments passed to the CDR_PROP function
	  correctly I can only blame this on a bad merge, because this in
	  no way worked properly the way it was written. Mea culpa. The
	  function should now parse its arguments correctly and function
	  properly. (Note that the API used by the CDR_PROP function has
	  working unit tests... this was merely bad coding of the actual
	  registered function) (closes issue ASTERISK-22613) Reported by:
	  Private Name

	* main/cdr.c: Remove spurious event raised when CDRs are reloaded
	  The Reload event is now raised by the module loading core. As
	  such, the Reload event in the CDR engine was a duplicate and not
	  needed.

2013-09-30 18:48 +0000 [r400178-400181]  David M. Lee <dlee@digium.com>

	* include/asterisk/stasis.h, main/devicestate.c, res/res_xmpp.c,
	  main/taskprocessor.c, main/sounds_index.c, main/endpoints.c,
	  channels/chan_iax2.c, res/res_jabber.c,
	  res/parking/parking_bridge_features.c, res/res_chan_stats.c,
	  main/cdr.c, main/manager_bridges.c, main/manager.c,
	  channels/chan_skinny.c, tests/test_devicestate.c,
	  res/res_pjsip_mwi.c, tests/test_taskprocessor.c,
	  tests/test_stasis.c, res/parking/parking_manager.c,
	  channels/chan_mgcp.c, res/res_security_log.c, main/pbx.c,
	  main/ccss.c, apps/app_meetme.c, include/asterisk/taskprocessor.h,
	  res/parking/parking_applications.c, channels/sig_pri.c,
	  apps/app_queue.c, main/cel.c, main/stasis.c,
	  channels/chan_dahdi.c, main/stasis_message_router.c,
	  funcs/func_presencestate.c, apps/confbridge/confbridge_manager.c,
	  res/res_agi.c, res/res_stasis_test.c, main/manager_channels.c,
	  main/manager_mwi.c, res/res_pjsip_refer.c, apps/app_voicemail.c,
	  main/stasis_cache.c, main/stasis_wait.c, res/stasis/app.c,
	  include/asterisk/stasis_internal.h, channels/chan_sip.c,
	  main/manager_endpoints.c: Remove dispatch object allocation from
	  Stasis publishing While looking for areas for performance
	  improvement, I realized that an unused feature in Stasis was
	  negatively impacting performance. When a message is sent to a
	  subscriber, a dispatch object is allocated for the dispatch,
	  containing the topic the message was published to, the subscriber
	  the message is being sent to, and the message itself. The topic
	  is actually unused by any subscriber in Asterisk today. And the
	  subscriber is associated with the taskprocessor the message is
	  being dispatched to. First, this patch removes the unused topic
	  parameter from Stasis subscription callbacks. Second, this patch
	  introduces the concept of taskprocessor local data, data that may
	  be set on a taskprocessor and provided along with the data
	  pointer when a task is pushed using the
	  ast_taskprocessor_push_local() call. This allows the task to have
	  both data specific to that taskprocessor, in addition to data
	  specific to that invocation. With those two changes, the dispatch
	  object can be removed completely, and the message is simply
	  refcounted and sent directly to the taskprocessor. Review:
	  https://reviewboard.asterisk.org/r/2884/

	* main/manager_system.c, tests/test_stasis.c,
	  main/manager_channels.c, main/manager_mwi.c,
	  main/stasis_cache_pattern.c, include/asterisk/vector.h (added),
	  res/stasis/app.c, main/channel_internal_api.c,
	  include/asterisk/stasis.h, apps/app_queue.c, main/cel.c,
	  main/stasis.c, tests/test_stasis_endpoints.c, main/cdr.c,
	  main/manager_bridges.c, main/manager.c: Optimize how Stasis
	  forwards are dispatched This patch optimizes how forwards are
	  dispatched in Stasis. Originally, forwards were dispatched as
	  subscriptions that are invoked on the publishing thread. This did
	  not account for the vast number of forwards we would end up
	  having in the system, and the amount of work it would take to
	  walk though the forward subscriptions. This patch modifies Stasis
	  so that rather than walking the tree of forwards on every
	  dispatch, when forwards and subscriptions are changed, the
	  subscriber list for every topic in the tree is changed. This has
	  a couple of benefits. First, this reduces the workload of
	  dispatching messages. It also reduces contention when dispatching
	  to different topics that happen to forward to the same
	  aggregation topic (as happens with all of the channel, bridge and
	  endpoint topics). Since forwards are no longer subscriptions, the
	  bulk of this patch is simply changing stasis_subscription objects
	  to stasis_forward objects (which, admittedly, I should have done
	  in the first place.) Since this required me to yet again put in a
	  growing array, I finally abstracted that out into a set of
	  ast_vector macros in asterisk/vector.h. Review:
	  https://reviewboard.asterisk.org/r/2883/

	* configure, include/asterisk/autoconfig.h.in,
	  configs/stasis.conf.sample (removed), include/asterisk/sem.h
	  (added), configure.ac, include/asterisk/stasis.h,
	  main/taskprocessor.c, main/sem.c (added), main/stasis.c,
	  main/stasis_config.c (removed), include/asterisk/taskprocessor.h:
	  Taskprocessor optimization; switch Stasis to use taskprocessors
	  This patch optimizes taskprocessor to use a semaphore for
	  signaling, which the OS can do a better job at managing
	  contention and waiting that we can with a mutex and condition.
	  The taskprocessor execution was also slightly optimized to reduce
	  the number of locks taken. The only observable difference in the
	  taskprocessor implementation is that when the final reference to
	  the taskprocessor goes away, it will execute all tasks to
	  completion instead of discarding the unexecuted tasks. For
	  systems where unnamed semaphores are not supported, a really
	  simple semaphore implementation is provided. (Which gives
	  identical performance as the original taskprocessor
	  implementation). The way we ended up implementing Stasis caused
	  the threadpool to be a burden instead of a boost to performance.
	  This was switched to just use taskprocessors directly for
	  subscriptions. Review: https://reviewboard.asterisk.org/r/2881/

2013-09-30 15:55 +0000 [r400141]  Kinsey Moore <kmoore@digium.com>

	* configs/pjsip.conf.sample, res/res_pjsip_outbound_registration.c,
	  configs/sip.conf.sample, CHANGES, /, channels/chan_sip.c:
	  chan_sip: Allow Asterisk to retry after 403 on register This adds
	  a global option in chan_sip to allow it to continue attempting
	  registration if a 403 is received, clearing the cached nonce and
	  treating it as a non-fatal response. Normally, this would cause
	  registration attempts to that endpoint to stop. This also adds a
	  similar per-outbound-registration option to chan_pjsip which
	  allows the retry interval to be altered for 403 responses to
	  REGISTER requests. (closes issue ASTERISK-17138) Review:
	  https://reviewboard.asterisk.org/r/2874/ Reported by: Rudi
	  ........ Merged revisions 400137 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400140 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-09-30 15:24 +0000 [r400138]  David M. Lee <dlee@digium.com>

	* main/astobj2.c, main/stasis.c, main/stasis_message_router.c,
	  main/taskprocessor.c, include/asterisk/stasis_message_router.h,
	  res/res_pjsip/include/res_pjsip_private.h, tests/test_stasis.c:
	  Stasis performance improvements This patch addresses several
	  performance problems that were found in the initial performance
	  testing of Asterisk 12. The Stasis dispatch object was allocated
	  as an AO2 object, even though it has a very confined lifecycle.
	  This was replaced with a straight ast_malloc(). The Stasis
	  message router was spending an inordinate amount of time
	  searching hash tables. In this case, most of our routers had 6 or
	  fewer routes in them to begin with. This was replaced with an
	  array that's searched linearly for the route. We more heavily
	  rely on AO2 objects in Asterisk 12, and the memset() in ao2_ref()
	  actually became noticeable on the profile. This was #ifdef'ed to
	  only run when AO2_DEBUG was enabled. After being misled by an
	  erroneous comment in taskprocessor.c during profiling, the wrong
	  comment was removed. Review:
	  https://reviewboard.asterisk.org/r/2873/

2013-09-28 22:56 +0000 [r400058-400121]  Matthew Jordan <mjordan@digium.com>

	* res/res_pjsip_notify.c, configs/pjsip_notify.conf.sample (added):
	  res_pjsip_notify: Add documentation We forgot to add
	  documentation for res_pjsip_notify, which would prevent it from
	  being loaded. Whoops. This patch also updates res_pjsip_notify to
	  use pjsip_notify.conf, which now has its own sample file in the
	  configs directory as well. Review:
	  https://reviewboard.asterisk.org/r/2835/

	* res/res_rtp_asterisk.c, /: res_rtp_asterisk: Correct erroneous
	  lost packet information in RTCP reports RTCP's calculation of the
	  number of lost packets in an RTP stream is based on that stream's
	  sequence number count, the number of received packets, and how
	  many packets we expect to receive. When the SSRC for an RTP
	  stream changes, there can - and almost always will be - a large
	  jump in the next packet's timestamp and sequence number. If we
	  don't reset the number of received packets, sequence number
	  count, and other metrics used by RTCP, the next RR/SR report will
	  use the previous SSRC's values to calculate the lost packet count
	  for the new SSRC - resulting in a very large number of lost
	  packets. This patch modifies res_rtp_asterisk such that, if it
	  detects a SSRC change, it will reset the various values used by
	  the RTCP calculations. From the perspective of RTCP, this appears
	  as a new media stream - which is what it is. Review:
	  https://reviewboard.asterisk.org/r/2886/ (closes issue AST-1174)
	  Reported by: Thomas Arimont ........ Merged revisions 400089 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400093 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* configure.ac, /, configure: Add check for openSUSE when detecting
	  bfd library In ASTERISK-17842, some additional library checks
	  were added to the configure script so that the bfd library could
	  be found on CentOS and Fedora systems. As it turns out, openSUSE
	  requires an additional library. This patch adds another check to
	  the configure script for openSUSE that will add that library.
	  Review: https://reviewboard.asterisk.org/r/2885/ (closes issue
	  AST-1169) Reported by: Guenther Kelleter ........ Merged
	  revisions 400073 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400075 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

	* main/cdr.c: CDR: Improve handling of parking; resolve assertion
	  when originating into park This patch covers two problems: 1)
	  Currently, when a call is transferred into a parking lot from a
	  bridge (using either the blind transfer or one touch parking
	  mechanisms), the application fails to be set to "Park" in the
	  resulting CDR record for the parked channel. This is due to the
	  ParkedCall message arriving before the BridgeEnter for the
	  channel entering the parking bridge. The ParkedCall message isn't
	  handled as the CDR for the channel has already been finalized
	  (due to the channel having left its two party bridge), and the
	  BridgeEnter - which creates the new CDR - doesn't have the
	  parking information. This patch modifies the behavior so that
	  reception of a ParkedCall message will - if not handled by a CDR
	  chain - cause a new CDR to be created and put into the Parking
	  state. 2) It fixes a FRACK that occurred when a channel is
	  originated into a parking space. The DialedPending state - which
	  occurs for both Dialed and Originated channels - assumed that it
	  couldn't handle the parking transitions due to it having a Party
	  B; however, Originated channels don't have a Party B. As such,
	  the existing CDR needs to transition into the parking state -
	  this patch does that. Review:
	  https://reviewboard.asterisk.org/r/2877/ (closes issue
	  ASTERISK-22482) Reported by: Richard Mudgett

	* apps/app_queue.c: app_queue: Make manager events tolerant of
	  Local channel shenanigans app_queue currently attempts to handle
	  Local channel optimizations in an effort to provide accurate
	  information in Stasis messages (and their corresponding AMI
	  events) as well as the Queue log. Sometimes, however, things
	  don't go as planned. Consider the following scenario: SIP/foo <->
	  L;1 <-> L;2 <-> SIP/agent SIP/agent answers, triggering a Local
	  channel optimization. app_queue will normally do the following: *
	  Listen for the Local optimization events and update our agent
	  accordingly to SIP/agent in the queue log and messages * When we
	  get a hangup, publish the AgentComplete event based on our
	  information (SIP/foo and SIP/agent) However, as with all things
	  that depend on sanity from something as capricious as Local
	  channels, things can go wrong: (1) SIP/agent immediately hangs up
	  upon answering. This triggers a race condition between
	  termination messages coming from SIP/agent and the ongoing Local
	  channel optimization messages. (Note that this can also occur
	  with SIP/foo) (2) In a race condition, Asterisk can (rarely)
	  deliver the hangup messages prior to the Local channel
	  optimization. In that case, the messages *may* arrive to
	  app_queue in the following order: * Hangup SIP/Agent * Hangup
	  SIP/foo * Optimize L;1/L;2 * Hangup L;2 * Hangup L;1 When
	  app_queue receives the hangup of the agent or the caller, it will
	  attempt to publish the AgentComplete event. However, it now has a
	  problem - it thinks its agent is the ;1 side of the Local
	  channel, as it never received the optimization event. At the same
	  time, that channel is already gone. This results in getting NULL
	  from the Stasis cache. What's more, we can't really wait for the
	  optimization message, as we are currently handling the hangup of
	  the channel that the optimization event would tell us to use.
	  This patch modifies the behavior in app_queue such that, since we
	  still have a lot of pertinent queue information (interface, queue
	  name, etc.), we now raise the event with what information we
	  know. The channels involved now may or may not be present. Users
	  will still at least get the "AgentComplete" event, which
	  "completes" the known Agent information. Review:
	  https://reviewboard.asterisk.org/r/2878/ (closes issue
	  ASTERISK-22507) Reported by: Richard Mudgett

	* main/manager.c: manager: Fix crash when appending a manager
	  channel variable In r399887, a minor performance improvement was
	  introduced by not allocating the manager variable struct if it
	  wasn't used. Unfortunately, when directly accessing an
	  ast_channel struct, manager assumed that the struct was always
	  allocated. Since this was no longer the case, things got a bit
	  crashy. This fixes that problem by simply bypassing appending
	  variables if the manager channel variable struct isn't there.

2013-09-27 21:56 +0000 [r400015-400020]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_cdr.c, res/res_parking.c: app_cdr and res_parking: Fix
	  some resource leaks. * app_cdr left the ResetCDR application
	  registered. * res_parking leaked a ref to config global. (closes
	  issue ASTERISK-22566) Reported by: Corey Farrell Patches:
	  ASTERISK-22566-r2.patch (license #5909) patch uploaded by Corey
	  Farrell

	* /, channels/chan_sip.c, channels/sip/reqresp_parser.c: chan_sip:
	  Increase some scratch buffer sizes dealing with caller id. *
	  Eliminated an unnecessary initialization in check_user_full().
	  (closes issue ASTERISK-22477) Reported by: Michael Shepelev
	  ........ Merged revisions 400013 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 400014 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-09-27 18:26 +0000 [r399990]  Kevin Harwell <kharwell@digium.com>

	* include/asterisk/res_pjsip.h, res/res_pjsip.exports.in,
	  res/res_pjsip.c, res/res_pjsip_session.c: res_pjsip: crash when
	  using localnet and external_signaling_address options There was a
	  collision of mod_data use on the transaction between using a nat
	  hook and an session response callback. During state change it was
	  assumed what was in the mod_data was nothing or the response
	  callback. However, it was possible for it to also contain a nat
	  hook thus resulting in a bad cast and a crash. Added the ability
	  to store multiple data elements in mod_data via a hash table. In
	  this instance, mod_data now stores a hash table of the two values
	  that can be retrieved using an associated string key. (closes
	  issue ASTERISK-22394) Reported by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/2843/

2013-09-27 17:34 +0000 [r399976]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c, channels/sip/include/sip.h: chan_sip:
	  Reject calls on 200 OKs if no SDP has been received When Asterisk
	  receives a 200 OK in response to an invite, that peer should have
	  sent an SDP at some point by then. If the channel has never
	  received an SDP, media won't have been set and the remote address
	  won't be known. Endpoints in general should not be doing this.
	  This patch makes it so that Asterisk will simply hang up a call
	  if it sends a 200 OK at this point. So far this odd behavior for
	  endpoints has only been observed in tests which involved manually
	  created SIP transactions in SIPp. (closes issue ASTERISK-22424)
	  Reported by: Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/2827/ ........ Merged
	  revisions 399939 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 399962 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-09-27 17:03 +0000 [r399937]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/astobj2.h, tests/test_astobj2.c, main/astobj2.c:
	  astobj2: Remove OBJ_CONTINUE support. OBJ_CONTINUE was a strange
	  feature that came into the world under suspicious circumstances
	  to support an abuse of the ao2_container by chan_iax2. Since
	  chan_iax2 no longer uses OBJ_CONTINUE, it is safe to remove it.
	  The simplified code should help performance slightly and make
	  understanding the code easier. Review:
	  https://reviewboard.asterisk.org/r/2887/

2013-09-27 14:29 +0000 [r399924]  Mark Michelson <mmichelson@digium.com>

	* bridges/bridge_native_rtp.c: Fix refleaks of ast_rtp_instance
	  structures. These refleaks were causing bridged calls not to
	  close their RTP ports. Thus a call would leave open 4 ports (RTP
	  for party A, RTCP for party A, RTP for party B, and RTCP for
	  party B). This led to an eventual depletion of available RTP
	  ports.

2013-09-27 14:01 +0000 [r399912]  Kinsey Moore <kmoore@digium.com>

	* include/asterisk/cel.h, tests/test_cel.c, main/cel.c: Restore
	  usefulness of the CEL Peer field This change makes the CEL peer
	  field useful again for BRIDGE_ENTER and BRIDGE_EXIT events and
	  fills the field with a comma-separated list of all channels in
	  the bridge other than the channel that is entering or exiting the
	  bridge. Review: https://reviewboard.asterisk.org/r/2840/ (closes
	  issue ASTERISK-22393)

2013-09-26 18:48 +0000 [r399897]  Kevin Harwell <kharwell@digium.com>

	* res/res_pjsip/security_events.c, res/res_pjsip_registrar.c,
	  include/asterisk/res_pjsip.h, res/res_pjsip.exports.in: pjsip:
	  race condition in registrar While handling a registration request
	  a race condition could occur if/when two+ clients registered at
	  the same time. This happened when one request obtained a copy of
	  the current contacts for an AOR and another request did the same
	  before the first request updated. Thus the second would update
	  and overwrite the first (or vice-versa depending on which
	  actually updated first). In the case of it being the same contact
	  two "add" events would be raised. pjsip registration handling is
	  now serialized to alleviate this issue. (closes issue AST-1213)
	  Reported by: John Bigelow Review:
	  https://reviewboard.asterisk.org/r/2860/

2013-09-26 15:41 +0000 [r399887]  David M. Lee <dlee@digium.com>

	* main/channel.c: Minor performance bump by not allocate manager
	  variable struct if we don't need it

2013-09-26 14:12 +0000 [r399874]  Rusty Newton <rnewton@digium.com>

	* apps/app_dial.c: Adding a few words to the Dial option 'r' help
	  text to clarify its tone argument description

2013-09-25 20:36 +0000 [r399842]  Richard Mudgett <rmudgett@digium.com>

	* channels/sig_ss7.c, channels/chan_dahdi.c, /: chan_dahdi: CLI
	  "core stop gracefully" has needless delay for PRI and SS7. The
	  PRI and SS7 link control threads are not stopped correctly when
	  the chan_dahdi.so module is unloaded. The link control threads
	  pri_dchannel() and ss7_linkset() are not awakened from a poll()
	  to cancel the thread. * Added a SIGURG signal after requesting
	  the thread cancel to break the link control thread poll()
	  immediately. For SS7 it was slightly worse, the link poll()
	  timeout would always be whatever was the last libss7 scheduled
	  event time used. If no libss7 scheduled event was pending, the
	  thread could run more often than necessary. * Set nextms to 60
	  seconds for the ss7_linkset() poll() if there is no other libss7
	  scheduled event. ........ Merged revisions 399818 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 399834 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-09-25 19:40 +0000 [r399798]  Rusty Newton <rnewton@digium.com>

	* res/res_pjsip.c: Broke the build - Fixing XML DTD violation added
	  in r399782, missing <para> tags inside a <note>

2013-09-25 19:28 +0000 [r399796]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: chan_sip: Fix Realtime Peer Update
	  Problem When Un-registering And Expires Header In 200ok 1st Issue
	  When a realtime peer sends an un-REGISTER request, Asterisk
	  un-registers the peer but the database table record still has
	  regseconds and fullcontact for the peer. This results in calls
	  attempting to be routed to the peer which is no longer
	  registered. The expected behavior is to get busy/congested when
	  attempting to call an un-registered peer through the dialplan.
	  What was discovered is that we are clearing out the peer's
	  registration in the database in parse_register_contact() when
	  calling expire_register() but then upon returning from
	  parse_register_contact(), update_peer() is run which stores back
	  in the database table regseconds and fullcontact. 2nd Issue The
	  reporter pointed out that the 200 ok being returned by Asterisk
	  after un-registering a peer contains a Contact header with
	  ;expires= and the Expires header is not set to 0. This is
	  actually a regression. Tests were created for this second issue
	  (ASTERISK-22548). The tests have been reviewed and a Ship It! was
	  received on those tests. This patch does the following: * Do not
	  ignore the Expires header value even when it is set to 0. The
	  patch sets the pvt->expiry earlier on in the function so that it
	  is set properly and used. * If pvt->expiry is 0, do not call
	  update_peer since that means the peer has already been
	  un-registered and there is no need to update the database record
	  again since nothing has changed. (closes issue ASTERISK-22428)
	  Reported by: Ben Smithurst Tested by: Ben Smithurst, Michael L.
	  Young Patches:
	  asterisk-22428-rt-peer-update-and-expires-header.diff by Michael
	  L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2869/ ........ Merged
	  revisions 399794 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 399795 from
	  http://svn.asterisk.org/svn/asterisk/branches/11

2013-09-25 18:36 +0000 [r399781]  Rusty Newton <rnewton@digium.com>

	* res/res_pjsip.c: Fixing documentation for the configOption
	  "external_media_address" of both Endpoints and Transports
	  Re-using some of Mark Michelson's text from an E-mail discussion
	  for: * Modifying synopsis for both options * Adding description
	  to both options * Changing name of "external_media_address" for
	  Endpoint configuration to "media_address" in anticipation of the
	  option name being changed. (As it is not really specific to
	  external destinations) (issue ASTERISK-22405) (closes issue
	  ASTERISK-22405) Reported by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/2850/

2013-09-24 22:50 +0000 [r399736-399749]  Richard Mudgett <rmudgett@digium.com>

	* main/astobj2.c: astobj2: Made use OBJ_SEARCH_xxx identifiers as
	  field enum values internally. * Made ao2_unlink to protect itself
	  from stray OBJ_SEARCH_xxx values passed in.

	* channels/chan_iax2.c, /: chan_iax2: Prevent some needless
	  breaking of the native IAX2 bridge. * Clean up some twisted code
	  in the iax2_bridge() loop. * Add AST_CONTROL_VIDUPDATE and
	  AST_CONTROL_SRCCHANGE to a list of frames to prevent the native
	  bridge loop from breaking. * Passing the
	  AST_CONTROL_T38_PARAMETERS frame should also allow FAX over a
	  native IAX2 bridge. (issue ABE-2912) Review:
	  https://reviewboard.asterisk.org/r/2870/ ........ Merged
	  revisions 399697 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 399708 from
	  http://svn.asterisk.org/svn/asterisk/branches/11 For v12 and
	  above this is really just documentation until IAX2 native
	  bridging is restored.

2013-09-24 19:22 +0000 [r399666-399695]  Matthew Jordan <mjordan@digium.com>

	* apps/app_queue.c: app_queue: Don't be quite so aggressive in
	  initializing the array We only need the first character.

	* apps/app_queue.c: app_queue: Initialize array holding MixMonitor
	  exec options If the channel variable MONITOR_EXEC is set,
	  app_queue will pass the specified execution parameters to the
	  MixMonitor application when a queue is recorded. If that channel
	  variable is not set, the buffer that holds the escaped value was
	  not being initialized to NULL, and so would be passed to the
	  MixMonitor application with garbage. Hilarity ensued as
	  app_mixmonitor attempted to execute gobeldy-gook.

	* main/cdr.c, main/stasis_bridges.c, tests/test_cdr.c: Fix a
	  performance problem CDRs There is a large performance price
	  currently in the CDR engine. We currently perform two
	  ao2_callback calls on a container that has an entry for every
	  channel in the system. This is done to create matching pairs
	  between channels in a bridge. As such, the portion of the CDR
	  logic that this patch deals with is how we make pairings when a
	  channel enters a mixing bridge. In general, when a channel enters
	  such a bridge, we need to do two things: (1) Figure out if anyone
	  in the bridge can be this channel's Party B. (2) Make pairings
	  with every other channel in the bridge that is not already our
	  Party B. This is a two step process. In the first step, we look
	  through everyone in the bridge and see if they can be our Party B
	  (single_state_process_bridge_enter). If they can - yay! We mark
	  our CDR as having gotten a Party B. If not, we keep searching. If
	  we don't find one, we wait until someone joins who can be our
	  Party B. Step 2 is where we changed the logic
	  (handle_bridge_pairings and bridge_candidate_process).
	  Previously, we would first find candidates - those channels in
	  the bridge with us - from the active_cdrs_by_channel container.
	  Because a channel could be a candidate if it was Party B to an
	  item in the container, the code implemented multiple
	  ao2_container callbacks to get all the candidates. We also had to
	  store them in another container with some other meta information.
	  This was rather complex and costly, particularly if you have 300
	  Local channels (600 channels!) going at once. Luckily, none of it
	  is needed: when a channel enters a bridge (which is when we're
	  figuring all this stuff out), the bridge snapshot tells us the
	  unique IDs of everyone already in the bridge. All we need to do
	  is: For all channels in the bridge: If the channel is us or our
	  Party B that we got in step 1, skip it Compare us and the
	  candidate to figure out who is Party A (based on some specific
	  rules) If we are Party A: Make a new CDR for us, append it to our
	  chain, and set the candidate as Party B If they are Party A: If
	  they don't have a Party B: Make a new CDR for them, append us to
	  their chain, and us as Party B Otherwise: Copy us over as Party B
	  on their existing CDR. This patch does that. Because we now use
	  channel unique IDs to find the candidates during bridging,
	  active_cdrs_by_channel now looks up things using uniqueid instead
	  of channel name. This makes the more complex code simpler; it
	  does, however, have the drawback that dialplan applications and
	  functions will be slightly slower as they have to iterate through
